/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.autoqualitycontrol;

import java.awt.Component;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.DefaultFormatter;

/**
 *
 * @author nunopbarros
 */
public class PopupLabelling extends javax.swing.JFrame implements KeyListener, LabellingPopupInterface {

    File currentFile;
    String activeFile = "";
    LabellingListener listener;
    String currentID;
    HashMap<String, String> unsavedLabels = new HashMap<>();
    HashMap<String, ArrayList<Double>> features;
    Long start;

    /**
     * Creates new form PopupLabelling
     */
    public PopupLabelling(final LabellingListener listener, HashMap<String, ArrayList<Double>> features, String ID, int total, File currentFolder) {
        initComponents();
        this.features = features;
        currentFile = currentFolder;
        currentID = ID;
        this.listener = listener;
        this.setLabelsSize(total);
        if (total == 1) {
            this.jButtonOK.setText("OK & Save");
        }
        this.setVisible(true);
        this.addKeyListener(this);
        ((DefaultFormatter) jFormattedTextFieldLabel.getFormatter()).setCommitsOnValidEdit(true);
        jFormattedTextFieldLabel.setValue(0);
        this.setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
        final Component comp = this;
        WindowListener exitListener = new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                int confirm = JOptionPane.showOptionDialog(comp, "Close the Labelling Assistant?", "Exit Confirmation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                if (confirm == 0) {
                    listener.finish();
                    dispose();
                }
            }
        };
        this.addWindowListener(exitListener);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jFormattedTextFieldLabel = new javax.swing.JFormattedTextField();
        jTextFieldFile = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jButtonSetFile = new javax.swing.JButton();
        jButtonOK = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldCoord = new javax.swing.JTextField();
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabelProgress = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("SpectrIm - Labelling Assistant");
        setAlwaysOnTop(true);

        jLabel1.setText("Label:");

        jFormattedTextFieldLabel.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat(""))));
        jFormattedTextFieldLabel.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                jFormattedTextFieldLabelInputMethodTextChanged(evt);
            }
        });
        jFormattedTextFieldLabel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jFormattedTextFieldLabelKeyPressed(evt);
            }
        });

        jTextFieldFile.setEditable(false);

        jLabel2.setText("File:");

        jButtonSetFile.setText("Set File");
        jButtonSetFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSetFileActionPerformed(evt);
            }
        });

        jButtonOK.setText("OK");
        jButtonOK.setEnabled(false);
        jButtonOK.setSelected(true);
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jLabel3.setText("Please, enter label for voxel:");

        jTextFieldCoord.setEditable(false);
        jTextFieldCoord.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCoord.setText("0 0 0");

        jLabelProgress.setText("0/0 voxels labelled");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 270, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelProgress, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldFile))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(38, 38, 38)
                        .addComponent(jTextFieldCoord))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(31, 31, 31)
                                .addComponent(jFormattedTextFieldLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addGap(86, 86, 86)
                                .addComponent(jButtonSetFile)))
                        .addGap(77, 77, 77)
                        .addComponent(jButtonOK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldCoord, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelProgress))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonOK)
                    .addComponent(jFormattedTextFieldLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addComponent(jButtonSetFile))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonSetFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSetFileActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Set file");
        fileChooser.setSelectedFile(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Labelling Sessions", "lbls");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = selected_file;
                this.listener.saveFileLocation(currentFile);
                if (selected_file != null) {
                    this.activeFile = selected_file.toString();
                    if (!activeFile.endsWith(".lbls")) {
                        this.activeFile += ".lbls";
                    }
                    this.jTextFieldFile.setText(activeFile);
                    this.jButtonOK.setEnabled(true);
                    start = System.currentTimeMillis();
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonSetFileActionPerformed

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        OKPressed();
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void OKPressed() {
        ArrayList<Double> feats;
        feats = features.get(this.jTextFieldCoord.getText());
        String featsString = Double.toString(feats.get(0));
        for (int i = 1; i < feats.size(); i++) {
            featsString = featsString + "\t" + Double.toString(feats.get(i));
        }
        unsavedLabels.put(currentID + "\\" + this.jTextFieldCoord.getText(), this.jFormattedTextFieldLabel.getText() + "\t" + featsString);

        this.jProgressBar1.setValue(jProgressBar1.getValue() + 1);
        this.jLabelProgress.setText(jProgressBar1.getValue() + "/" + jProgressBar1.getMaximum() + " voxels labelled");
        this.jButtonOK.setEnabled(false);
        if (jProgressBar1.getValue() < jProgressBar1.getMaximum()) {
            this.listener.nextLabel();
            if (jProgressBar1.getValue() == (jProgressBar1.getMaximum() - 1)) {
                this.jButtonOK.setText("OK & Save");
            }
        } else {
            save2File();
            listener.finish();
            dispose();
        }
    }

    private void jFormattedTextFieldLabelKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jFormattedTextFieldLabelKeyPressed
        int value = Integer.valueOf(jFormattedTextFieldLabel.getValue().toString());
        switch (evt.getKeyCode()) {
            case KeyEvent.VK_ENTER:
                if (this.jButtonOK.isEnabled()) {
                    OKPressed();
                }
                break;
            case KeyEvent.VK_UP:
                value++;
                if (value > 1) {
                    value = 1;
                    Toolkit.getDefaultToolkit().beep();
                } else if (value < 0) {
                    value = 0;
                    Toolkit.getDefaultToolkit().beep();
                }
                this.jFormattedTextFieldLabel.setValue(value);
                break;
            case KeyEvent.VK_DOWN:
                value--;
                if (value > 1) {
                    value = 1;
                    Toolkit.getDefaultToolkit().beep();
                } else if (value < 0) {
                    value = 0;
                    Toolkit.getDefaultToolkit().beep();
                }
                this.jFormattedTextFieldLabel.setValue(value);
                break;
        }
    }//GEN-LAST:event_jFormattedTextFieldLabelKeyPressed

    private void jFormattedTextFieldLabelInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_jFormattedTextFieldLabelInputMethodTextChanged
    }//GEN-LAST:event_jFormattedTextFieldLabelInputMethodTextChanged

    public void save2File() {
        try {
            BufferedWriter output = new BufferedWriter(new FileWriter(activeFile, true));
            Iterator<String> iter = unsavedLabels.keySet().iterator();
            Long endTime = System.currentTimeMillis();
            while (iter.hasNext()) {
                String id = iter.next();
                output.append(start + "\\" + endTime + "\\" + id + "\t" + unsavedLabels.get(id));
                output.newLine();
            }
            output.close();
//            CHECK FOR REPEATED ENTRIES LATER
        } catch (IOException ex) {
            Logger.getLogger(PopupLabelling.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void setLabelsSize(int total) {
        this.jProgressBar1.setMaximum(total);
        this.jProgressBar1.setValue(0);
        this.jLabelProgress.setText(0 + "/" + total + "voxels labelled");
    }

    @Override
    public void askLabel(String coord) {
        this.setVisible(true);
        this.jTextFieldCoord.setText(coord);
        if (!this.activeFile.isEmpty()) {
            this.jButtonOK.setEnabled(true);
        }
    }
    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>
//
//        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new PopupLabelling().setVisible(true);
//            }
//        });
//    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOK;
    private javax.swing.JButton jButtonSetFile;
    private javax.swing.JFormattedTextField jFormattedTextFieldLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelProgress;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JTextField jTextFieldCoord;
    private javax.swing.JTextField jTextFieldFile;
    // End of variables declaration//GEN-END:variables

    @Override
    public void keyTyped(KeyEvent ke) {
    }

    @Override
    public void keyPressed(KeyEvent ke) {
        if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
            OKPressed();
        }
    }

    @Override
    public void keyReleased(KeyEvent ke) {
    }

    @Override
    public void initialization() {
        if (currentFile != null) {
            this.activeFile = currentFile.toString();
            if (!activeFile.endsWith(".lbls")) {
                this.activeFile += ".lbls";
            }
            this.jTextFieldFile.setText(activeFile);
            this.jButtonOK.setEnabled(true);
            start = System.currentTimeMillis();
        }
    }

    @Override
    public void setLocationRelTo(Component comp) {
        this.setLocationRelativeTo(comp);
    }
}
