/*
 * File: $Id: DicomHeaderViewer.java,v 1.1.1.1 2006/04/19 09:38:47 hans Exp $
 * History
 * Date: 17. Dezember 2002, 09:37     Authors: Hans Slotboom
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
 
package org.spectrim.dicom;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;

import java.awt.Point;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * This class displays the a large number of MRI related Dicom tags (not all) 
 * but the most relevant. 
 * @author  hans
 */
public class DicomHeaderViewer extends JFrame implements ActionListener
{
    
    /** 
     * Creates a new instance of DicomHeaderViewer. 
     * @param parent
     * @param dcmInfo
     */
    public DicomHeaderViewer( JFrame parent, FileInfo dcmInfo )
    {        
        
        m_displayPanel = new JPanel( );
        m_displayPanel.setLayout( new BoxLayout( m_displayPanel , BoxLayout.X_AXIS ) );
        m_infoLabel = new JLabel( dcmInfo.getDicomFileInfoAsHTML( ) );
        m_displayPanel.add( m_infoLabel );
        m_displayPanel.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );
        m_mainScrollPane = new JScrollPane( m_displayPanel,
                                            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                                            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS );
        // define the button panel
        JPanel m_buttonPanel = new JPanel( );
        m_okButton = new JButton( "OK" );
        m_okButton.addActionListener( this );
        m_buttonPanel.add( m_okButton );
        
        m_collectionPanel = new JPanel( );
        m_collectionPanel.setLayout( new BoxLayout( m_collectionPanel, BoxLayout.Y_AXIS ) );
        // add the two subpanels to the collection panel
        m_collectionPanel.add( m_mainScrollPane );
        m_collectionPanel.add( m_buttonPanel );
        
        m_collectionPanel.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );
        setContentPane( m_collectionPanel );
        this.setTitle( "Dicom header information" ); 
        // Put the Dialog nicely in the middle of its parent
        Point parentLoc = parent.getLocation( );
        Point centerParent = new Point( parent.getX( ) + parent.getWidth( ) / 2,
                                        parent.getY( ) + parent.getHeight( ) / 2 );
        pack( );
        setVisible( true );
    }
    
    /**
     * Handles action events eg pressing a button etc.
     * @param actionEvent
     */
    @Override
    public void actionPerformed( ActionEvent actionEvent ) 
    {
       Object sender = actionEvent.getSource( );
        
	if ( sender == m_okButton ) 
        {
            setVisible( false );
            this.dispose( );
        }
    }
    
    // Attributes for the displayer
    JPanel          m_collectionPanel;
    JPanel          m_displayPanel;
    JScrollPane     m_mainScrollPane;
    JLabel          m_infoLabel;
    JPanel          m_buttonPanel;
    JButton         m_okButton;
    
    // For proper serialization
    private static final long serialVersionUID = 1487225898889393L;
}
