/*
 * File: $Id: DicomNetworkNodeDefinerAndSelectionPanel.java,v 1.6 2009/15/05 13:28:39 hans Exp $
 * History
 * Date: 15.05.2009  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2009 by
 *
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

/*
 * DicomNetworkNodeDefinerAndSelectionPanel.java
 *
 * Created on 15-May-2009, 13:09:51
 */

package org.spectrim.dicom;

import org.spectrim.lib.Dialogs;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author slotboom
 */
public class DicomNetworkNodeDefinerAndSelectionPanel extends javax.swing.JPanel implements ListSelectionListener, ActionListener
{

    /** 
     * Creates new form DicomNetworkNodeDefinerAndSelectionPanel
     */
    public DicomNetworkNodeDefinerAndSelectionPanel( DicomNetworkNodeDefinerAndSelectionFrame frame )
    {
        m_parentFrame = frame;
        initComponents( );
        initializeTableModel( );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        m_selectedRemoteHostDicomIPaddressTextBox = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        m_selectedRemoteHostDicomPortNumbertextBox = new javax.swing.JTextField();
        m_selectedRemoteHostDicomAETitleTextbox = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        m_updateTableButton = new javax.swing.JButton();
        m_nodeNameLabel = new javax.swing.JLabel();
        m_selectedRemoteHostDicomNodeNameTextBox = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        m_dicomNodeTable = new javax.swing.JTable();
        m_OKButton = new javax.swing.JButton();
        m_localHostPanel = new javax.swing.JPanel();
        m_localHostDICOMNameTextField = new javax.swing.JTextField();
        m_nodeNameLabel1 = new javax.swing.JLabel();
        m_localHostIPAddressTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        m_localHostPortNumberReceiveTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        m_localHostPortNumberTransmitTextField = new javax.swing.JTextField();
        m_localHostTransmitAETitleTextField = new javax.swing.JTextField();
        m_localHostAETitleReceiveTextField = new javax.swing.JTextField();
        m_localhostUpdateData = new javax.swing.JButton();
        m_aboutButton = new javax.swing.JButton();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Dicom node properties"));

        jLabel1.setText("IP-address");

        jLabel2.setText("Dicom port number");

        jLabel3.setText("AE-title");

        m_updateTableButton.setText("Update node properties");
        m_updateTableButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_updateTableButtonActionPerformed(evt);
            }
        });

        m_nodeNameLabel.setText("Dicom node name");

        m_dicomNodeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Node name", "IP-address", "Dicom port number", "AE-title"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(m_dicomNodeTable);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel1)
                    .addComponent(m_nodeNameLabel)
                    .addComponent(jLabel2))
                .addGap(66, 66, 66)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_selectedRemoteHostDicomAETitleTextbox, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE)
                    .addComponent(m_selectedRemoteHostDicomNodeNameTextBox, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE)
                    .addComponent(m_selectedRemoteHostDicomIPaddressTextBox, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE)
                    .addComponent(m_selectedRemoteHostDicomPortNumbertextBox, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE))
                .addGap(215, 215, 215))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 1053, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(850, Short.MAX_VALUE)
                .addComponent(m_updateTableButton, javax.swing.GroupLayout.PREFERRED_SIZE, 191, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 27, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_selectedRemoteHostDicomNodeNameTextBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_nodeNameLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_selectedRemoteHostDicomIPaddressTextBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_selectedRemoteHostDicomPortNumbertextBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(m_selectedRemoteHostDicomAETitleTextbox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addComponent(m_updateTableButton)
                .addContainerGap())
        );

        m_OKButton.setText("OK");
        m_OKButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_OKButtonActionPerformed(evt);
            }
        });

        m_localHostPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("DICOM properties of local host"));

        m_nodeNameLabel1.setText("Dicom node name");

        jLabel4.setText("IP-address");

        jLabel5.setText("Dicom port number (receive)");

        jLabel6.setText("AE-title (send)");

        jLabel7.setText("AE-title (receive)");

        jLabel8.setText("Dicom port number (transmit)");

        m_localhostUpdateData.setText("Update localhost properties");
        m_localhostUpdateData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_localhostUpdateDataActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_localHostPanelLayout = new javax.swing.GroupLayout(m_localHostPanel);
        m_localHostPanel.setLayout(m_localHostPanelLayout);
        m_localHostPanelLayout.setHorizontalGroup(
            m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_localHostPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jLabel5)
                        .addComponent(m_nodeNameLabel1)
                        .addComponent(jLabel4)
                        .addComponent(jLabel8, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_localHostPanelLayout.createSequentialGroup()
                        .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, m_localHostPanelLayout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(m_localHostIPAddressTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 584, Short.MAX_VALUE)
                                    .addComponent(m_localHostDICOMNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 584, Short.MAX_VALUE)
                                    .addComponent(m_localHostPortNumberReceiveTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 584, Short.MAX_VALUE)))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, m_localHostPanelLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(m_localHostPortNumberTransmitTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 582, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, m_localHostPanelLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(m_localHostTransmitAETitleTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 582, Short.MAX_VALUE)
                                    .addComponent(m_localHostAETitleReceiveTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 582, Short.MAX_VALUE))))
                        .addGap(212, 212, 212))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, m_localHostPanelLayout.createSequentialGroup()
                        .addGap(567, 567, 567)
                        .addComponent(m_localhostUpdateData)
                        .addContainerGap())))
        );
        m_localHostPanelLayout.setVerticalGroup(
            m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_localHostPanelLayout.createSequentialGroup()
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_nodeNameLabel1)
                    .addComponent(m_localHostDICOMNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_localHostIPAddressTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(m_localHostPortNumberReceiveTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(m_localHostPortNumberTransmitTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_localHostAETitleReceiveTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(m_localHostPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_localHostTransmitAETitleTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_localhostUpdateData)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_aboutButton.setText("About");
        m_aboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_aboutButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(m_localHostPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(33, 33, 33)
                .addComponent(m_OKButton, javax.swing.GroupLayout.PREFERRED_SIZE, 462, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 66, Short.MAX_VALUE)
                .addComponent(m_aboutButton, javax.swing.GroupLayout.PREFERRED_SIZE, 483, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(21, 21, 21))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_localHostPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_aboutButton)
                    .addComponent(m_OKButton))
                .addGap(20, 20, 20))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void m_updateTableButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_updateTableButtonActionPerformed

        try
        {

            if ( m_dicomNodeTable.getSelectedRow( ) == 0 )
            {
                m_dicomNode0.setNodeName( m_selectedRemoteHostDicomNodeNameTextBox.getText( ) );
                m_dicomNode0.setReceiveAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode0.setTransmitAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode0.setIPaddressNr( m_selectedRemoteHostDicomIPaddressTextBox.getText( ) );
                m_dicomNode0.setDicomReceivePortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
                m_dicomNode0.setDicomTransmitPortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
            }


            if ( m_dicomNodeTable.getSelectedRow( ) == 1 )
            {
                m_dicomNode1.setNodeName( m_selectedRemoteHostDicomNodeNameTextBox.getText( ) );
                m_dicomNode1.setReceiveAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode1.setTransmitAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode1.setIPaddressNr( m_selectedRemoteHostDicomIPaddressTextBox.getText( ) );
                m_dicomNode1.setDicomReceivePortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
                m_dicomNode1.setDicomTransmitPortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
            }

            if ( m_dicomNodeTable.getSelectedRow( ) == 2 )
            {
                m_dicomNode2.setNodeName( m_selectedRemoteHostDicomNodeNameTextBox.getText( ) );
                m_dicomNode2.setReceiveAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode2.setTransmitAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode2.setIPaddressNr( m_selectedRemoteHostDicomIPaddressTextBox.getText( ) );
                m_dicomNode2.setDicomReceivePortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
                m_dicomNode2.setDicomTransmitPortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
            }

            if ( m_dicomNodeTable.getSelectedRow( ) == 3 )
            {
                m_dicomNode3.setNodeName( m_selectedRemoteHostDicomNodeNameTextBox.getText( ) );
                m_dicomNode3.setReceiveAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode3.setTransmitAEtitle( m_selectedRemoteHostDicomAETitleTextbox.getText( ) );
                m_dicomNode3.setIPaddressNr( m_selectedRemoteHostDicomIPaddressTextBox.getText( ) );
                m_dicomNode3.setDicomReceivePortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
                m_dicomNode3.setDicomTransmitPortNumber( new Integer( m_selectedRemoteHostDicomPortNumbertextBox.getText( ) ).intValue( ) );
            }

            setTableValuesAccordingtoSettings( );
        }
        catch ( NumberFormatException nfe )
        {
            System.out.println( "Number format exception occurred" );
            Dialogs.messageBox( (JFrame)m_parentFrame, "Port number must be an integer", "Number format exception occurred" );
        }
}//GEN-LAST:event_m_updateTableButtonActionPerformed

    private void m_OKButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_OKButtonActionPerformed

        
        DicomNetworkNodeDefaults dicomNetworkDefs = DicomNetworkNodeDefaults.getInstance( );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.SELECTED_REMOTE_DICOM_HOST_NUMBER, "" + m_dicomNodeTable.getSelectedRow( ) );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_NAME , m_localHostDICOMNameTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_IP_ADDRESS , m_localHostIPAddressTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_PORT , m_localHostPortNumberReceiveTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_PORT , m_localHostPortNumberTransmitTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_AETITLE , m_localHostAETitleReceiveTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_AETITLE , m_localHostTransmitAETitleTextField.getText( ) );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_NAME , (String)m_dicomNodeTable.getValueAt( 0, 0 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_IP_ADDRESS , (String)m_dicomNodeTable.getValueAt( 0, 1 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_RECEIVE_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 0, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_TRANSMIT_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 0, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_TRANSMIT_AETITLE , (String)m_dicomNodeTable.getValueAt( 0, 3 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_RECEIVE_AETITLE , (String)m_dicomNodeTable.getValueAt( 0, 3 ) );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_NAME , (String)m_dicomNodeTable.getValueAt( 1, 0 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_IP_ADDRESS , (String)m_dicomNodeTable.getValueAt( 1, 1 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_RECEIVE_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 1, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_TRANSMIT_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 1, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_TRANSMIT_AETITLE , (String)m_dicomNodeTable.getValueAt( 1, 3 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_RECEIVE_AETITLE , (String)m_dicomNodeTable.getValueAt( 1, 3 ) );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_NAME , (String)m_dicomNodeTable.getValueAt( 2, 0 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_IP_ADDRESS , (String)m_dicomNodeTable.getValueAt( 2, 1 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_RECEIVE_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 2, 2) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_TRANSMIT_PORT , "" + ( (Integer)m_dicomNodeTable.getValueAt( 2, 2) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_RECEIVE_AETITLE , (String)m_dicomNodeTable.getValueAt( 2, 3 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_TRANSMIT_AETITLE , (String)m_dicomNodeTable.getValueAt( 2, 3 ) );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_NAME , (String)m_dicomNodeTable.getValueAt( 3, 0 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_IP_ADDRESS , (String)m_dicomNodeTable.getValueAt( 3, 1 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_RECEIVE_PORT , "" + ((Integer)m_dicomNodeTable.getValueAt( 3, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_TRANSMIT_PORT , "" + ((Integer)m_dicomNodeTable.getValueAt( 3, 2 ) ).intValue( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_TRANSMIT_AETITLE , (String)m_dicomNodeTable.getValueAt( 3, 3 ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_RECEIVE_AETITLE , (String)m_dicomNodeTable.getValueAt( 3, 3 ) );

        // permanent storage..
        dicomNetworkDefs.save( );

        notifyActionListeners( OK_BUTTON_PRESSED );

        // dispose the frame in wich this is shown
        m_parentFrame.quitAndDispose( );

    }//GEN-LAST:event_m_OKButtonActionPerformed
    /**
     * Button was pressed: according actions below
     * @param evt
     */
    private void m_localhostUpdateDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_localhostUpdateDataActionPerformed

        DicomNetworkNodeDefaults dicomNetworkDefs = DicomNetworkNodeDefaults.getInstance( );

        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_NAME, m_localHostDICOMNameTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_IP_ADDRESS, m_localHostIPAddressTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_PORT, m_localHostPortNumberReceiveTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_PORT, m_localHostPortNumberReceiveTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_AETITLE, m_localHostTransmitAETitleTextField.getText( ) );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_AETITLE, m_localHostAETitleReceiveTextField.getText( ) );

    }//GEN-LAST:event_m_localhostUpdateDataActionPerformed

    private void m_aboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_aboutButtonActionPerformed
        DicomNetworkNodeDefinerInfomationPanel dicomNetworkNodeDefinerInfomationPanel = new DicomNetworkNodeDefinerInfomationPanel( m_parentFrame );
    }//GEN-LAST:event_m_aboutButtonActionPerformed

    /**
     * Sets the values according to the current dicom nodes
     */
    private void setTableValuesAccordingtoSettings( )
    {

        // set the values of the remote hosts in the table

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getNodeName( ), 0, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getIPaddressr( ), 0, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getDicomReceivePortNumber( ), 0, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getReceiveAEtitle( ), 0, 3 );

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getNodeName( ), 1, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getIPaddressr( ), 1, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getDicomReceivePortNumber( ), 1, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getReceiveAEtitle( ), 1, 3 );

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getNodeName( ), 2, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getIPaddressr( ), 2, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getDicomReceivePortNumber( ), 2, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getReceiveAEtitle( ), 2, 3 );

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getNodeName( ), 3, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getIPaddressr( ), 3, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getDicomReceivePortNumber( ), 3, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getReceiveAEtitle( ), 3, 3 );

        // set the values of the local host in the textfields

        m_localHostDICOMNameTextField.setText( m_localHost.getNodeName( ) );
        m_localHostIPAddressTextField.setText( m_localHost.getIPaddressr( ) );
        m_localHostPortNumberReceiveTextField.setText( "" + m_localHost.getDicomReceivePortNumber( ) );
        m_localHostTransmitAETitleTextField.setText( "" + m_localHost.getDicomTransmitPortNumber( ) );
        m_localHostAETitleReceiveTextField.setText( m_localHost.getReceiveAEtitle( ) );
        m_localHostTransmitAETitleTextField.setText( m_localHost.getTransmitAEtitle( ) );

    }


    /**
     * Initialize the JTable containing the Dicom Node Information
     */
    public void initializeTableModel( )
    {
        DicomNetworkNodeDefaults def = DicomNetworkNodeDefaults.getInstance( );
        
        m_localHost = new DicomNetworkNode( );

        m_dicomNode0 = new DicomNetworkNode( );
        m_dicomNode1 = new DicomNetworkNode( );
        m_dicomNode2 = new DicomNetworkNode( );
        m_dicomNode3 = new DicomNetworkNode( );
       
        m_selectedRemoteDicomHost = ( new Integer( def.getProperty( DicomNetworkNodeDefaults.SELECTED_REMOTE_DICOM_HOST_NUMBER ) ) ).intValue( );

        m_localHostDICOMNameTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_NAME ) );
        m_localHostIPAddressTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_IP_ADDRESS ) );
        m_localHostPortNumberReceiveTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_PORT ) );
        m_localHostPortNumberTransmitTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_PORT ) );
        m_localHostAETitleReceiveTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_AETITLE ) );
        m_localHostTransmitAETitleTextField.setText( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_AETITLE ) );

        m_localHost.setNodeName( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_NAME ) );
        m_localHost.setIPaddressNr( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_IP_ADDRESS ) );
        m_localHost.setReceiveAEtitle( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_AETITLE ) );
        m_localHost.setTransmitAEtitle( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_AETITLE ) );
        m_localHost.setDicomReceivePortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_RECEIVE_PORT ) ) ).intValue( ) );
        m_localHost.setDicomTransmitPortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.LOCAL_HOST_DICOM_TRANSMIT_PORT ) ) ).intValue( )  );

        m_dicomNode0.setNodeName( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_NAME ) );
        m_dicomNode0.setIPaddressNr( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_IP_ADDRESS ) );
        m_dicomNode0.setReceiveAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_RECEIVE_AETITLE ) );
        m_dicomNode0.setTransmitAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_TRANSMIT_AETITLE ) );
        m_dicomNode0.setDicomReceivePortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_RECEIVE_PORT ) ) ).intValue( ) );
        m_dicomNode0.setDicomTransmitPortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_0_DICOM_TRANSMIT_PORT ) ) ).intValue( ) );

        m_dicomNode1.setNodeName( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_NAME ) );
        m_dicomNode1.setIPaddressNr( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_IP_ADDRESS ) );
        m_dicomNode1.setReceiveAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_RECEIVE_AETITLE ) );
        m_dicomNode1.setTransmitAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_TRANSMIT_AETITLE ) );
        m_dicomNode1.setDicomReceivePortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_RECEIVE_PORT ) ) ).intValue( ) );
        m_dicomNode1.setDicomTransmitPortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_1_DICOM_TRANSMIT_PORT ) ) ).intValue( ) );

        m_dicomNode2.setNodeName( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_NAME ) );
        m_dicomNode2.setIPaddressNr( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_IP_ADDRESS ) );
        m_dicomNode2.setReceiveAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_RECEIVE_AETITLE ) );
        m_dicomNode2.setTransmitAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_TRANSMIT_AETITLE ) );
        m_dicomNode2.setDicomReceivePortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_RECEIVE_PORT ) ) ).intValue( ) );
        m_dicomNode2.setDicomTransmitPortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_2_DICOM_TRANSMIT_PORT ) ) ).intValue( ) );

        m_dicomNode3.setNodeName( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_NAME ) );
        m_dicomNode3.setIPaddressNr( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_IP_ADDRESS ) );
        m_dicomNode3.setReceiveAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_RECEIVE_AETITLE ) );
        m_dicomNode3.setTransmitAEtitle( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_TRANSMIT_AETITLE ) );
        m_dicomNode3.setDicomReceivePortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_RECEIVE_PORT ) ) ).intValue( ) );
        m_dicomNode3.setDicomTransmitPortNumber( ( new Integer( def.getProperty( DicomNetworkNodeDefaults.REMOTE_DICOM_HOST_3_DICOM_TRANSMIT_PORT ) ) ).intValue( ) );


        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getNodeName( ), 0, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getIPaddressr( ), 0, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getDicomReceivePortNumber( ), 0, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode0.getReceiveAEtitle( ), 0, 3 );

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getNodeName( ), 1, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getIPaddressr( ), 1, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getDicomReceivePortNumber( ), 1, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode1.getReceiveAEtitle( ), 1, 3 );
       
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getNodeName( ), 2, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getIPaddressr( ), 2, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getDicomReceivePortNumber( ), 2, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode2.getReceiveAEtitle( ), 2, 3 );

        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getNodeName( ), 3, 0 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getIPaddressr( ), 3, 1 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getDicomReceivePortNumber( ), 3, 2 );
        m_dicomNodeTable.getModel( ).setValueAt( m_dicomNode3.getReceiveAEtitle( ), 3, 3 );

        m_dicomNodeTable.getSelectionModel( ).addSelectionInterval( 0, 0 );

        m_selectedRemoteHostDicomNodeNameTextBox.setText( m_localHost.getNodeName( ) );
        m_selectedRemoteHostDicomAETitleTextbox.setText( m_localHost.getReceiveAEtitle( ) );
        m_selectedRemoteHostDicomIPaddressTextBox.setText( m_localHost.getIPaddressr( ) );
        m_selectedRemoteHostDicomPortNumbertextBox.setText( "" + m_localHost.getDicomReceivePortNumber( ) );


         // add a listener to selection changes of the table
        m_dicomNodeTable.getSelectionModel( ).addListSelectionListener( this );
        m_dicomNodeTable.getColumnModel( ).getSelectionModel( ).addListSelectionListener( this );



        if ( ( m_selectedRemoteDicomHost > -1 ) && ( m_selectedRemoteDicomHost < 4 ) )
        {
            m_dicomNodeTable.setRowSelectionInterval( m_selectedRemoteDicomHost, m_selectedRemoteDicomHost );
        }
        else
        {
            m_dicomNodeTable.setRowSelectionInterval( 3, 3 );
        }


//        // add a listener to selection changes of the table
//        m_dicomNodeTable.getSelectionModel( ).addListSelectionListener( this );
//        m_dicomNodeTable.getColumnModel( ).getSelectionModel( ).addListSelectionListener( this );

    }


     /**
     * Is called whenever a listSelection event occurs in a registered object
     * @param arg0
     */
    public void valueChanged( ListSelectionEvent e )
    {

        if ( m_dicomNodeTable.getSelectedRow() == 0 )
        {
            m_selectedRemoteHostDicomNodeNameTextBox.setText( m_dicomNode0.getNodeName( ) );
            m_selectedRemoteHostDicomAETitleTextbox.setText( m_dicomNode0.getReceiveAEtitle( ) );
            m_selectedRemoteHostDicomIPaddressTextBox.setText( m_dicomNode0.getIPaddressr( ) );
            m_selectedRemoteHostDicomPortNumbertextBox.setText( "" + m_dicomNode0.getDicomReceivePortNumber( ) );
        }

        if ( m_dicomNodeTable.getSelectedRow() == 1 )
        {
            m_selectedRemoteHostDicomNodeNameTextBox.setText( m_dicomNode1.getNodeName( ) );
            m_selectedRemoteHostDicomAETitleTextbox.setText( m_dicomNode1.getReceiveAEtitle( ) );
            m_selectedRemoteHostDicomIPaddressTextBox.setText( m_dicomNode1.getIPaddressr( ) );
            m_selectedRemoteHostDicomPortNumbertextBox.setText( "" + m_dicomNode1.getDicomReceivePortNumber( ) );
        }

        if ( m_dicomNodeTable.getSelectedRow() == 2 )
        {
            m_selectedRemoteHostDicomNodeNameTextBox.setText( m_dicomNode2.getNodeName( ) );
            m_selectedRemoteHostDicomAETitleTextbox.setText( m_dicomNode2.getReceiveAEtitle( ) );
            m_selectedRemoteHostDicomIPaddressTextBox.setText( m_dicomNode2.getIPaddressr( ) );
            m_selectedRemoteHostDicomPortNumbertextBox.setText( "" + m_dicomNode2.getDicomReceivePortNumber( ) );
        }

        if ( m_dicomNodeTable.getSelectedRow() == 3 )
        {
            m_selectedRemoteHostDicomNodeNameTextBox.setText( m_dicomNode3.getNodeName( ) );
            m_selectedRemoteHostDicomAETitleTextbox.setText( m_dicomNode3.getReceiveAEtitle( ) );
            m_selectedRemoteHostDicomIPaddressTextBox.setText( m_dicomNode3.getIPaddressr( ) );
            m_selectedRemoteHostDicomPortNumbertextBox.setText( "" + m_dicomNode3.getDicomReceivePortNumber( ) );
        }

        DicomNetworkNodeDefaults dicomNetworkDefs = DicomNetworkNodeDefaults.getInstance( );
        dicomNetworkDefs.setProperty( DicomNetworkNodeDefaults.SELECTED_REMOTE_DICOM_HOST_NUMBER, "" + m_dicomNodeTable.getSelectedRow( ) );
        dicomNetworkDefs.save( );

    }



      /**
     * Notify listeners that something in the object has changed
     */
    protected void notifyActionListeners( int eventType )
    {

        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "OK" ) );
        }

    }


    /**
     * Adds an actionlistener to the list of action listeners who are notified
     * when something happens in this component
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Is called whenever a registered object raises an ActionEvent
     * @param ae
     */
    public void actionPerformed( ActionEvent ae )
    {
        // not implemented
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton m_OKButton;
    private javax.swing.JButton m_aboutButton;
    private javax.swing.JTable m_dicomNodeTable;
    private javax.swing.JTextField m_localHostAETitleReceiveTextField;
    private javax.swing.JTextField m_localHostDICOMNameTextField;
    private javax.swing.JTextField m_localHostIPAddressTextField;
    private javax.swing.JPanel m_localHostPanel;
    private javax.swing.JTextField m_localHostPortNumberReceiveTextField;
    private javax.swing.JTextField m_localHostPortNumberTransmitTextField;
    private javax.swing.JTextField m_localHostTransmitAETitleTextField;
    private javax.swing.JButton m_localhostUpdateData;
    private javax.swing.JLabel m_nodeNameLabel;
    private javax.swing.JLabel m_nodeNameLabel1;
    private javax.swing.JTextField m_selectedRemoteHostDicomAETitleTextbox;
    private javax.swing.JTextField m_selectedRemoteHostDicomIPaddressTextBox;
    private javax.swing.JTextField m_selectedRemoteHostDicomNodeNameTextBox;
    private javax.swing.JTextField m_selectedRemoteHostDicomPortNumbertextBox;
    private javax.swing.JButton m_updateTableButton;
    // End of variables declaration//GEN-END:variables


    private DicomNetworkNode m_localHost;
    private DicomNetworkNode m_dicomNode0;
    private DicomNetworkNode m_dicomNode1;
    private DicomNetworkNode m_dicomNode2;
    private DicomNetworkNode m_dicomNode3;

    private int m_selectedRemoteDicomHost = -1;

    //
    private DicomNetworkNodeDefinerAndSelectionFrame m_parentFrame;
    private LinkedList<ActionListener> m_actionListeners = new LinkedList<ActionListener>( );
    public final static int OK_BUTTON_PRESSED = 0;
}
