/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.grid;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.swing.JOptionPane;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.spectrim.model.GlobalModel;

/**
 *
 * @author johan
 */
public class FeatureBasedGridSelectionJFrame extends javax.swing.JFrame implements ChangeListener
{

    // Attributes
    GlobalModel m_model;
    private float m_rangeMultiplier1;
    private float m_rangeMultiplier2;
    private float m_rangeMultiplier3;
    
    HashMap<String, Boolean> m_outputFilterMapCriterium1_First  = new HashMap<>( );
    HashMap<String, Boolean> m_outputFilterMapCriterium1_Second = new HashMap<>( );
    HashMap<String, Boolean> m_outputFilterMapCriterium2_First  = new HashMap<>( );
    HashMap<String, Boolean> m_outputFilterMapCriterium2_Second = new HashMap<>( );
    HashMap<String, Boolean> m_outputFilterMapCriterium3_First  = new HashMap<>( );
    HashMap<String, Boolean> m_outputFilterMapCriterium3_Second = new HashMap<>( );
    
    // storage of the colormap values so that they need to be computed only once!
    HashMap<String, Float> m_valueMapCriterium1 = new HashMap<>( );
    float                  m_criterium1MinimumValue;
    float                  m_criterium1MaximumValue;
    int                    m_currentlySelectedCriterium1Type = -1;
    
    HashMap<String, Float> m_valueMapCriterium2 = new HashMap<>( );
    float                  m_criterium2MinimumValue;
    float                  m_criterium2MaximumValue;
    int                    m_currentlySelectedCriterium2Type = -1;
    
    HashMap<String, Float> m_valueMapCriterium3 = new HashMap<>( );
    float                  m_criterium3MinimumValue;
    float                  m_criterium3MaximumValue;
    int                    m_currentlySelectedCriterium3Type = -1;
    
    HashMap<String, Boolean> m_overallOutputCriterium1 = new HashMap<>( );
    HashMap<String, Boolean> m_overallOutputCriterium2 = new HashMap<>( );
    HashMap<String, Boolean> m_overallOutputCriterium3 = new HashMap<>( );
    
    HashMap<String, Boolean> m_overallOutputAllCriteria = new HashMap<>( );
    HashMap<String, Double>   m_overallOutputAllCriteriaValues = new HashMap<>( );
    
    /**
     * Creates new form FeatureBasedGridSelectionJFrame
     * Enables exclusion of MRSI spectra based on spectral features.
     * @param model
     */
    public FeatureBasedGridSelectionJFrame( GlobalModel model ) 
    {
        initComponents( );
        
        m_model = model;
        
        if ( m_model != null )
        {
            m_featureSelectionjComboBox_Criterium_1.removeAllItems( );
            m_featureSelectionjComboBox_Criterium_2.removeAllItems( );
            m_featureSelectionjComboBox_Criterium_3.removeAllItems( );
            // m_model.getColorMap( ).constructMappingFunctions( );
            
            ArrayList<String> functions = m_model.getColorMap( ).getFunctionsNames( );
            if ( functions != null )
            {
                m_featureSelectionjComboBox_Criterium_1.addItem( "--Select Function--" );
                m_featureSelectionjComboBox_Criterium_2.addItem( "--Select Function--" );
                m_featureSelectionjComboBox_Criterium_3.addItem( "--Select Function--" );
                for ( int i = 0; i < functions.size( ); i++ )
                {
                    this.m_featureSelectionjComboBox_Criterium_1.addItem( functions.get( i ) );
                    this.m_featureSelectionjComboBox_Criterium_2.addItem( functions.get( i ) );
                    this.m_featureSelectionjComboBox_Criterium_3.addItem( functions.get( i ) );
                }
            }
        }
        
        m_featureSelectionjComboBox_Criterium_1.setSelectedIndex( 0 );
        m_featureSelectionjComboBox_Criterium_2.setSelectedIndex( 0 );
        m_featureSelectionjComboBox_Criterium_3.setSelectedIndex( 0 );
        
        m_second_Comparator_Criterium1_jComboBox.setEnabled(false);
        m_maximum_Criterium_1_jTextField.setEnabled(false);
        m_maximumFeaturejLabel1.setEnabled(false);
        m_maximumFeaturejLabel_Value_1.setEnabled(false);
        
        m_second_Comparator_Criterium2_jComboBox.setEnabled(false);
        m_maximum_Criterium_2_TextField.setEnabled(false);
        m_maximumFeaturejLabel2.setEnabled(false);
        m_maximumFeaturejLabel_Value_2.setEnabled(false);
        
        m_second_Comparator_Criterium3_jComboBox.setEnabled(false);
        m_maximum_Criterium_3_TextField.setEnabled(false);
        m_maximumFeaturejLabel3.setEnabled(false);
        m_maximumFeaturejLabel_Value_3.setEnabled(false);
        
        criteriumOnejSliderLeft.addChangeListener(this);
        criteriumOnejSliderRight.addChangeListener(this);
        criteriumTwojSliderLeft.addChangeListener(this);
        criteriumTwojSliderRight.addChangeListener(this);
        criteriumThreejSliderLeft.addChangeListener(this);
        criteriumThreejSliderRight.addChangeListener(this);
        
        setVisible( true );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        m_featureSelectionjComboBox_Criterium_1 = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel1 = new javax.swing.JLabel();
        m_maximumFeaturejLabel1 = new javax.swing.JLabel();
        m_first_Comparator_Criterium1_jComboBox = new javax.swing.JComboBox<>();
        m_connector_Criterium_1_jComboBox = new javax.swing.JComboBox<>();
        m_minimum_Criterium_1_jTextField = new javax.swing.JTextField();
        m_maximum_Criterium_1_jTextField = new javax.swing.JTextField();
        m_second_Comparator_Criterium1_jComboBox = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel_Value_1 = new javax.swing.JLabel();
        m_maximumFeaturejLabel_Value_1 = new javax.swing.JLabel();
        criteriumOnejSliderLeft = new javax.swing.JSlider();
        criteriumOnejSliderRight = new javax.swing.JSlider();
        jPanel4 = new javax.swing.JPanel();
        m_featureSelectionjComboBox_Criterium_3 = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel3 = new javax.swing.JLabel();
        m_maximumFeaturejLabel3 = new javax.swing.JLabel();
        m_first_Comparator_Criterium3_jComboBox = new javax.swing.JComboBox<>();
        m_connector_Criterium_3_jComboBox = new javax.swing.JComboBox<>();
        m_minimum_Criterium_3_TextField = new javax.swing.JTextField();
        m_maximum_Criterium_3_TextField = new javax.swing.JTextField();
        m_second_Comparator_Criterium3_jComboBox = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel_Value_3 = new javax.swing.JLabel();
        m_maximumFeaturejLabel_Value_3 = new javax.swing.JLabel();
        criteriumThreejSliderLeft = new javax.swing.JSlider();
        criteriumThreejSliderRight = new javax.swing.JSlider();
        jPanel5 = new javax.swing.JPanel();
        m_featureSelectionjComboBox_Criterium_2 = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel2 = new javax.swing.JLabel();
        m_maximumFeaturejLabel2 = new javax.swing.JLabel();
        m_first_Comparator_Criterium2_jComboBox = new javax.swing.JComboBox<>();
        m_connector_Criterium_2_jComboBox = new javax.swing.JComboBox<>();
        m_minimum_Criterium_2_TextField = new javax.swing.JTextField();
        m_maximum_Criterium_2_TextField = new javax.swing.JTextField();
        m_second_Comparator_Criterium2_jComboBox = new javax.swing.JComboBox<>();
        m_minimumFeaturejLabel_Value_2 = new javax.swing.JLabel();
        m_maximumFeaturejLabel_Value_2 = new javax.swing.JLabel();
        criteriumTwojSliderLeft = new javax.swing.JSlider();
        criteriumTwojSliderRight = new javax.swing.JSlider();
        jPanel2 = new javax.swing.JPanel();
        m_previewFilterEffectjButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        m_applyTwoCriteriajComboBox = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        m_applyThreeCriteriajComboBox = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        m_applyjButton = new javax.swing.JButton();
        m_quitjButton = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        useOneCriteriumjRadioButton = new javax.swing.JRadioButton();
        useTwoCriteriajRadioButton = new javax.swing.JRadioButton();
        useThreeCriteriajRadioButton = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Criterium 1"));
        jPanel1.setPreferredSize(new java.awt.Dimension(942, 81));
        jPanel1.setRequestFocusEnabled(false);

        m_featureSelectionjComboBox_Criterium_1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        m_featureSelectionjComboBox_Criterium_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_featureSelectionjComboBox_Criterium_1ActionPerformed(evt);
            }
        });

        m_minimumFeaturejLabel1.setText("Minimum value ");

        m_maximumFeaturejLabel1.setText("Maximum value ");

        m_first_Comparator_Criterium1_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));

        m_connector_Criterium_1_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "AND", "OR" }));
        m_connector_Criterium_1_jComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_connector_Criterium_1_jComboBoxActionPerformed(evt);
            }
        });

        m_minimum_Criterium_1_jTextField.setText("0.0000");

        m_maximum_Criterium_1_jTextField.setText("0.0000");

        m_second_Comparator_Criterium1_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));

        m_minimumFeaturejLabel_Value_1.setText("0.0000");
        m_minimumFeaturejLabel_Value_1.setToolTipText("");

        m_maximumFeaturejLabel_Value_1.setText("0.0000");
        m_maximumFeaturejLabel_Value_1.setToolTipText("");

        criteriumOnejSliderLeft.setPaintTicks(true);

        criteriumOnejSliderRight.setPaintTicks(true);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_featureSelectionjComboBox_Criterium_1, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(54, 54, 54)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_minimumFeaturejLabel1)
                    .addComponent(m_first_Comparator_Criterium1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_minimumFeaturejLabel_Value_1)
                    .addComponent(m_minimum_Criterium_1_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(criteriumOnejSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_connector_Criterium_1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_maximumFeaturejLabel1)
                    .addComponent(m_second_Comparator_Criterium1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_maximumFeaturejLabel_Value_1)
                    .addComponent(m_maximum_Criterium_1_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(criteriumOnejSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_minimumFeaturejLabel1)
                            .addComponent(m_maximumFeaturejLabel1)
                            .addComponent(m_minimumFeaturejLabel_Value_1)
                            .addComponent(m_maximumFeaturejLabel_Value_1))
                        .addGap(13, 13, 13)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_featureSelectionjComboBox_Criterium_1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_first_Comparator_Criterium1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_connector_Criterium_1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_minimum_Criterium_1_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_maximum_Criterium_1_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_second_Comparator_Criterium1_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(criteriumOnejSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(criteriumOnejSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(29, Short.MAX_VALUE))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Criterium 3"));
        jPanel4.setPreferredSize(new java.awt.Dimension(942, 81));

        m_featureSelectionjComboBox_Criterium_3.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        m_featureSelectionjComboBox_Criterium_3.setEnabled(false);
        m_featureSelectionjComboBox_Criterium_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_featureSelectionjComboBox_Criterium_3ActionPerformed(evt);
            }
        });

        m_minimumFeaturejLabel3.setText("Minimum value ");
        m_minimumFeaturejLabel3.setEnabled(false);

        m_maximumFeaturejLabel3.setText("Maximum value ");
        m_maximumFeaturejLabel3.setEnabled(false);

        m_first_Comparator_Criterium3_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));
        m_first_Comparator_Criterium3_jComboBox.setEnabled(false);

        m_connector_Criterium_3_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "AND", "OR" }));
        m_connector_Criterium_3_jComboBox.setEnabled(false);
        m_connector_Criterium_3_jComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_connector_Criterium_3_jComboBoxActionPerformed(evt);
            }
        });

        m_minimum_Criterium_3_TextField.setText("0.0000");
        m_minimum_Criterium_3_TextField.setAutoscrolls(false);
        m_minimum_Criterium_3_TextField.setEnabled(false);

        m_maximum_Criterium_3_TextField.setText("0.0000");
        m_maximum_Criterium_3_TextField.setAutoscrolls(false);
        m_maximum_Criterium_3_TextField.setEnabled(false);

        m_second_Comparator_Criterium3_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));
        m_second_Comparator_Criterium3_jComboBox.setEnabled(false);

        m_minimumFeaturejLabel_Value_3.setText("0.0000");
        m_minimumFeaturejLabel_Value_3.setEnabled(false);

        m_maximumFeaturejLabel_Value_3.setText("0.0000");
        m_maximumFeaturejLabel_Value_3.setEnabled(false);

        criteriumThreejSliderLeft.setPaintTicks(true);

        criteriumThreejSliderRight.setPaintTicks(true);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_featureSelectionjComboBox_Criterium_3, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(m_first_Comparator_Criterium3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_minimum_Criterium_3_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(m_minimumFeaturejLabel3)
                        .addGap(18, 18, 18)
                        .addComponent(m_minimumFeaturejLabel_Value_3, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(criteriumThreejSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(m_connector_Criterium_3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_second_Comparator_Criterium3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_maximumFeaturejLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_maximumFeaturejLabel_Value_3)
                    .addComponent(m_maximum_Criterium_3_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(2, 2, 2)
                .addComponent(criteriumThreejSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_minimumFeaturejLabel3)
                            .addComponent(m_maximumFeaturejLabel3)
                            .addComponent(m_minimumFeaturejLabel_Value_3)
                            .addComponent(m_maximumFeaturejLabel_Value_3))
                        .addGap(13, 13, 13)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_featureSelectionjComboBox_Criterium_3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_first_Comparator_Criterium3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_connector_Criterium_3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_minimum_Criterium_3_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_maximum_Criterium_3_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_second_Comparator_Criterium3_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(criteriumThreejSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(criteriumThreejSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(29, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Criterium 2"));
        jPanel5.setPreferredSize(new java.awt.Dimension(942, 81));

        m_featureSelectionjComboBox_Criterium_2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        m_featureSelectionjComboBox_Criterium_2.setEnabled(false);
        m_featureSelectionjComboBox_Criterium_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_featureSelectionjComboBox_Criterium_2ActionPerformed(evt);
            }
        });

        m_minimumFeaturejLabel2.setText("Minimum value ");
        m_minimumFeaturejLabel2.setEnabled(false);

        m_maximumFeaturejLabel2.setText("Maximum value ");
        m_maximumFeaturejLabel2.setEnabled(false);

        m_first_Comparator_Criterium2_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));
        m_first_Comparator_Criterium2_jComboBox.setEnabled(false);

        m_connector_Criterium_2_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "AND", "OR" }));
        m_connector_Criterium_2_jComboBox.setEnabled(false);
        m_connector_Criterium_2_jComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_connector_Criterium_2_jComboBoxActionPerformed(evt);
            }
        });

        m_minimum_Criterium_2_TextField.setText("0.0000");
        m_minimum_Criterium_2_TextField.setEnabled(false);

        m_maximum_Criterium_2_TextField.setText("0.0000");
        m_maximum_Criterium_2_TextField.setEnabled(false);

        m_second_Comparator_Criterium2_jComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "Larger than", "Smaller than" }));
        m_second_Comparator_Criterium2_jComboBox.setEnabled(false);

        m_minimumFeaturejLabel_Value_2.setText("0.0000");
        m_minimumFeaturejLabel_Value_2.setEnabled(false);

        m_maximumFeaturejLabel_Value_2.setText("0.0000");
        m_maximumFeaturejLabel_Value_2.setEnabled(false);

        criteriumTwojSliderLeft.setPaintTicks(true);

        criteriumTwojSliderRight.setPaintTicks(true);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_featureSelectionjComboBox_Criterium_2, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(53, 53, 53)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(m_minimumFeaturejLabel2)
                        .addGap(18, 18, 18)
                        .addComponent(m_minimumFeaturejLabel_Value_2))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(m_first_Comparator_Criterium2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_minimum_Criterium_2_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(criteriumTwojSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addComponent(m_connector_Criterium_2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_second_Comparator_Criterium2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_maximumFeaturejLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(m_maximumFeaturejLabel_Value_2)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(m_maximum_Criterium_2_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(criteriumTwojSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(criteriumTwojSliderLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_minimumFeaturejLabel2)
                            .addComponent(m_maximumFeaturejLabel2)
                            .addComponent(m_minimumFeaturejLabel_Value_2)
                            .addComponent(m_maximumFeaturejLabel_Value_2))
                        .addGap(13, 13, 13)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_featureSelectionjComboBox_Criterium_2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_first_Comparator_Criterium2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_connector_Criterium_2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_minimum_Criterium_2_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_maximum_Criterium_2_TextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_second_Comparator_Criterium2_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(criteriumTwojSliderRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(29, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        m_previewFilterEffectjButton.setText("Preview filter effect");
        m_previewFilterEffectjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_previewFilterEffectjButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Apply criterium 1");

        m_applyTwoCriteriajComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "AND", "OR" }));
        m_applyTwoCriteriajComboBox.setEnabled(false);

        jLabel3.setText("Apply criterium 2");
        jLabel3.setEnabled(false);

        m_applyThreeCriteriajComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select", "AND", "OR" }));
        m_applyThreeCriteriajComboBox.setEnabled(false);

        jLabel4.setText("Apply criterium 3");
        jLabel4.setEnabled(false);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addComponent(m_applyTwoCriteriajComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel3)
                .addGap(18, 18, 18)
                .addComponent(m_applyThreeCriteriajComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_previewFilterEffectjButton)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_previewFilterEffectjButton)
                    .addComponent(jLabel2)
                    .addComponent(m_applyTwoCriteriajComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(m_applyThreeCriteriajComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        m_applyjButton.setText("Apply and Quit");
        m_applyjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyjButtonActionPerformed(evt);
            }
        });

        m_quitjButton.setText("Quit");
        m_quitjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_quitjButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addComponent(m_applyjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_quitjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(31, 31, 31))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_applyjButton)
                    .addComponent(m_quitjButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setText("Use number of criteria: ");

        buttonGroup1.add(useOneCriteriumjRadioButton);
        useOneCriteriumjRadioButton.setSelected(true);
        useOneCriteriumjRadioButton.setText("One criterium");
        useOneCriteriumjRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                useOneCriteriumjRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(useTwoCriteriajRadioButton);
        useTwoCriteriajRadioButton.setText("Two criteria");
        useTwoCriteriajRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                useTwoCriteriajRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(useThreeCriteriajRadioButton);
        useThreeCriteriajRadioButton.setText("Three criteria");
        useThreeCriteriajRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                useThreeCriteriajRadioButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(useOneCriteriumjRadioButton)
                .addGap(18, 18, 18)
                .addComponent(useTwoCriteriajRadioButton)
                .addGap(18, 18, 18)
                .addComponent(useThreeCriteriajRadioButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(useOneCriteriumjRadioButton)
                    .addComponent(useTwoCriteriajRadioButton)
                    .addComponent(useThreeCriteriajRadioButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 985, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 985, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 985, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_quitjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_quitjButtonActionPerformed
        dispose();
    }//GEN-LAST:event_m_quitjButtonActionPerformed

    private void m_applyjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyjButtonActionPerformed
        System.out.println( "Apply!" ); // TODO add your handling code here:
    }//GEN-LAST:event_m_applyjButtonActionPerformed

    private void m_featureSelectionjComboBox_Criterium_1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_featureSelectionjComboBox_Criterium_1ActionPerformed
        
        if ( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) > 0  )
        {
            updateOverlayAccordingToCombobox_1( );
        }
    }//GEN-LAST:event_m_featureSelectionjComboBox_Criterium_1ActionPerformed

    private void m_previewFilterEffectjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_previewFilterEffectjButtonActionPerformed
        
        
        computeFilteredSelection( m_valueMapCriterium1 );
                 
    }//GEN-LAST:event_m_previewFilterEffectjButtonActionPerformed

    private void computeFilteredSelection( HashMap<String,Float> map )
    {
        // first select all voxels ..
        m_model.selectAllVoxels( );
        
//        HashMap<String, Float> map = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ), 1.0, 5.0 );
        
        Iterator it = map.entrySet( ).iterator( );
        while ( it.hasNext( ) ) 
        {
            Map.Entry pair = (Map.Entry)it.next( );
            m_outputFilterMapCriterium1_First.put( (String)pair.getKey( ), false );
            m_outputFilterMapCriterium1_Second.put( (String)pair.getKey( ), false );
            m_outputFilterMapCriterium2_First.put( (String)pair.getKey( ), false );
            m_outputFilterMapCriterium2_Second.put( (String)pair.getKey( ), false );
            m_outputFilterMapCriterium3_First.put( (String)pair.getKey( ), false );
            m_outputFilterMapCriterium3_Second.put( (String)pair.getKey( ), false );
        }
        
        // Always compute
        computedCriteriumOneBooleanLogicOutput( );
        
        if  ( useTwoCriteriajRadioButton.isSelected( ) )
        {
            computedCriteriumTwoBooleanLogicOutput( );
        }
        
        if ( useThreeCriteriajRadioButton.isSelected( ) )
        {
            computedCriteriumTwoBooleanLogicOutput( );
            computedCriteriumThreeBooleanLogicOutput( );
        }
        
        if ( useOneCriteriumjRadioButton.isSelected( ) )
        {
            Iterator it1 = this.m_overallOutputCriterium1.entrySet( ).iterator( );
            while ( it1.hasNext( ) ) 
            {
                Map.Entry pair = (Map.Entry)it1.next( );
                this.m_overallOutputAllCriteria.put( (String)pair.getKey( ), (Boolean)pair.getValue( ) );
            }
        }
        
        if ( useOneCriteriumjRadioButton.isSelected( ) )
        {
            Iterator it1 = this.m_overallOutputCriterium1.entrySet( ).iterator( );
            while ( it1.hasNext( ) ) 
            {
                Map.Entry pair = (Map.Entry)it1.next( );
                this.m_overallOutputAllCriteria.put( (String)pair.getKey( ), (Boolean)pair.getValue( ) );
            }
        }
        
        if ( useTwoCriteriajRadioButton.isSelected( ) )
        {
            Iterator it1 = this.m_overallOutputCriterium1.entrySet( ).iterator( );
            Iterator it2 = this.m_overallOutputCriterium2.entrySet( ).iterator( );
            while ( it1.hasNext( ) ) 
            {
                Map.Entry pair1 = (Map.Entry)it1.next( );
                Map.Entry pair2 = (Map.Entry)it2.next( );
                
                boolean bool1 = (boolean)pair1.getValue( );
                boolean bool2 = (boolean)pair2.getValue( );
                boolean output;
                if ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 1 )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( bool1 && bool2 ) );
                }
                
                if ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 2 )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( bool1 || bool2 ) );
                }
            }
        }
        
        if ( useThreeCriteriajRadioButton.isSelected( ) )
        {
            Iterator it1 = this.m_overallOutputCriterium1.entrySet( ).iterator( );
            Iterator it2 = this.m_overallOutputCriterium2.entrySet( ).iterator( );
            Iterator it3 = this.m_overallOutputCriterium3.entrySet( ).iterator( );
            while ( it1.hasNext( ) ) 
            {
                Map.Entry pair1 = (Map.Entry)it1.next( );
                Map.Entry pair2 = (Map.Entry)it2.next( );
                Map.Entry pair3 = (Map.Entry)it3.next( );
                
                boolean bool1 = (boolean)pair1.getValue( );
                boolean bool2 = (boolean)pair2.getValue( );
                boolean bool3 = (boolean)pair2.getValue( );
                boolean output;
                if ( ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 1 ) && ( m_applyThreeCriteriajComboBox.getSelectedIndex( ) == 1 ) )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( ( bool1 && bool2 ) && ( bool3 ) ) );
                }
                
                if ( ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 1 ) && ( m_applyThreeCriteriajComboBox.getSelectedIndex( ) == 2 ) )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( ( bool1 && bool2 ) || ( bool3 ) ) );
                }
                
                if ( ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 2 ) && ( m_applyThreeCriteriajComboBox.getSelectedIndex( ) == 1 ) )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( ( bool1 || bool2 ) && ( bool3 ) ) );
                }
                
                if ( ( m_applyTwoCriteriajComboBox.getSelectedIndex( ) == 2 ) && ( m_applyThreeCriteriajComboBox.getSelectedIndex( ) == 2 ) )
                {
                    m_overallOutputAllCriteria.put( (String)pair1.getKey( ), (Boolean)( ( bool1 || bool2 ) || ( bool3 ) ) );
                }
            }
        }
        ArrayList<String> userSelectedVoxels = new ArrayList<String>( );
        
        
        m_overallOutputAllCriteriaValues = new HashMap<>();
        
        Iterator itOut = m_overallOutputAllCriteria.entrySet( ).iterator( );
        while ( itOut.hasNext( ) ) 
        {
            Map.Entry pair1 = (Map.Entry)itOut.next( );
            boolean selected = (Boolean)pair1.getValue( );
            if ( selected == true )
            {
                userSelectedVoxels.add( (String)pair1.getKey( ) );
                m_overallOutputAllCriteriaValues.put( (String)pair1.getKey( ), 0.0 );
            }
            else
            {
                m_overallOutputAllCriteriaValues.put( (String)pair1.getKey( ), 1.0 );
            }
        }
        
        if ( useOneCriteriumjRadioButton.isSelected( ) == true )
        {
           m_model.getColorMap( ).setColorMapValues( m_overallOutputAllCriteriaValues, true );
        }
        
        m_model.setSelectedVoxels( userSelectedVoxels );
    }
            
    private void computedCriteriumThreeBooleanLogicOutput( )
    {
        HashMap<String, Float> map = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( ), 1.0, 5.0 );
            
        float criterium3FirstValue = new Float( this.m_minimum_Criterium_3_TextField.getText( ) );
        float criterium3SecondValue = new Float( this.m_maximum_Criterium_3_TextField.getText( ) );

        Iterator it = map.entrySet( ).iterator( );
        while ( it.hasNext( ) ) 
        {
            Map.Entry pair = (Map.Entry)it.next( );
            System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );

            if ( m_first_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 1 )
            {
                // test greater than ...
                if ( ( (Float)pair.getValue( ) ) > criterium3FirstValue )
                {
                    m_outputFilterMapCriterium3_First.put( (String)pair.getKey( ), true );
                }
            }
            if ( m_first_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 2 )
            {
                // test smaller than ...
                if ( ( (Float)pair.getValue( ) ) < criterium3FirstValue )
                {
                    m_outputFilterMapCriterium3_First.put( (String)pair.getKey( ), true );
                }
            }

            if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) > 0 )
            {
                if ( m_second_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 1 )
                {
                    // test greater than ...
                    if ( ( (Float)pair.getValue( ) ) > criterium3SecondValue )
                    {
                        m_outputFilterMapCriterium3_Second.put( (String)pair.getKey( ), true );
                    }
                }
                if ( m_second_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 2 )
                {
                    // test smaller than ...
                    if ( ( (Float)pair.getValue( ) ) < criterium3SecondValue )
                    {
                        m_outputFilterMapCriterium3_Second.put( (String)pair.getKey( ), true );
                    }
                }
            }  
        }

        // Now collect information with combined boolean logic
        if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) == 0 )
        {
            // No combined boolean logic
            Iterator it2 = m_outputFilterMapCriterium3_First.entrySet( ).iterator( );

            while ( it2.hasNext( ) )
            {
                Map.Entry pair = (Map.Entry)it2.next( );
                m_overallOutputCriterium3.put( (String)pair.getKey( ), (Boolean)pair.getValue( ) );
            }
        }

        if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) == 1 )
        {
            // combined logic AND
            Iterator it3 = m_outputFilterMapCriterium3_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium3_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool && secondBool;
                m_overallOutputCriterium3.put( (String)pair1.getKey( ), (Boolean)test );
            }
        }

        if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) == 2 )
        {
            // combined logic OR
            Iterator it3 = m_outputFilterMapCriterium3_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium3_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool || secondBool;
                m_overallOutputCriterium3.put( (String)pair1.getKey( ), (Boolean)test );
            }
        }  
    }
    
    
    private void computedCriteriumTwoBooleanLogicOutput( )
    {
        HashMap<String, Float> map = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ), 1.0, 5.0 );
            
        float criterium2FirstValue = new Float( this.m_minimum_Criterium_2_TextField.getText( ) );
        float criterium2SecondValue = new Float( this.m_maximum_Criterium_2_TextField.getText( ) );

        Iterator it = map.entrySet( ).iterator( );
        while ( it.hasNext( ) ) 
        {
            Map.Entry pair = (Map.Entry)it.next( );
            System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );

            if ( m_first_Comparator_Criterium2_jComboBox.getSelectedIndex( ) == 1 )
            {
                // test greater than ...
                if ( ( (Float)pair.getValue( ) ) > criterium2FirstValue )
                {
                    m_outputFilterMapCriterium2_First.put( (String)pair.getKey( ), true );
                }
            }
            if ( m_first_Comparator_Criterium2_jComboBox.getSelectedIndex( ) == 2 )
            {
                // test smaller than ...
                if ( ( (Float)pair.getValue( ) ) < criterium2FirstValue )
                {
                    m_outputFilterMapCriterium2_First.put( (String)pair.getKey( ), true );
                }
            }

            if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) > 0 )
            {
                if ( m_second_Comparator_Criterium2_jComboBox.getSelectedIndex( ) == 1 )
                {
                    // test greater than ...
                    if ( ( (Float)pair.getValue( ) ) > criterium2SecondValue )
                    {
                        m_outputFilterMapCriterium2_Second.put( (String)pair.getKey( ), true );
                    }
                }
                if ( m_second_Comparator_Criterium2_jComboBox.getSelectedIndex( ) == 2 )
                {
                    // test smaller than ...
                    if ( ( (Float)pair.getValue( ) ) < criterium2SecondValue )
                    {
                        m_outputFilterMapCriterium2_Second.put( (String)pair.getKey( ), true );
                    }
                }
            }  
        }

        // Now collect information with combined boolean logic
        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 0 )
        {
            // No combined boolean logic
            Iterator it2 = m_outputFilterMapCriterium2_First.entrySet( ).iterator( );

            while ( it2.hasNext( ) )
            {
                Map.Entry pair = (Map.Entry)it2.next( );
                m_overallOutputCriterium2.put( (String)pair.getKey( ), (Boolean)pair.getValue( ) );
            }
        }

        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 1 )
        {
            // combined logic AND
            Iterator it3 = m_outputFilterMapCriterium2_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium2_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool && secondBool;
                m_overallOutputCriterium2.put( (String)pair1.getKey( ), (Boolean)test );
            }
        }

        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 2 )
        {
            // combined logic OR
            Iterator it3 = m_outputFilterMapCriterium2_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium2_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool || secondBool;
                m_overallOutputCriterium2.put( (String)pair1.getKey( ), (Boolean)test );
            }
        }  
    }
    
    private void computedCriteriumOneBooleanLogicOutput( )
    {
        // HashMap<String, Float> map = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ), 1.0, 5.0 );
        
        float criterium1FirstValue = new Float( this.m_minimum_Criterium_1_jTextField.getText( ) );
        float criterium1SecondValue = new Float( this.m_maximum_Criterium_1_jTextField.getText( ) );

        Iterator it2 = m_valueMapCriterium1.entrySet( ).iterator( );
        while ( it2.hasNext( ) ) 
        {
            Map.Entry pair = (Map.Entry)it2.next( );
            System.out.println( ">>>>" + pair.getKey( ) + " = " + pair.getValue( ) );

            if ( m_first_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 1 )
            {
                // test greater than ...
                if ( ( (Float)pair.getValue( ) ) > criterium1FirstValue )
                {
                    m_outputFilterMapCriterium1_First.put( (String)pair.getKey( ), true );
                }
            }
            if ( m_first_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 2 )
            {
                // test smaller than ...
                if ( ( (Float)pair.getValue( ) ) < criterium1FirstValue )
                {
                    m_outputFilterMapCriterium1_First.put( (String)pair.getKey( ), true );
                }
            }

            if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) > 0 )
            {
                if ( m_second_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 1 )
                {
                    // test greater than ...
                    if ( ( (Float)pair.getValue( ) ) > criterium1SecondValue )
                    {
                        m_outputFilterMapCriterium1_Second.put( (String)pair.getKey( ), true );
                    }
                }
                if ( m_second_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 2 )
                {
                    // test smaller than ...
                    if ( ( (Float)pair.getValue( ) ) < criterium1SecondValue )
                    {
                        m_outputFilterMapCriterium1_Second.put( (String)pair.getKey( ), true );
                    }
                }
            }  
        }

        // Now collect information with combined boolean logic
        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 0 )
        {
            // No combined boolean logic
            Iterator it3 = m_outputFilterMapCriterium1_First.entrySet( ).iterator( );

            while ( it3.hasNext( ) )
            {
                Map.Entry pair = (Map.Entry)it3.next( );
                m_overallOutputCriterium1.put( (String)pair.getKey( ), (Boolean)pair.getValue( ) );
            }
        }

        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 1 )
        {
            // combined logic AND
            Iterator it3 = m_outputFilterMapCriterium1_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium1_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool && secondBool;
                m_overallOutputCriterium1.put( (String)pair1.getKey( ), (Boolean)test );
            }
        }

        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 2 )
        {
            // combined logic OR
            Iterator it3 = m_outputFilterMapCriterium1_First.entrySet( ).iterator( );
            Iterator it4 = m_outputFilterMapCriterium1_Second.entrySet( ).iterator( );
            while ( it3.hasNext( ) )
            {
                Map.Entry pair1    = (Map.Entry)it3.next( );
                Map.Entry pair2    = (Map.Entry)it4.next( );

                boolean firstBool  = (Boolean)pair1.getValue( );
                boolean secondBool = (Boolean)pair2.getValue( );
                boolean test = firstBool || secondBool;
                m_overallOutputCriterium1.put( (String)pair1.getKey( ), (Boolean)test );
            }
        } 
        System.out.println();
    }
    
    
    
    private void m_featureSelectionjComboBox_Criterium_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_featureSelectionjComboBox_Criterium_3ActionPerformed
        if ( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( ) > 0  )
        {
            updateOverlayAccordingToCombobox_3( );
        }
    }//GEN-LAST:event_m_featureSelectionjComboBox_Criterium_3ActionPerformed

    private void m_featureSelectionjComboBox_Criterium_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_featureSelectionjComboBox_Criterium_2ActionPerformed
        if ( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ) > 0  )
        {
            updateOverlayAccordingToCombobox_2( );
        }
    }//GEN-LAST:event_m_featureSelectionjComboBox_Criterium_2ActionPerformed

    private void useOneCriteriumjRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_useOneCriteriumjRadioButtonActionPerformed
        
        m_featureSelectionjComboBox_Criterium_1.setEnabled(true);
        m_featureSelectionjComboBox_Criterium_2.setEnabled(false);
        m_featureSelectionjComboBox_Criterium_3.setEnabled(false);
        
        m_minimumFeaturejLabel1.setEnabled(true);
        m_maximumFeaturejLabel1.setEnabled(true);
        m_minimumFeaturejLabel2.setEnabled(false);
        m_maximumFeaturejLabel2.setEnabled(false);
        m_minimumFeaturejLabel3.setEnabled(false);
        m_maximumFeaturejLabel3.setEnabled(false);
        
        m_minimumFeaturejLabel_Value_1.setEnabled(true);
        m_maximumFeaturejLabel_Value_1.setEnabled(true);
        m_minimumFeaturejLabel_Value_2.setEnabled(false);
        m_maximumFeaturejLabel_Value_2.setEnabled(false);
        m_minimumFeaturejLabel_Value_3.setEnabled(false);
        m_maximumFeaturejLabel_Value_3.setEnabled(false);
        
        m_first_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_first_Comparator_Criterium2_jComboBox.setEnabled( false );
        m_first_Comparator_Criterium3_jComboBox.setEnabled( false );
        
        m_second_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_second_Comparator_Criterium2_jComboBox.setEnabled( false );
        m_second_Comparator_Criterium3_jComboBox.setEnabled( false );
        
        m_connector_Criterium_1_jComboBox.setEnabled(true);
        m_minimum_Criterium_1_jTextField.setEnabled(true);
        m_minimum_Criterium_1_jTextField.setEnabled(true);
        
        m_connector_Criterium_2_jComboBox.setEnabled(false);
        m_minimum_Criterium_2_TextField.setEnabled(false);
        m_maximum_Criterium_2_TextField.setEnabled(false);
        
        m_connector_Criterium_3_jComboBox.setEnabled(false);
        m_minimum_Criterium_3_TextField.setEnabled(false);
        m_maximum_Criterium_3_TextField.setEnabled(false);
        
        m_applyTwoCriteriajComboBox.setEnabled(false);
        m_applyThreeCriteriajComboBox.setEnabled(false);
        
        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium1_jComboBox.setEnabled(false);
            m_maximum_Criterium_1_jTextField.setEnabled(false);
            m_maximumFeaturejLabel1.setEnabled(false);
            m_maximumFeaturejLabel_Value_1.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium1_jComboBox.setEnabled(true);
            m_maximum_Criterium_1_jTextField.setEnabled(true);
            m_maximumFeaturejLabel1.setEnabled(true);
            m_maximumFeaturejLabel_Value_1.setEnabled(true);
        }
        
        
    }//GEN-LAST:event_useOneCriteriumjRadioButtonActionPerformed

    private void useTwoCriteriajRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_useTwoCriteriajRadioButtonActionPerformed
        m_featureSelectionjComboBox_Criterium_1.setEnabled(true);
        m_featureSelectionjComboBox_Criterium_2.setEnabled(true);
        m_featureSelectionjComboBox_Criterium_3.setEnabled(false);
        
        m_minimumFeaturejLabel1.setEnabled(true);
        m_maximumFeaturejLabel1.setEnabled(true);
        m_minimumFeaturejLabel2.setEnabled(true);
        m_maximumFeaturejLabel2.setEnabled(true);
        m_minimumFeaturejLabel3.setEnabled(false);
        m_maximumFeaturejLabel3.setEnabled(false);
        
        m_minimumFeaturejLabel_Value_1.setEnabled(true);
        m_maximumFeaturejLabel_Value_1.setEnabled(true);
        m_minimumFeaturejLabel_Value_2.setEnabled(true);
        m_maximumFeaturejLabel_Value_2.setEnabled(true);
        m_minimumFeaturejLabel_Value_3.setEnabled(false);
        m_maximumFeaturejLabel_Value_3.setEnabled(false);
        
        m_first_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_first_Comparator_Criterium2_jComboBox.setEnabled( true );
        m_first_Comparator_Criterium3_jComboBox.setEnabled( false );
        
        m_second_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_second_Comparator_Criterium2_jComboBox.setEnabled( true );
        m_second_Comparator_Criterium3_jComboBox.setEnabled( false );
        
        m_connector_Criterium_1_jComboBox.setEnabled(true);
        m_minimum_Criterium_1_jTextField.setEnabled(true);
        m_maximum_Criterium_1_jTextField.setEnabled(true);
        
        m_connector_Criterium_2_jComboBox.setEnabled(true);
        m_minimum_Criterium_2_TextField.setEnabled(true);
        m_maximum_Criterium_2_TextField.setEnabled(true);
        
        m_connector_Criterium_3_jComboBox.setEnabled(false);
        m_minimum_Criterium_3_TextField.setEnabled(false);
        m_maximum_Criterium_3_TextField.setEnabled(false);
        
        m_applyTwoCriteriajComboBox.setEnabled(true);
        m_applyThreeCriteriajComboBox.setEnabled(false);
        
        
        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium1_jComboBox.setEnabled(false);
            m_maximum_Criterium_1_jTextField.setEnabled(false);
            m_maximumFeaturejLabel1.setEnabled(false);
            m_maximumFeaturejLabel_Value_1.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium1_jComboBox.setEnabled(true);
            m_maximum_Criterium_1_jTextField.setEnabled(true);
            m_maximumFeaturejLabel1.setEnabled(true);
            m_maximumFeaturejLabel_Value_1.setEnabled(true);
        }
        
        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium2_jComboBox.setEnabled(false);
            m_maximum_Criterium_2_TextField.setEnabled(false);
            m_maximumFeaturejLabel2.setEnabled(false);
            m_maximumFeaturejLabel_Value_2.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium2_jComboBox.setEnabled(true);
            m_maximum_Criterium_2_TextField.setEnabled(true);
            m_maximumFeaturejLabel2.setEnabled(true);
            m_maximumFeaturejLabel_Value_2.setEnabled(true);
        }
        
        
    }//GEN-LAST:event_useTwoCriteriajRadioButtonActionPerformed

    private void useThreeCriteriajRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_useThreeCriteriajRadioButtonActionPerformed
        m_featureSelectionjComboBox_Criterium_1.setEnabled(true);
        m_featureSelectionjComboBox_Criterium_2.setEnabled(true);
        m_featureSelectionjComboBox_Criterium_3.setEnabled(true);
        
        m_minimumFeaturejLabel1.setEnabled(true);
        m_maximumFeaturejLabel1.setEnabled(true);
        m_minimumFeaturejLabel2.setEnabled(true);
        m_maximumFeaturejLabel2.setEnabled(true);
        m_minimumFeaturejLabel3.setEnabled(true);
        m_maximumFeaturejLabel3.setEnabled(true);
        
        m_minimumFeaturejLabel_Value_1.setEnabled(true);
        m_maximumFeaturejLabel_Value_1.setEnabled(true);
        m_minimumFeaturejLabel_Value_2.setEnabled(true);
        m_maximumFeaturejLabel_Value_2.setEnabled(true);
        m_minimumFeaturejLabel_Value_3.setEnabled(true);
        m_maximumFeaturejLabel_Value_3.setEnabled(true);
        
        m_first_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_first_Comparator_Criterium2_jComboBox.setEnabled( true );
        m_first_Comparator_Criterium3_jComboBox.setEnabled( true );
        
        m_second_Comparator_Criterium1_jComboBox.setEnabled( true );
        m_second_Comparator_Criterium2_jComboBox.setEnabled( true );
        m_second_Comparator_Criterium3_jComboBox.setEnabled( true );
        
        m_connector_Criterium_1_jComboBox.setEnabled(true);
        m_minimum_Criterium_1_jTextField.setEnabled(true);
        m_maximum_Criterium_1_jTextField.setEnabled(true);
        
        m_applyTwoCriteriajComboBox.setEnabled(true);
        m_applyThreeCriteriajComboBox.setEnabled(true);
        
        m_connector_Criterium_2_jComboBox.setEnabled(true);
        m_minimum_Criterium_2_TextField.setEnabled(true);
        m_maximum_Criterium_2_TextField.setEnabled(true);
        
        m_connector_Criterium_3_jComboBox.setEnabled(true);
        m_minimum_Criterium_3_TextField.setEnabled(true);
        m_maximum_Criterium_3_TextField.setEnabled(true);
        
        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium1_jComboBox.setEnabled(false);
            m_maximum_Criterium_1_jTextField.setEnabled(false);
            m_maximumFeaturejLabel1.setEnabled(false);
            m_maximumFeaturejLabel_Value_1.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium1_jComboBox.setEnabled(true);
            m_maximum_Criterium_1_jTextField.setEnabled(true);
            m_maximumFeaturejLabel1.setEnabled(true);
            m_maximumFeaturejLabel_Value_1.setEnabled(true);
        }
        
        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium2_jComboBox.setEnabled(false);
            m_maximum_Criterium_2_TextField.setEnabled(false);
            m_maximumFeaturejLabel2.setEnabled(false);
            m_maximumFeaturejLabel_Value_2.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium2_jComboBox.setEnabled(true);
            m_maximum_Criterium_2_TextField.setEnabled(true);
            m_maximumFeaturejLabel2.setEnabled(true);
            m_maximumFeaturejLabel_Value_2.setEnabled(true);
        }
        
        if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium3_jComboBox.setEnabled(false);
            m_maximum_Criterium_3_TextField.setEnabled(false);
            m_maximumFeaturejLabel3.setEnabled(false);
            m_maximumFeaturejLabel_Value_3.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium3_jComboBox.setEnabled(true);
            m_maximum_Criterium_3_TextField.setEnabled(true);
            m_maximumFeaturejLabel3.setEnabled(true);
            m_maximumFeaturejLabel_Value_3.setEnabled(true);
        }
        
    }//GEN-LAST:event_useThreeCriteriajRadioButtonActionPerformed

    private void m_connector_Criterium_1_jComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_connector_Criterium_1_jComboBoxActionPerformed
        String selectedFunction = m_connector_Criterium_1_jComboBox.getItemAt( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) );
        if ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium1_jComboBox.setEnabled(false);
            m_maximum_Criterium_1_jTextField.setEnabled(false);
            m_maximumFeaturejLabel1.setEnabled(false);
            m_maximumFeaturejLabel_Value_1.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium1_jComboBox.setEnabled(true);
            m_maximum_Criterium_1_jTextField.setEnabled(true);
            m_maximumFeaturejLabel1.setEnabled(true);
            m_maximumFeaturejLabel_Value_1.setEnabled(true);
        }
    }//GEN-LAST:event_m_connector_Criterium_1_jComboBoxActionPerformed

    private void m_connector_Criterium_2_jComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_connector_Criterium_2_jComboBoxActionPerformed
        String selectedFunction = m_connector_Criterium_2_jComboBox.getItemAt( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) );
        if ( m_connector_Criterium_2_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium2_jComboBox.setEnabled(false);
            m_maximum_Criterium_2_TextField.setEnabled(false);
            m_maximumFeaturejLabel2.setEnabled(false);
            m_maximumFeaturejLabel_Value_2.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium2_jComboBox.setEnabled(true);
            m_maximum_Criterium_2_TextField.setEnabled(true);
            m_maximumFeaturejLabel2.setEnabled(true);
            m_maximumFeaturejLabel_Value_2.setEnabled(true);
        }
    }//GEN-LAST:event_m_connector_Criterium_2_jComboBoxActionPerformed

    private void m_connector_Criterium_3_jComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_connector_Criterium_3_jComboBoxActionPerformed
        String selectedFunction = m_connector_Criterium_3_jComboBox.getItemAt( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) );
        if ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) == 0 )
        {   
            m_second_Comparator_Criterium3_jComboBox.setEnabled(false);
            m_maximum_Criterium_3_TextField.setEnabled(false);
            m_maximumFeaturejLabel3.setEnabled(false);
            m_maximumFeaturejLabel_Value_3.setEnabled(false);
        }
        else
        {
            m_second_Comparator_Criterium3_jComboBox.setEnabled(true);
            m_maximum_Criterium_3_TextField.setEnabled(true);
            m_maximumFeaturejLabel3.setEnabled(true);
            m_maximumFeaturejLabel_Value_3.setEnabled(true);
        }
    }//GEN-LAST:event_m_connector_Criterium_3_jComboBoxActionPerformed

    public static boolean isNumeric( String strNum ) 
    {
        if ( strNum == null ) 
        {
            return false;
        }
        if ( strNum.contains( "Infinity") || strNum.contains( "NaN") )
        {
            return false;
        }
        try 
        {
            float d = Float.parseFloat( strNum );
        } catch ( NumberFormatException nfe ) 
        {
            return false;
        }
        return true;
        
    }
    
    
    private void updateOverlayAccordingToCombobox_1( )
    {
        
        HashMap<String, Float>  map = new HashMap<>( );
        
        String selectedFunction = m_featureSelectionjComboBox_Criterium_1.getItemAt( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) );
        
        // test of the computation intensive map computation already took place 
        // if not, perform the computation ...
        if ( m_currentlySelectedCriterium1Type != m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) )
        {
            m_currentlySelectedCriterium1Type =  m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( );
            switch ( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) )
            {
                case  1: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Peak SNR
                case  2: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Magnitude Sum
                case  3: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Absorption Sum
                case  4: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 3.65, 3.85, 2.90, 3.10 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Regions ratio
                case  5: // m_model.getColorMap().createMap( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) );
                         m_valueMapCriterium1 =  m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Phase
                case  6: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD noise  
                case  7: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //FD noise
                case  8: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD max
                case  9: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD time of max
                case 10: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD mean 
                case 11: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Std Dev.
                case 12: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Skewness 
                case 13: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Kurtosis 
                case 14: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 15: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 16: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD PPM max
                case 17: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD mean      
                case 18: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Std. Dev.
                case 19: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Skewness                    
                case 20: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Kurtosis     
                case 21: m_valueMapCriterium1 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium1MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium1MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Mean SNR                         
                default: // Inform user that the selected function is not defined in this context!

            }
        }
        
        if ( isNumeric( "" + m_criterium1MinimumValue ) &&  isNumeric( "" + m_criterium1MaximumValue ) )
        {
            m_minimumFeaturejLabel_Value_1.setText( "" + m_criterium1MinimumValue );
            m_maximumFeaturejLabel_Value_1.setText( "" + m_criterium1MaximumValue );
            
            m_minimum_Criterium_1_jTextField.setText( "" + (int)m_criterium1MinimumValue );
            m_maximum_Criterium_1_jTextField.setText( "" + (int)m_criterium1MaximumValue );
            
            m_rangeMultiplier1 = 1.0f;

            float rangeCriterium1 = Math.abs( m_criterium1MaximumValue - m_criterium1MinimumValue );
            if ( ( rangeCriterium1 > 0.1 ) && ( rangeCriterium1 <= 1.0 ) )
            {
                m_rangeMultiplier1 = 1000.0f;
            }
            if ( ( rangeCriterium1 > 1.0 ) && ( rangeCriterium1 <= 10.0 ) )
            {
                m_rangeMultiplier1 = 100.0f;
            }
            if ( ( rangeCriterium1 > 10.0 ) && ( rangeCriterium1 < 100.0 ) )
            {
                m_rangeMultiplier1 = 10.0f;
            }

            criteriumOnejSliderLeft.removeChangeListener(this);
            criteriumOnejSliderRight.removeChangeListener(this);
            
            criteriumOnejSliderLeft.setMinimum( (int)( m_criterium1MinimumValue * m_rangeMultiplier1 ) );
            criteriumOnejSliderLeft.setMaximum( (int)( m_criterium1MaximumValue * m_rangeMultiplier1 ) );
            criteriumOnejSliderLeft.setValue( (int)m_criterium1MinimumValue );

            criteriumOnejSliderRight.setMaximum( (int)( m_criterium1MaximumValue * m_rangeMultiplier1 ) );
            criteriumOnejSliderRight.setMinimum( (int)( m_criterium1MinimumValue * m_rangeMultiplier1 ) );
            criteriumOnejSliderRight.setValue( (int)m_criterium1MaximumValue );
            
            criteriumOnejSliderLeft.addChangeListener(this);
            criteriumOnejSliderRight.addChangeListener(this);
            
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html>Selection criterion 1 is not possible:" + "<br><br>Error in computation of the selected feature map!</html>");
        }
    }
    
    
    boolean canSelectionBeComputed( )
    {
        boolean returnVal = true;
        
        if ( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) == 0 )
        {
            returnVal = false; 
        }
        
        if ( m_first_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 0 )
        {
            returnVal = false;
        }
        
        if ( ( m_connector_Criterium_1_jComboBox.getSelectedIndex( ) > 0 ) && 
             ( m_second_Comparator_Criterium1_jComboBox.getSelectedIndex( ) == 0 ) )
        {
            returnVal = false;
        }
        
        if ( useTwoCriteriajRadioButton.isSelected( ) == true && m_first_Comparator_Criterium2_jComboBox.getSelectedIndex( ) == 0 )
        {
             returnVal = false;
        }
        
        if ( ( useThreeCriteriajRadioButton.isSelected( ) == true && m_first_Comparator_Criterium3_jComboBox.getSelectedIndex( ) > 0 ) && 
             ( ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) > 0 ) && 
             ( m_second_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 0 ) ) )
        {
             returnVal = false;
        }
        
        if ( useThreeCriteriajRadioButton.isSelected( ) == true && m_first_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 0 )
        {
             returnVal = false;
        }
        
        if ( ( useThreeCriteriajRadioButton.isSelected( ) == true && m_first_Comparator_Criterium3_jComboBox.getSelectedIndex( ) > 0 ) && 
             ( ( m_connector_Criterium_3_jComboBox.getSelectedIndex( ) > 0 ) && 
             ( m_second_Comparator_Criterium3_jComboBox.getSelectedIndex( ) == 0 ) ) )
        {
             returnVal = false;
        }
        
        return returnVal;
        
    }
    
    
    private void updateOverlayAccordingToCombobox_2( )
    {
        
        HashMap<String, Float>  map = new HashMap<>( );
        
        String selectedFunction = m_featureSelectionjComboBox_Criterium_2.getItemAt( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ) );
        
        // test of the computation intensive map computation already took place 
        // if not, perform the computation ...
        if ( m_currentlySelectedCriterium2Type != m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ) )
        {
            m_currentlySelectedCriterium2Type =  m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( );
            switch ( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ) )
            {
                case  1: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Peak SNR
                case  2: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Magnitude Sum
                case  3: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Absorption Sum
                case  4: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 3.65, 3.85, 2.90, 3.10 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Regions ratio
                case  5: m_model.getColorMap( ).createMap( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) );
                         m_valueMapCriterium2 =  m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Phase
                case  6: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD noise  
                case  7: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //FD noise
                case  8: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD max
                case  9: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD time of max
                case 10: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD mean 
                case 11: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Std Dev.
                case 12: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Skewness 
                case 13: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Kurtosis 
                case 14: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 15: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 16: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD PPM max
                case 17: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD mean      
                case 18: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Std. Dev.
                case 19: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Skewness                    
                case 20: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Kurtosis     
                case 21: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Mean SNR                         
                default: // Inform user that the selected function is not defined in this context!

            }
        }
        
        if ( isNumeric( "" + m_criterium2MinimumValue ) &&  isNumeric( "" + m_criterium2MaximumValue ) )
        {
            m_minimumFeaturejLabel_Value_2.setText( "" + m_criterium2MinimumValue );
            m_maximumFeaturejLabel_Value_2.setText( "" + m_criterium2MaximumValue );
            
            m_minimum_Criterium_2_TextField.setText( "" + (int)m_criterium2MinimumValue );
            m_maximum_Criterium_2_TextField.setText( "" + (int)m_criterium2MaximumValue );
            
            m_rangeMultiplier2 = 1.0f;

            float rangeCriterium2 = Math.abs( m_criterium2MaximumValue - m_criterium2MinimumValue );
            if ( ( rangeCriterium2 > 0.1 ) && ( rangeCriterium2 <= 1.0 ) )
            {
                m_rangeMultiplier2 = 1000.0f;
            }
            if ( ( rangeCriterium2 > 1.0 ) && ( rangeCriterium2 <= 10.0 ) )
            {
                m_rangeMultiplier2 = 100.0f;
            }
            if ( ( rangeCriterium2 > 10.0 ) && ( rangeCriterium2 < 100.0 ) )
            {
                m_rangeMultiplier2 = 10.0f;
            }

            criteriumTwojSliderLeft.removeChangeListener(this);
            criteriumTwojSliderRight.removeChangeListener(this);
            
            criteriumTwojSliderLeft.setMinimum( (int)( m_criterium2MinimumValue * m_rangeMultiplier2 ) );
            criteriumTwojSliderLeft.setMaximum( (int)( m_criterium2MaximumValue * m_rangeMultiplier2 ) );
            criteriumTwojSliderLeft.setValue( (int)m_criterium2MinimumValue );

            criteriumTwojSliderRight.setMaximum( (int)( m_criterium2MaximumValue * m_rangeMultiplier2 ) );
            criteriumTwojSliderRight.setMinimum( (int)( m_criterium2MinimumValue * m_rangeMultiplier2 ) );
            criteriumTwojSliderRight.setValue( (int)m_criterium2MaximumValue );
            
            criteriumTwojSliderLeft.addChangeListener(this);
            criteriumTwojSliderRight.addChangeListener(this);
            
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html>Selection criterion 2 is not possible:" + "<br><br>Error in computation of the selected feature map!</html>");
        }
    }

    
    private void updateOverlayAccordingToCombobox_3( )
    {
        
        HashMap<String, Float>  map = new HashMap<>( );
        
        String selectedFunction = m_featureSelectionjComboBox_Criterium_3.getItemAt( m_featureSelectionjComboBox_Criterium_2.getSelectedIndex( ) );
        
        // test of the computation intensive map computation already took place 
        // if not, perform the computation ...
        if ( m_currentlySelectedCriterium3Type != m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( ) )
        {
            m_currentlySelectedCriterium3Type =  m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( );
            switch ( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( ) )
            {
                case  1: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Peak SNR
                case  2: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1 , 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Magnitude Sum
                case  3: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Absorption Sum
                case  4: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 3.65, 3.85, 2.90, 3.10 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Regions ratio
                case  5: m_model.getColorMap( ).createMap( m_featureSelectionjComboBox_Criterium_1.getSelectedIndex( ) );
                         m_valueMapCriterium3 =  m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //Phase
                case  6: m_valueMapCriterium2 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD noise  
                case  7: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //FD noise
                case  8: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD max
                case  9: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; //TD time of max
                case 10: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD mean 
                case 11: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium2MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium2MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Std Dev.
                case 12: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Skewness 
                case 13: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Kurtosis 
                case 14: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 15: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD max
                case 16: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD PPM max
                case 17: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD mean      
                case 18: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Std. Dev.
                case 19: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Skewness                    
                case 20: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // FD Kurtosis     
                case 21: m_valueMapCriterium3 = m_model.getColorMap( ).getMapValues( m_featureSelectionjComboBox_Criterium_3.getSelectedIndex( )-1, 1.0, 5.0 );
                         m_criterium3MinimumValue = m_model.getColorMap( ).getMin( );
                         m_criterium3MaximumValue = m_model.getColorMap( ).getMax( );
                         break; // TD Mean SNR                         
                default: // Inform user that the selected function is not defined in this context!

            }
        }
        
        if ( isNumeric( "" + m_criterium3MinimumValue ) &&  isNumeric( "" + m_criterium3MaximumValue ) )
        {
            m_minimumFeaturejLabel_Value_3.setText( "" + m_criterium3MinimumValue );
            m_maximumFeaturejLabel_Value_3.setText( "" + m_criterium3MaximumValue );
            
            m_minimum_Criterium_3_TextField.setText( "" + (int)m_criterium3MinimumValue );
            m_maximum_Criterium_3_TextField.setText( "" + (int)m_criterium3MaximumValue );
            
            m_rangeMultiplier3 = 1.0f;

            float rangeCriterium3 = Math.abs( m_criterium3MaximumValue - m_criterium3MinimumValue );
            if ( ( rangeCriterium3 > 0.1 ) && ( rangeCriterium3 <= 1.0 ) )
            {
                m_rangeMultiplier3 = 1000.0f;
            }
            if ( ( rangeCriterium3 > 1.0 ) && ( rangeCriterium3 <= 10.0 ) )
            {
                m_rangeMultiplier3 = 100.0f;
            }
            if ( ( rangeCriterium3 > 10.0 ) && ( rangeCriterium3 < 100.0 ) )
            {
                m_rangeMultiplier3 = 10.0f;
            }

            criteriumThreejSliderLeft.removeChangeListener(this);
            criteriumThreejSliderRight.removeChangeListener(this);
            
            criteriumThreejSliderLeft.setMinimum( (int)( m_criterium3MinimumValue * m_rangeMultiplier3 ) );
            criteriumThreejSliderLeft.setMaximum( (int)( m_criterium3MaximumValue * m_rangeMultiplier3 ) );
            criteriumThreejSliderLeft.setValue( (int)m_criterium3MinimumValue );

            criteriumThreejSliderRight.setMaximum( (int)( m_criterium3MaximumValue * m_rangeMultiplier3 ) );
            criteriumThreejSliderRight.setMinimum( (int)( m_criterium3MinimumValue * m_rangeMultiplier3 ) );
            criteriumThreejSliderRight.setValue( (int)m_criterium3MaximumValue );
            
            criteriumThreejSliderLeft.addChangeListener(this);
            criteriumThreejSliderRight.addChangeListener(this);
            
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html>Selection criterion 3 is not possible:" + "<br><br>Error in computation of the selected feature map!</html>");
        }
    }
        
    /**
     * @param args the command line arguments
     */
    public static void main( String args[] ) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FeatureBasedGridSelectionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FeatureBasedGridSelectionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FeatureBasedGridSelectionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FeatureBasedGridSelectionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new FeatureBasedGridSelectionJFrame( null ).setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JSlider criteriumOnejSliderLeft;
    private javax.swing.JSlider criteriumOnejSliderRight;
    private javax.swing.JSlider criteriumThreejSliderLeft;
    private javax.swing.JSlider criteriumThreejSliderRight;
    private javax.swing.JSlider criteriumTwojSliderLeft;
    private javax.swing.JSlider criteriumTwojSliderRight;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JComboBox<String> m_applyThreeCriteriajComboBox;
    private javax.swing.JComboBox<String> m_applyTwoCriteriajComboBox;
    private javax.swing.JButton m_applyjButton;
    private javax.swing.JComboBox<String> m_connector_Criterium_1_jComboBox;
    private javax.swing.JComboBox<String> m_connector_Criterium_2_jComboBox;
    private javax.swing.JComboBox<String> m_connector_Criterium_3_jComboBox;
    private javax.swing.JComboBox<String> m_featureSelectionjComboBox_Criterium_1;
    private javax.swing.JComboBox<String> m_featureSelectionjComboBox_Criterium_2;
    private javax.swing.JComboBox<String> m_featureSelectionjComboBox_Criterium_3;
    private javax.swing.JComboBox<String> m_first_Comparator_Criterium1_jComboBox;
    private javax.swing.JComboBox<String> m_first_Comparator_Criterium2_jComboBox;
    private javax.swing.JComboBox<String> m_first_Comparator_Criterium3_jComboBox;
    private javax.swing.JLabel m_maximumFeaturejLabel1;
    private javax.swing.JLabel m_maximumFeaturejLabel2;
    private javax.swing.JLabel m_maximumFeaturejLabel3;
    private javax.swing.JLabel m_maximumFeaturejLabel_Value_1;
    private javax.swing.JLabel m_maximumFeaturejLabel_Value_2;
    private javax.swing.JLabel m_maximumFeaturejLabel_Value_3;
    private javax.swing.JTextField m_maximum_Criterium_1_jTextField;
    private javax.swing.JTextField m_maximum_Criterium_2_TextField;
    private javax.swing.JTextField m_maximum_Criterium_3_TextField;
    private javax.swing.JLabel m_minimumFeaturejLabel1;
    private javax.swing.JLabel m_minimumFeaturejLabel2;
    private javax.swing.JLabel m_minimumFeaturejLabel3;
    private javax.swing.JLabel m_minimumFeaturejLabel_Value_1;
    private javax.swing.JLabel m_minimumFeaturejLabel_Value_2;
    private javax.swing.JLabel m_minimumFeaturejLabel_Value_3;
    private javax.swing.JTextField m_minimum_Criterium_1_jTextField;
    private javax.swing.JTextField m_minimum_Criterium_2_TextField;
    private javax.swing.JTextField m_minimum_Criterium_3_TextField;
    private javax.swing.JButton m_previewFilterEffectjButton;
    private javax.swing.JButton m_quitjButton;
    private javax.swing.JComboBox<String> m_second_Comparator_Criterium1_jComboBox;
    private javax.swing.JComboBox<String> m_second_Comparator_Criterium2_jComboBox;
    private javax.swing.JComboBox<String> m_second_Comparator_Criterium3_jComboBox;
    private javax.swing.JRadioButton useOneCriteriumjRadioButton;
    private javax.swing.JRadioButton useThreeCriteriajRadioButton;
    private javax.swing.JRadioButton useTwoCriteriajRadioButton;
    // End of variables declaration//GEN-END:variables

    @Override
    public void stateChanged( ChangeEvent e ) 
    {
       if ( e.getSource( ) == this.criteriumOnejSliderLeft )
       {
            if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumOnejSliderLeft" );
                    this.m_minimum_Criterium_1_jTextField.setText( "" + ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier1 );
                    computeFilteredSelection( m_valueMapCriterium1 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }       
            }
       }
       
       if ( e.getSource( ) == this.criteriumOnejSliderRight )
       {
            if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumOnejSliderRight" );
                    this.m_maximum_Criterium_1_jTextField.setText( "" + ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier1 );
                    computeFilteredSelection( m_valueMapCriterium1 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }
            }
       }
       
       if ( e.getSource( ) == this.criteriumTwojSliderLeft )
       {
           if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumTwojSliderLeft" );
                    this.m_minimum_Criterium_2_TextField.setText( "" + ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier2 );
                    computeFilteredSelection( m_valueMapCriterium2 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }
                
            }
       }
       
       if ( e.getSource( ) == this.criteriumTwojSliderRight )
       {
         if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumTwojSliderRight" );
                    this.m_maximum_Criterium_2_TextField.setText( "" + ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier2 );
                    computeFilteredSelection( m_valueMapCriterium2 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }
            }
       }
       
       if ( e.getSource( ) == this.criteriumThreejSliderLeft )
       {
          if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumThreejSliderLeft" );
                    this.m_minimum_Criterium_3_TextField.setText( "" + ( ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier3 ) );
                    computeFilteredSelection( m_valueMapCriterium3 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }
            }
       }
       
       if ( e.getSource( ) == this.criteriumThreejSliderRight )
       {
            if ( !( (JSlider)e.getSource( ) ).getValueIsAdjusting( ) ) 
            {
                if ( canSelectionBeComputed( ) )
                {
                    System.out.println( "criteriumThreejSliderRight" );
                    this.m_maximum_Criterium_3_TextField.setText( "" + ( ((JSlider)e.getSource( ) ).getValue( ) / m_rangeMultiplier3 ) );
                    computeFilteredSelection( m_valueMapCriterium3 );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "<html>Not enough information available for overlay computation:" + "<br><br>No valid selection logic: fully state selection criterium!</html>");
                    return;
                }
            }
       }
        
    }
}
