/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.grid;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

/**
 *
 * @author user
 */
public class PrecisionPolygon extends Polygon {

    public int precision;

    public PrecisionPolygon(int precision) {
        this.precision = precision;
    }

    public PrecisionPolygon(double[] doubles, double[] doubles1, int i, int precision) {
        super();
        int[] ints = new int[doubles.length];
        int[] ints1 = new int[doubles1.length];
        this.precision = precision;
        for (int j = 1; j < doubles.length; j++) {
            this.addPoint((int) Math.round(doubles[j] * precision), (int) Math.round(doubles1[j] * precision));
        }
    }

    public PrecisionPolygon(ArrayList<double[]> plg, int precision){
        super();
        this.precision = precision;
        for(double[] pt:plg)
        {
            this.addPoint((int) Math.round(pt[0] * (double)precision), (int) Math.round(pt[1] * (double)precision));
        }
    }

    public PrecisionPolygon(PrecisionPolygon pgn, int precision){
        super();
        this.precision = precision;
        for(int i = 0; i < pgn.npoints; i++)
        {
            this.addPoint((int) Math.round((double)pgn.xpoints[i] /(double) pgn.precision * (double)precision), (int) Math.round((double)pgn.ypoints[i] / (double)pgn.precision * (double)precision));
        }
    }

    @Override
    public boolean contains(Point point) {
        Point pointaux = new Point(point.x * precision, point.y * precision);
        return super.contains(pointaux); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean contains(Point2D pd) {
        Point pointaux = new Point((int) Math.round(pd.getX()*precision), (int) Math.round(pd.getY()*precision));
        return super.contains(pointaux); //To change body of generated methods, choose Tools | Templates.
    }

    public void addPoint(double d, double d1) {
        super.addPoint((int) Math.round(d * precision), (int) Math.round(d1 * precision)); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean contains(int i, int i1) {
        return super.contains(i * precision, i1 * precision); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean contains(double d, double d1) {
        return super.contains(d * precision, d1 * precision); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean contains(double d, double d1, double d2, double d3) {
        return super.contains(d * precision, d1 * precision, d2 * precision, d3 * precision); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean contains(Rectangle2D rd) {
        return super.contains(rd); //To change body of generated methods, choose Tools | Templates.
    }

    public Point getScaledPoint( Point input, float rescaleFactX, float rescaleFactY )
    {
        Point retPoint = new Point( (int) Math.round( input.x * ( rescaleFactX / (double) precision ) ), 
                                    (int) Math.round( input.y * ( rescaleFactY / (double) precision ) ) );
        return retPoint;
    }
    
  
    public Polygon getRescaledPolygon(double rescaleFactX, double rescaleFactY) {
        Polygon pol = new Polygon();
        for (int i = 0; i < this.npoints; i++) {
            pol.addPoint(   (int) Math.round(((double) this.xpoints[i]) * rescaleFactX / (double) precision),
                            (int) Math.round(((double) this.ypoints[i]) * rescaleFactY / (double) precision));
        }
        return pol;
    }

    public PrecisionPolygon getScaled(double s)
    {
        PrecisionPolygon prcPlg = new PrecisionPolygon(precision);
        for(int i = 0;i<npoints;i++)
        {
            double x = ((double)xpoints[i] / (double)precision * s);
            double y = ((double)ypoints[i] / (double)precision * s);
            prcPlg.addPoint(x, y);
        }
        return prcPlg;
    }

    public PrecisionPolygon getScaledXY(double sx, double sy)
    {
        PrecisionPolygon prcPlg = new PrecisionPolygon(precision);
        for(int i = 0;i<npoints;i++)
        {
            double x = ((double)xpoints[i] / (double)precision * sx);
            double y = ((double)ypoints[i] / (double)precision * sy);
            prcPlg.addPoint(x, y);
        }
        return prcPlg;
    }
}
