
#include <jni.h>
#include "callNativeC.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    JNIEXPORT jobjectArray JNICALL
    Java_org_spectrim_hlsvd_1_NativeC_callNativeC(
            JNIEnv *env,
            jobject obj,
            jstring signal_name_java,
            jint ndp,
            jdouble step,
            jdouble larmor,
            jobjectArray str_str_java,
            jobjectArray str_int_java,
            jobjectArray str_dbl_java) 
    {

            const char *signal_name = (*env)->GetStringUTFChars(env, signal_name_java, 0);
            int name_len;
            name_len = strlen(signal_name);

            printf("Hello in callNativeC");
            printf("\n");
            printf("%s ", signal_name);
            printf("\n");
            printf("%d ", name_len);
            printf("\n");
            printf("%d ", ndp);
            printf("\n");
            printf("%10.2E ", step);
            printf("\n");
            printf("%10.2E ", larmor);
            printf("\n");

            int n;
            jstring tmp_string;

            int str_len = (*env)->GetArrayLength(env, str_str_java);
            int int_len = (*env)->GetArrayLength(env, str_int_java);
            int dbl_len = (*env)->GetArrayLength(env, str_dbl_java);

            int return_len = str_len + int_len + dbl_len + 1;
            char  *str_return[return_len];
            str_return[0] = "Return from callNativeC";

            char  *str_native[str_len];
            int    int_native[int_len];
            double dbl_native[dbl_len];

            for( n = 0; n < str_len; n++ )
            {
                tmp_string          = (jstring) (*env)->GetObjectArrayElement(env, str_str_java, n);
                const char *str_str = (*env)->GetStringUTFChars(env, tmp_string, 0);
                char *copy_str_str  = malloc(strlen(str_str) + 1);
                strcpy(copy_str_str, str_str);
                str_return[n+1]     = copy_str_str;
                str_native[n]       = copy_str_str;
            }
            for( n = 0; n < int_len; n++ )
            {
                tmp_string          = (jstring) (*env)->GetObjectArrayElement(env, str_int_java, n);
                const char *str_int = (*env)->GetStringUTFChars(env, tmp_string, 0);
                char *copy_str_int  = malloc(strlen(str_int) + 1);
                strcpy(copy_str_int, str_int);
                str_return[n+str_len+1] = copy_str_int;
                int_native[n]       = atoi((*env)->GetStringUTFChars(env, tmp_string, 0));
            }
            for( n = 0; n < dbl_len; n++ )
            {
                tmp_string          = (jstring) (*env)->GetObjectArrayElement(env, str_dbl_java, n);
                const char *str_dbl = (*env)->GetStringUTFChars(env, tmp_string, 0);
                char *copy_str_dbl  = malloc(strlen(str_dbl) + 1);
                strcpy(copy_str_dbl, str_dbl);
                str_return[n+str_len+int_len+1] = copy_str_dbl;
                dbl_native[n]       = strtod((*env)->GetStringUTFChars(env, tmp_string, 0), NULL);
            }

            const char *str_native0 = str_native[0];
            const char *str_native1 = str_native[1];
            const char *str_native2 = str_native[2];
            const char *str_native3 = str_native[3];
            const char *str_native4 = str_native[4];
            const char *str_native5 = str_native[5];

            int str0_len, str1_len, str2_len, str3_len, str4_len, str5_len;

            str0_len = strlen(str_native0);
            str1_len = strlen(str_native1);
            str2_len = strlen(str_native2);
            str3_len = strlen(str_native3);
            str4_len = strlen(str_native4);
            str5_len = strlen(str_native5);

            callfortran_( signal_name, &name_len, &ndp, &step, &larmor,
                          &str0_len, &str1_len, &str2_len, &str3_len, &str4_len, &str5_len,
                          str_native0, str_native1, str_native2, str_native3, str_native4, str_native5,
                          &int_len, &dbl_len, int_native, dbl_native );

            jstring str;
            jobjectArray ret = 0;

            int i;
            ret = (*env)->NewObjectArray(env, return_len, (*env)->FindClass(env, "java/lang/String"), 0);
            for( i = 0; i < return_len; i++ )
            {
                str = (*env)->NewStringUTF( env, str_return[i] );
                (*env)->SetObjectArrayElement(env, ret, i, str);
            }

            return ret;

    }

    
    JNIEXPORT jdoubleArray JNICALL Java_org_spectrim_hlsvd_1_NativeC_getSignal
        (JNIEnv *env, jobject)
    {
        jdoubleArray outDoubleArray = 0;
        outDoubleArray = (*env)->NewDoubleArray(env, 1024);
        return outDoubleArray;
    }