/*
 * File: $Id: Dicom3DSlicerControlApp.java,v 1.3 2006/09/01 09:13:10 hans Exp $
 * History
 * Date: 03.05.2006  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2006 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */


/*
 * Dicom3DSlicerControlApp.java
 *
 * Created on May 3, 2006, 12:51 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.imagegraphicobjects;

import org.spectrim.dicom.Dicom3DSlicerControl;
import org.spectrim.dicom.DicomNetworkListenerPropertiesFrame;
import org.spectrim.dicom.DicomNetworkNodeDefinerAndSelectionFrame;
import org.spectrim.dicom.DicomSeriesSelectorFrame;
import org.spectrim.lib.BrainVoyagerFBRFileParserAndLoader;
import org.spectrim.lib.BrainVoyagerVOIFileParserAndLoader;
import org.spectrim.lib.Credits;
import org.spectrim.lib.StatusPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.LinkedList;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author hans
 */
public class Dicom3DSlicerControlApp extends JFrame implements ActionListener
{

    /** 
     * Creates a new instance of Dicom3DSlicerControlApp 
     */
    public Dicom3DSlicerControlApp( ) 
    {
        
        m_slicerControl = new Dicom3DSlicerControl( this );
        m_slicerControl.addActionListener( this );
        
        m_scrollPane = new JScrollPane( m_slicerControl, 
                                        JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
                                        JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED ); 
        m_statusPanel = new StatusPanel( this );
        
        this.getContentPane( ).setLayout( new BorderLayout( ) );
   
        this.getContentPane( ).add( m_scrollPane, BorderLayout.CENTER );
        this.getContentPane( ).add( m_statusPanel, BorderLayout.SOUTH );
        
        // setContentPane( m_slicerControl );
        createMenuBar( );
        
        // add window listener necessary to handle the window closing 
        // event properly
        addWindowListener( 
            new WindowAdapter( )
            {
                @Override
                public void windowClosing( WindowEvent event )
                {
                   //System.exit( 0 );
                   dispose( );
                }
            }
        );
        
        pack( );
        setVisible( true );   
    }
    

    /** 
     * Creates a new instance of Dicom3DSlicerControlApp 
     */
    public Dicom3DSlicerControlApp( LinkedList<String> fileReferences,
                                    boolean[][][] activationImageOverlays,
                                    boolean[][][] dtiFiberImageOverlays,
                                    Color[][][] dtiFiberColors )
    {
        m_slicerControl = new Dicom3DSlicerControl( this );
        m_slicerControl.addActionListener( this );
        
        m_scrollPane = new JScrollPane( m_slicerControl, 
                                        JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
                                        JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED ); 
        
        m_statusPanel = new StatusPanel( this );
        
        this.getContentPane( ).setLayout( new BorderLayout( ) );
        
        this.getContentPane( ).add( m_scrollPane, BorderLayout.CENTER );
        this.getContentPane( ).add( m_statusPanel, BorderLayout.SOUTH );
        
        // setContentPane( m_slicerControl );
        createMenuBar( );
        
        // add window listener necessary to handle the window closing 
        // event properly
        addWindowListener( 
            new WindowAdapter( )
            {
                @Override
                public void windowClosing( WindowEvent event )
                {
                   //System.exit( 0 );
                   dispose( );
                }
            }
        );
        
        pack( );
        setVisible( true );
        
        m_slicerControl.setDicom3DFileReferences( fileReferences, activationImageOverlays,
                                                  dtiFiberImageOverlays, dtiFiberColors );
    
    }
    
    
    
    /**
     * Creates a menubar for the FitGuru application
     */
    private void createMenuBar( )
    {
        
        m_menuBar = new JMenuBar( );
        
        // File menu
        m_dicomMenu = new JMenu( "Dicom" );
        
        m_load3DDataset = new JMenuItem( "Load 3D Dataset .." );
        m_load3DDataset.addActionListener( this );
        
        m_load2DImageSeries = new JMenuItem( "Load 2D Imageseries .." );
        m_load2DImageSeries.addActionListener( this );
        m_load2DImageSeries.setEnabled( false );

        m_quitApp = new JMenuItem( "Quit application" );
        m_quitApp.addActionListener( this );
        
        m_dicomMenu.add( m_load3DDataset );
        m_dicomMenu.add( m_load2DImageSeries );

        m_reformatDICOMImagesMenu = new JMenu( "Reformat and write DICOM images");

        m_reformatAndWriteImagesOfView12MenuItem = new JMenuItem( "Reformat and write images of upperleft view to DICOM-files" );
        m_reformatAndWriteImagesOfView12MenuItem.addActionListener( this );
        m_reformatDICOMImagesMenu.add( m_reformatAndWriteImagesOfView12MenuItem );

        m_reformatAndWriteImagesOfView13MenuItem = new JMenuItem( "Reformat and write images of upperright view to DICOM-files" );
        m_reformatAndWriteImagesOfView13MenuItem.addActionListener( this );
        m_reformatDICOMImagesMenu.add( m_reformatAndWriteImagesOfView13MenuItem );

        m_reformatAndWriteImagesOfView23MenuItem = new JMenuItem( "Reformat and write images of lower left view to DICOM-files" );
        m_reformatAndWriteImagesOfView23MenuItem.addActionListener( this );
        m_reformatDICOMImagesMenu.add( m_reformatAndWriteImagesOfView23MenuItem );
        
        m_dicomMenu.add( m_reformatDICOMImagesMenu );

        m_dicomNetwork = new JMenu( "Dicomize and sent to network nodes" );

        m_dicomMenu.add( m_dicomNetwork );

        // define the menu items of the network..
        m_defineDicomNetworkNodesMenuItem = new JMenuItem( "Dicom network node properties ..");
        m_defineDicomNetworkNodesMenuItem.addActionListener( this );
        m_dicomNetwork.add( m_defineDicomNetworkNodesMenuItem );


        m_startDicomNetworkListener = new JMenuItem( "Dicom Network listener .." );
        m_startDicomNetworkListener.addActionListener( this );
        m_dicomNetwork.add( m_startDicomNetworkListener );

        m_sentDicomizedUpperLeftImageStackToDicomNodeMenuItem = new JMenuItem( "Dicomize & send upper-left slice-stack to selected remote dicom node" );
        m_sentDicomizedUpperLeftImageStackToDicomNodeMenuItem.addActionListener( this );
        m_dicomNetwork.add( m_sentDicomizedUpperLeftImageStackToDicomNodeMenuItem  );

        m_sentDicomizedUpperRightImageStackToDicomNodeMenuItem = new JMenuItem( "Dicomize & send upper-right slice-stack to selected remote dicom node" );
        m_sentDicomizedUpperRightImageStackToDicomNodeMenuItem.addActionListener( this );
        m_dicomNetwork.add( m_sentDicomizedUpperRightImageStackToDicomNodeMenuItem  );

        m_sentDicomizedLowerLeftImageStackToDicomNodeMenuItem = new JMenuItem( "Dicomize & send lower-left slice-stack to selected remote dicom node" );
        m_sentDicomizedLowerLeftImageStackToDicomNodeMenuItem.addActionListener( this );
        m_dicomNetwork.add( m_sentDicomizedLowerLeftImageStackToDicomNodeMenuItem  );

        m_dicomMenu.add( m_quitApp );

        m_overlayMenu = new JMenu( "Overlays" );

        m_loadBrainVoyagerDTIOverlay = new JMenuItem( "Import Brainvoyger DTI overlay (.fbr)" );
        m_loadBrainVoyagerDTIOverlay.addActionListener( this );
        m_loadBrainVoyagerDTIOverlay.setEnabled( false );

        m_loadBrainVoyagerFMRIOverlay = new JMenuItem( "Import Brainvoyger fMRI overlay (.voi)" );
        m_loadBrainVoyagerFMRIOverlay.addActionListener( this );
        m_loadBrainVoyagerFMRIOverlay.setEnabled( false );

        m_overlayMenu.add( m_loadBrainVoyagerFMRIOverlay );
        m_overlayMenu.add( m_loadBrainVoyagerDTIOverlay );

        // Help menu
        m_helpMenu = new JMenu( "Help" );
        
        m_aboutFitGuru = new JMenuItem( "About 3D-slicer" );
        m_aboutFitGuru.addActionListener( this );
        m_helpMenu.add( m_aboutFitGuru );
        
        m_menuBar.add( m_dicomMenu );
        m_menuBar.add( m_overlayMenu );
        m_menuBar.add( m_helpMenu );
        
        setJMenuBar( m_menuBar );        
    }

   
     /**
     * Called whenever a registered component raises an ActionEvent
     */
    public void actionPerformed( ActionEvent e )
    {
        Object sender = e.getSource( );
        
        if ( sender == m_aboutFitGuru )
        {
            Credits credits = new Credits( m_parent, "Simple 3D slicer tool" );
        }

        if ( sender == m_reformatAndWriteImagesOfView12MenuItem )
        {
            m_slicerControl.handleRegriddingOfImagesStack_1_2_InWorkerThread( );
        }

        if ( sender == m_reformatAndWriteImagesOfView13MenuItem )
        {
             m_slicerControl.handleRegriddingOfImagesStack_1_3_InWorkerThread( );
        }

        if ( sender == m_reformatAndWriteImagesOfView23MenuItem )
        {
             m_slicerControl.handleRegriddingOfImagesStack_2_3_InWorkerThread( );
        }

        if ( sender == m_defineDicomNetworkNodesMenuItem )
        {
            DicomNetworkNodeDefinerAndSelectionFrame dicomNodesFrame = new DicomNetworkNodeDefinerAndSelectionFrame( this );
        }

        if ( sender == m_sentDicomizedUpperLeftImageStackToDicomNodeMenuItem )
        {
            m_slicerControl.handleDicomizationOfImagesStack_1_2( );   
        }

        if ( sender == m_sentDicomizedUpperRightImageStackToDicomNodeMenuItem )
        {
            m_slicerControl.handleDicomizationOfImagesStack_1_3( );
        }


        if ( sender == m_sentDicomizedLowerLeftImageStackToDicomNodeMenuItem )
        {
            m_slicerControl.handleDicomizationOfImagesStack_2_3( );
        }

        if ( sender == m_startDicomNetworkListener )
        {

            if ( m_dicomNetworkListenerPropertiesFrame == null )
            {
                m_dicomNetworkListenerPropertiesFrame = new DicomNetworkListenerPropertiesFrame( this );
            }
            else
            {
                m_dicomNetworkListenerPropertiesFrame.setVisible( true );
            }
        }

        if ( sender ==  m_loadBrainVoyagerFMRIOverlay )
        {
            importBrainvoyagerVOIFileAsImageOverlay( );
        }

        if ( sender ==  m_loadBrainVoyagerDTIOverlay )
        {
            importBrainvoyagerFBRFileAsImageOverlay( );
        }

        if ( sender == m_slicerControl )
        {
            if ( e.getID( ) == m_slicerControl.THREE_D_VIEWER_DATASET_LOADED )
            {
                m_loadBrainVoyagerDTIOverlay.setEnabled( true );
                m_loadBrainVoyagerFMRIOverlay.setEnabled( true );
            }
        }

        if ( sender == m_quitApp )
        {
            dispose( );
            //System.exit( 0 );
        }
        
        if ( sender == m_load3DDataset )
        {
            m_dicomFileSelectorFrame = new DicomSeriesSelectorFrame( this );
            m_dicomFileSelectorFrame.addActionListener( this );
            
        }
        
        if ( sender == m_load2DImageSeries )
        {
            m_dicomFileSelectorFrame.setVisible( true );
        }
        
        
        if ( sender == m_dicomFileSelectorFrame )
        {   
            if ( m_load2DImageSeries.isEnabled( ) == false )
            {
                m_slicerControl.setDicom3DFileReferences( m_dicomFileSelectorFrame.getSelectedDicomFileReferences( ), null, null, null  );

                m_loadBrainVoyagerDTIOverlay.setEnabled( true );
                m_loadBrainVoyagerFMRIOverlay.setEnabled( true );

                m_load2DImageSeries.setEnabled( true );
            }
            else
            {
                m_slicerControl.setFourthViewFileReferences( m_dicomFileSelectorFrame.getSelectedDicomFileReferences( ) );
            }
        }
    }

    /**
     * Returns the filename and directory selected by the user
     */
    private String getBrainVoyagerVOIFilePathAndName( String defaultString, String buttonText )
    {

        FileNameExtensionFilter voiFilter = new FileNameExtensionFilter( "VOI file", "voi", "VOI" );


        JFileChooser fileChooser = new JFileChooser( );
        String selectedFilePathAndName = "";

        // only image file can be choosen!
        fileChooser.addChoosableFileFilter( voiFilter );

        // Create a File object containing the canonical path of the
        // desired directory

        String filePath = System.getProperty( "user.dir" );

        File f = new File( filePath );

        // Set the current directory
        fileChooser.setCurrentDirectory( f );

        int result;
        //fileChooser.setSelectedFile( new File( patientName+ "_" + examinationDate + "_" + defaultString ) );

        result = fileChooser.showDialog( this, defaultString );

        File selected_file = new File( "" );

        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_file = fileChooser.getSelectedFile( );
                                                selectedFilePathAndName = selected_file.getPath( );
                                                break;
            case JFileChooser.CANCEL_OPTION:    // Cancel or close dialog was selected
                                                break;
            case JFileChooser.ERROR_OPTION:     // the selected process did not terminate properly
                                                break;
        }

        return selectedFilePathAndName;
    }

     /**
     * Returns the filename and directory selected by the user
     */
    private String getBrainVoyagerFBRFilePathAndName( String defaultString, String buttonText )
    {

        FileNameExtensionFilter voiFilter = new FileNameExtensionFilter( "FBR file", "fbr", "FBR" );


        JFileChooser fileChooser = new JFileChooser( );
        String selectedFilePathAndName = "";

        // only image file can be choosen!
        fileChooser.addChoosableFileFilter( voiFilter );

        // Create a File object containing the canonical path of the
        // desired directory

        String filePath = System.getProperty( "user.dir" );

        File f = new File( filePath );

        // Set the current directory
        fileChooser.setCurrentDirectory( f );

        int result;
        //fileChooser.setSelectedFile( new File( patientName+ "_" + examinationDate + "_" + defaultString ) );

        result = fileChooser.showDialog( this, defaultString );

        File selected_file = new File( "" );

        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_file = fileChooser.getSelectedFile( );
                                                selectedFilePathAndName = selected_file.getPath( );
                                                break;
            case JFileChooser.CANCEL_OPTION:    // Cancel or close dialog was selected
                                                break;
            case JFileChooser.ERROR_OPTION:     // the selected process did not terminate properly
                                                break;
        }

        return selectedFilePathAndName;
    }

    /**
     * Loads the BrainVoyager overlay file containing fMRI activation maps
     * which can be overlayed onto a 3D dataset which currently loaded.
     * @return
     */
    private boolean importBrainvoyagerVOIFileAsImageOverlay( )
    {

        String voiFile = getBrainVoyagerVOIFilePathAndName( "Brainvoyager - fMRI-activation voi-file", "Import" );



        BrainVoyagerVOIFileParserAndLoader voiLoader = new BrainVoyagerVOIFileParserAndLoader( voiFile,  
                                                                                               m_slicerControl.getOriginalNumberOfImages( ),
                                                                                               m_slicerControl.getOriginalImageWidth( ),
                                                                                               m_slicerControl.getOriginalImageHeight( ) );

        boolean[][][] b = voiLoader.loadBrainVoyagerVOIFile( );
        
        m_slicerControl.setfMRIActiovationOverlays( b );

        return true;
    }


    /**
     * Loads a BrainVoyager FBR file and fiber overlay positions and
     * the fiber directions as color codings
     * @return
     */
    private boolean importBrainvoyagerFBRFileAsImageOverlay( )
    {

        String fbrFile = getBrainVoyagerFBRFilePathAndName( "Brainvoyager - DTI-fiber fbr-file", "Import" );

        BrainVoyagerFBRFileParserAndLoader fbrLoader = new BrainVoyagerFBRFileParserAndLoader( fbrFile,  
                                                                                               m_slicerControl.getOriginalNumberOfImages( ), 
                                                                                               m_slicerControl.getOriginalImageWidth( ), 
                                                                                               m_slicerControl.getOriginalImageHeight( ) );

        boolean[][][] pos  = fbrLoader.loadBrainVoyagerFBRFile( );
        Color[][][] colors = fbrLoader.getOverlayColors( );

        m_slicerControl.setDTIFiberOverlays( pos, colors );

        return true;
    }


    /**
     * Entry point of the 3D slicer
     */
    public static void main( String[] args )
    {
        Dicom3DSlicerControlApp theApp = new Dicom3DSlicerControlApp( );
    }
    
    // Attributes
    private Dicom3DSlicerControl m_slicerControl;
    
    private JMenuBar  m_menuBar;
    
    private JMenu m_dicomMenu;
    private JMenu m_overlayMenu;

    private JMenuItem m_loadBrainVoyagerDTIOverlay;
    private JMenuItem m_loadBrainVoyagerFMRIOverlay;

    private JMenu m_helpMenu;
    private JMenu m_dicomNetwork;
    private JMenu m_reformatDICOMImagesMenu;

    private JMenuItem m_reformatAndWriteImagesOfView12MenuItem;
    private JMenuItem m_reformatAndWriteImagesOfView13MenuItem;
    private JMenuItem m_reformatAndWriteImagesOfView23MenuItem;

    private JMenuItem m_defineDicomNetworkNodesMenuItem;
    private JMenuItem m_startDicomNetworkListener;
    private JMenuItem m_sentDicomizedUpperLeftImageStackToDicomNodeMenuItem;
    private JMenuItem m_sentDicomizedLowerLeftImageStackToDicomNodeMenuItem;
    private JMenuItem m_sentDicomizedUpperRightImageStackToDicomNodeMenuItem;

    private DicomNetworkListenerPropertiesFrame m_dicomNetworkListenerPropertiesFrame;

    private JMenuItem m_load3DDataset;
    private JMenuItem m_load2DImageSeries;
    private JMenuItem m_quitApp;
    private JMenuItem m_aboutFitGuru;
    
    private StatusPanel  m_statusPanel;
    
    private DicomSeriesSelectorFrame m_dicomFileSelectorFrame;
    

    private JFrame m_parent;

    private JScrollPane m_scrollPane;

    // For proper serialization
    private static final long serialVersionUID = 1282225998121223L;
}
