/*
 * ImageCrossLines.java
 *
 * Created on May 5, 2006, 9:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.imagegraphicobjects;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
 *
 * Class the draws itself on a Dicom slice canvas
 *
 * @author hans
 */
public class ImageCrossLines 
{
    
    /** 
     * Creates a new instance of ImageCrossLines 
     */
    public ImageCrossLines( int imageWidth, int imageHeight, 
                            int startHorizontalPosition, int startVerticalPosition, 
                            Color horizontalDisplayColor, Color verticalDisplayColor )
    {
        m_imageWidth = imageWidth;
        m_imageHeigth = imageHeight;
        m_horizontalCrossPosition = startHorizontalPosition;
        m_verticalCrossPosition = startVerticalPosition;
        m_horizontalDisplayColor = horizontalDisplayColor;
        m_verticalDisplayColor = verticalDisplayColor;
    }
    
    /**
     * Sets the new center of the cross
     */
    public void setZoom( float zoom )
    {
        m_imageWidth = (int)( m_imageWidth * zoom );
        m_imageHeigth = (int)( m_imageHeigth * zoom );
        m_horizontalCrossPosition = (int)( m_horizontalCrossPosition * zoom );
        m_verticalCrossPosition = (int)( m_verticalCrossPosition * zoom );
    }
    
    /**
     * Sets the new center of the cross
     */
    public void setCenter( int horPos, int vertPos )
    {
        m_horizontalCrossPosition = horPos;
        m_verticalCrossPosition = vertPos;
    }
    
    /**
     * Draws itself on a graphics context g
     */
    public void paint( Graphics g )
    {
        m_graphics = g;
        
        Color oldColor = g.getColor( );
        Rectangle rect = g.getClipBounds( );
        
        g.setColor( m_horizontalDisplayColor );
        // Horizontal lines
        g.drawLine( 0, m_verticalCrossPosition, m_horizontalCrossPosition - 5, m_verticalCrossPosition );
        g.drawLine( m_horizontalCrossPosition + 5, m_verticalCrossPosition, m_imageWidth, m_verticalCrossPosition );
        
        g.setColor( m_verticalDisplayColor );
        // Vertical lines
        g.drawLine( m_horizontalCrossPosition, 0, m_horizontalCrossPosition,  m_verticalCrossPosition - 5 );
        g.drawLine( m_horizontalCrossPosition,  m_verticalCrossPosition + 5,  m_horizontalCrossPosition, m_imageHeigth );
        
        g.setColor( oldColor );
    }
    
    /**
     * Draws itself on a graphics context g
     */
    public void paint( Graphics g, int horPos, int vertPos )
    {
        setCenter( horPos, vertPos );
        paint( g );
    }
    
    /**
     * Does the painting of the cross
     */
    public void paint( )
    {
        paint( m_graphics );
    }
    
    /**
     * Sets only the Y coordinate of the cross
     */
    public void setCenterY( int Ycoord )
    {
        m_verticalCrossPosition = Ycoord;
        paint();
    }
    
    /**
     * Sets only the X coordinate of the cross
     */
    public void setCenterX( int Xcoord )
    {
        m_horizontalCrossPosition = Xcoord;
        paint();
    }

    // Attributes
    private int m_imageWidth;
    private int m_imageHeigth;
    private int m_horizontalCrossPosition;
    private int m_verticalCrossPosition;
    
    private Color m_horizontalDisplayColor; 
    private Color m_verticalDisplayColor;
    
    private Graphics m_graphics;
    
}
