package org.spectrim.io.dicom;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author nunopbarros
 */
public class DicomHeader {

    private HashMap<String, DicomHeaderLine> data = new HashMap<>();

    public void put(String string, DicomHeaderLine line) {
        data.put(string, line);
    }

    ;
    
    public DicomHeaderLine get(String string) {
        return data.get(string);
    }
    
    public void clear(){
        data.clear();
    }

    public Set keySet() {
        return data.keySet();
    }
    
    public int size(){
        return data.size();
    }

    public void write2file(String fileOUTname, boolean hideValues) throws FileNotFoundException, UnsupportedEncodingException {
        PrintWriter writer = new PrintWriter(fileOUTname, "UTF-8");
        writer.println("# Tag" + "\t" + "VR" + "\t" + "Name" + "\t" + "VM" + "\t" + "Version");
        Set keys = data.keySet();
        DicomHeaderLine line;
        Iterator iter = keys.iterator();
        while (iter.hasNext()) {
            String tag = (String) iter.next();
            line = (DicomHeaderLine) this.get(tag);
            if (hideValues) {
                writer.println(tag + "\t" + line.VR + "\t" + line.Name + "\t" + line.VM + "\t" + "Version?");
            } else {
                if (line.Value == null && line.ValueByte != null) {
                    writer.println(tag + "\t" + line.VR + "\t" + line.Name + "\t" + line.VM + "\t" + "Version?" + "\t" + line.ValueByte.toString());
                } else if (line.Value != null) {
                    writer.println(tag + "\t" + line.VR + "\t" + line.Name + "\t" + line.VM + "\t" + "Version?" + "\t" + line.Value);
                }
            }
        }
        writer.close();
    }

    public void print() {
        Iterator iter = keySet().iterator();
        while (iter.hasNext()) {
            DicomHeaderLine line = (DicomHeaderLine) iter.next();
            String tagName = line.Name;
            String tagVR = line.VR;
            String tagVM = line.VM;
            String tagValue = line.Value;

            if (tagName.contains("Pixel Data") || tagName.contains("Request Attributes Sequence") || tagName.contains("Referenced Image Sequence")) {
                System.out.println(tagName + " [" + tagVR + "] " + tagVM + "  **##DATA##**");
            } else {
                System.out.println(tagName + " [" + tagVR + "] " + " [" + tagValue + "]" + tagVM);
            }

        }
    }
    
    public int getInstanceNumber(){
        return Integer.valueOf(this.get("(0020,0013)").Value);
    }
}
