/*
 * File: $Id: ColumnSorter.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 28.09.2004  Authors: Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

/*
 * ColumnSorter.java
 *
 * Created on September 28, 2004, 8:36 AM
 */

package org.spectrim.lib;

import java.util.Comparator;
import java.util.Vector;

/**
 *
 * @author  hans
 */

// This comparator is used to sort vectors of data
public class ColumnSorter implements Comparator 
{
    private int colIndex;
    private boolean ascending;
    
    public ColumnSorter( int colIndex, boolean ascending ) 
    {
        this.colIndex = colIndex;
        this.ascending = ascending;
    }
    
    /**
     * Implements the compare function
     */    
    public int compare( Object a, Object b ) 
    {
        Vector v1 = (Vector)a;
        Vector v2 = (Vector)b;
        Object o1 = v1.get(colIndex);
        Object o2 = v2.get(colIndex);
    
        // Treat empty strains like nulls
        if ( o1 instanceof String && ((String)o1).length() == 0 ) 
        {
            o1 = null;
        }
        if ( o2 instanceof String && ((String)o2).length() == 0 ) 
        {
            o2 = null;
        }
    
        // Sort nulls so they appear last, regardless
        // of sort order
        if ( o1 == null && o2 == null ) 
        {
            return 0;
        } 
        else if ( o1 == null ) 
        {
                return 1;
        } 
        else if ( o2 == null ) 
        {
            return -1;
        } 
        else if (o1 instanceof Comparable) 
        {
            if ( ascending ) 
            {
                return ( (Comparable)o1 ).compareTo(o2);
            } 
            else 
            {
                return ( (Comparable)o2 ).compareTo(o1);
            }
        } 
        else 
        {
            if ( ascending ) 
            {
                return o1.toString().compareTo(o2.toString());
            } 
            else 
            {
                return o2.toString().compareTo(o1.toString());
            }
        }
    }
}
