/*
 * File: $Id: Credits.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 30. November 2002, 08:03  Authors: Martin Buerki - Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.lib;


import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Rectangle;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class Credits extends JDialog implements ActionListener 
{

    public Credits( JFrame parent, String subTooldescription )
    {

        super( parent, "About SCANalyze-tools", true );

        this.m_parent = parent;
        this.getContentPane( ).setLayout( new GridLayout( 0, 1 ) );
        this.getContentPane( ).add( new JLabel( subTooldescription + " based on : " , JLabel.CENTER ) );
        this.getContentPane( ).add( new JLabel( "Test version" + " " + "0.1", JLabel.CENTER ) );
        this.getContentPane( ).add( new JLabel( "(c) 2017", JLabel.CENTER ) );
        this.getContentPane( ).add( new JLabel( "Institute for Diagnostic and Interventional Neuroradiology", JLabel.CENTER ) );
        this.getContentPane( ).add( new JLabel( "University Hospital of Berne - Switzerland", JLabel.CENTER ) );
        this.getContentPane( ).add( new JLabel( "Suggestions and remarks are welcome to:", JLabel.CENTER )  );
        this.getContentPane( ).add( new JLabel( "johannes.slotboom@gmail.com", JLabel.CENTER ) );
        this.getContentPane( ).add( m_bOK = new JButton( "   OK   " ) );
        m_bOK.addActionListener( this );
        pack( );
    }

    /**
     * Shows the frame in modal mode
     */
    public void showModal( )
    {
        centerToParent( );
        setVisible( true );
    }

    @Override
    public Dimension getMinimumSize( ) 
    {
        return new Dimension( 350, 200 );
    }

    @Override
    public Dimension getPreferredSize( )
    {
        if ( isValid( ) )
        {
            return super.getPreferredSize( );
        }
        else
        {
            return getMinimumSize( );
        }
    }

    /**
     * Centers the control in the center of the parent
     */
    private void centerToParent( )
    {
        setSize( getPreferredSize( ) );
        Dimension d = getSize( );
        Rectangle r = m_parent.getBounds( );
        setLocation( r.x + ( r.width - d.width ) /2 ,
                     r.y + ( r.height - d.height ) / 2 );
    }

    public void actionPerformed( ActionEvent e )
    {
        setVisible( false );
    }

    // Attributes
    private JButton m_bOK;
    private JFrame m_parent;
    
    // For proper serialization
    private static final long serialVersionUID = 1481295812349123L;

}
