/*
 * File: $Id: QuestionDialog.java,v 1.1.1.1 2006/04/19 09:38:50 hans Exp $
 * History
 * Date: 30. November 2002, 10:34  Authors: Martin Buerki / Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.lib;

import java.awt.BorderLayout;
import java.awt.FontMetrics;
import java.awt.Rectangle;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JButton;

  
public class QuestionDialog extends JDialog 
{

    private final JLabel question;
    private boolean answer;
    private final JFrame parent;
    
    // Must be declarated somehow
    private static final long serialVersionUID = 3287495895813493L;
    
    public QuestionDialog( JFrame parent ) 
    {
	super( parent, "Question", false );
	setSize( 200,100 );
	this.parent = parent;
        this.getContentPane( ).setLayout( new BorderLayout( ) );
	question = new JLabel( );
	question.setAlignmentX( JLabel.CENTER );
        question.setAlignmentY( JLabel.CENTER );
	//qqq  add( "Center", question );
        getContentPane( ).add( question, BorderLayout.CENTER );
	// add( "South", new buttonPanel( this ) );
        getContentPane( ).add( new buttonPanel( this ),  BorderLayout.SOUTH );
        
        pack( );
    }

    /**
     * The question of to be asked in the question dialog can be formulated 
     * here.
     * @param text
     * @return 
     */
    public boolean ask( String text ) 
    {
	question.setText( text );
	FontMetrics fm = question.getFontMetrics( question.getFont( ) );
	int w = fm.stringWidth( text ) + 50;
	int h = 100;
	Rectangle r = parent.getBounds( );
	setBounds( r.x+( r.width - w )/2, r.y + ( r.height - h )/2, w, h );
	// System.out.print("\u0007");
	Toolkit.getDefaultToolkit( ).beep( );
	setVisible( true );
	return answer;
    }
    
    /**
     * Creates the button panel.
     */
    class buttonPanel extends JPanel implements ActionListener 
    {
	QuestionDialog dlg;
	private final JButton bOK;
	private final JButton bCancel;
        
        // Must be declared somewhere.
        private static final long serialVersionUID = 3487415895813493L;
	
        public buttonPanel( QuestionDialog owner ) 
        {
	    dlg = owner;
	    bOK = new JButton( "OK" );
	    bOK.addActionListener( this );
	    add( bOK );
	    bCancel = new JButton( "Cancel" );
	    bCancel.addActionListener( this );
	    add( bCancel );
	}

        @Override
	public void actionPerformed( ActionEvent e ) 
        {
	    if ( e.getSource( ) == bOK ) 
            {
		dlg.answer = true;
	    }
	    else if ( e.getSource( ) == bCancel )
            {
		dlg.answer = false;
	    }
	    else 
            {
		return;
	    }
	    dlg.setVisible( false );
	}
    }
}