/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.main;

import java.util.HashMap;

/**
 * SpectrIm side implementation of Voxel Metabolites.
 * @author Johannes Slotboom <johannes.slotboom at insel.ch>
 */
public class VoxelMetabolites implements VoxelMetabolitesInterface
{
    private HashMap<String, MetaboliteFeatures> metabolites = new HashMap<>( ); // metabolite                                                                                                                                                            // features
    private double globalError;

    public VoxelMetabolites( ) 
    {
    }

    /**
     * Add a metabolite as well as its features to the collection of metabolites.
     */
    @Override
    public void addMetabolite( String metab, MetaboliteFeatures features ) 
    {
        metabolites.put( metab, features );
    }

    /**
     * Set the global quantitation error for the spectra.
     */
    @Override
    public void setGlobalError( double globalError ) 
    {
        this.globalError = globalError;
    }

    /**
     * Get the global quantitation error for the spectra.
     */
    @Override
    public double getGlobalError( ) 
    {
        return globalError;
    }

    /**
     * Returns the metabolite features for the given metabolite.
     */
    @Override
    public MetaboliteFeatures getFeatures( String metab ) 
    {
        if ( metabolites.containsKey( metab ) )
        {
            return metabolites.get( metab );
        }
        else
        {
            return null;
        }
    }
    
    /**
     * Returns the MetaboliteFeatures Object of the current voxel.
     * @return 
     */
    @Override
    public HashMap<String, MetaboliteFeatures> getMetabFeatures( ) 
    {
        return metabolites;
    }
} 
