/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.main;

import java.util.HashMap;

/**
 * Interface that enables the definition of fitting results in jMRUI as
 * well as in SpiectrIm.
 * @author Johannes Slotboom <johannes.slotboom at insel.ch>
 */
public interface VoxelMetabolitesInterface 
{
    /**
     * Add a metabolite as well as its features to the collection of metabolites.
     * @param metab
     * @param features
     */
    public void addMetabolite( String metab, MetaboliteFeatures features ); 
  
    /**
     * Set the global quantitation error for the spectra.
     * @param globalError
     */
    public void setGlobalError( double globalError ); 

    /**
     * Get the global quantitation error for the spectra.
     * @return 
     */
    public double getGlobalError( ); 
  
    /**
     * Returns the metabolite features for the given metabolite.
     * @param metab
     * @return 
     */
    public MetaboliteFeatures getFeatures( String metab ); 
   
    /**
     * Returns the MetaboliteFeatures Object of the current voxel.
     * @return 
     */
    public HashMap<String, MetaboliteFeatures> getMetabFeatures( ); 

}
