/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.patientbrowser;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;

/**
 *
 * @author nunopbarros
 */
public class Series {

    private String description;
    private String seriesNr;
    private String date;
    private String UID;
    private int modality;
    private int orientation;
    private boolean isSpectroscopy;
    private LinkedList<String> files = new LinkedList<>( );
    

    public Series(String name, String number, String UID, String date, int modality, boolean isSpectrum, int orientation) {
        this.description = name;
        
        if ( number.compareTo( "N.A." ) != 0 )
        {
            int seriesNumber = new Integer( number.trim( ) );
            if ( seriesNumber < 10 )
            {
                seriesNr = "000000" + seriesNumber;
            }
            else if ( seriesNumber < 100 )
            {
                seriesNr = "00000" + seriesNumber;
            }    
            else if ( seriesNumber < 1000 )
            {
                seriesNr = "0000" + seriesNumber;
            }
            else if ( seriesNumber < 10000 )
            {
                seriesNr = "000" + seriesNumber;
            }
            else if ( seriesNumber < 100000 )
            {
                seriesNr = "00" + seriesNumber;
            }
            else if ( seriesNumber < 1000000 )
            {
                seriesNr = "0" + seriesNumber;
            }
            else if ( seriesNumber < 10000000 )
            {
                seriesNr = "" + seriesNumber;
            }
        }
        else
        {
            seriesNr = "N.A.";
        }          
        
        // this.seriesNr = number;
        this.UID = UID;
        this.date = date;
        this.modality = modality;
        this.orientation = orientation;
        this.isSpectroscopy = isSpectrum;
    }

    public LinkedList<String> getFiles() {
        return files;
    }

    public void addFile(String file) {
        this.files.add(file);
    }

    public String getDescription() {
        return description;
    }

    public String getSeriesNr() {
        return seriesNr;
    }

    public String getUID() {
        return UID;
    }

    public String getDate() {
        return date;
    }

    public int getModality() {
        return modality;
    }
    
    public int getOrientation(){
        return orientation;
    }
    
    public boolean isSpectroscopy() {
        return isSpectroscopy;
    }
}
