/*
 * DatabaseConnectionSettings.java
 *
 * Created on December 1, 2006, 9:41 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.patientdatabase;

/**
 * Data container class storing the currently defined  
 * @author hans
 */
public class DatabaseConnectionSettings 
{
    
    /** 
     * Creates a new instance of DatabaseConnectionSettings 
     */
    private DatabaseConnectionSettings( ) 
    {
        // Set defaults
        m_databaseName = "din_spectro_db";
        m_databaseIP  = "127.0.0.1";
        m_databasePort = "3306";
        m_loginName = "root";
        m_loginPassword = "rotterdam";
    }
    
    
    /**
     * Returns the one and onnly instance of DatabaseConnectionSettings
     */
    public static DatabaseConnectionSettings getInstance( )
    {
        if ( theInstance == null )
        {
            theInstance = new DatabaseConnectionSettings( );
        }
        return theInstance;
    }
    
    /**
     * Returns the current database name
     */
    public String getDatabaseName( )
    {
        return m_databaseName;
    }
    
    /**
     * Returns the current database host tcp/ip address
     */
    public String getDatabaseIP( )
    {
        return m_databaseIP;
    }
    
    /**
     * Returns the current database port number
     */
    public String getDatabasePort( )
    {
        return m_databasePort;
    }
    
    /**
     * Returns the current database login name
     */
    public String getDatabaseLoginName( )
    {
        return m_loginName;
    }
    
    /**
     * Returns the current database login password
     */
    public String getDatabaseLoginPassword( )
    {
        return m_loginPassword;
    }
    
    /**
     * Sets the current database name
     */
    public void setDatabaseName( String dbName )
    {
        m_databaseName = dbName;
    }
    
    /**
     * Sets the current database host tcp/ip address
     */
    public void setDatabaseIP( String databaseIP )
    {
        m_databaseIP = databaseIP;
    }
    
    /**
     * Sets the current database port number
     */
    public void setDatabasePort( String databasePort )
    {
        m_databasePort = databasePort;
    }
    
    /**
     * Sets the current database login name
     */
    public void setDatabaseLoginName( String loginName )
    {
        m_loginName = loginName;
    }
    
    /**
     * Sets the current database login password
     */
    public void setDatabaseLoginPassword( String loginPassword )
    {
        m_loginPassword = loginPassword;
    }
    
     // static private attribute is the instance itself (Singleton!)
    private static DatabaseConnectionSettings theInstance = null;
    
    private String m_databaseName;
    private String m_databaseIP;
    private String m_databasePort;
    
    private String m_loginName;
    private String m_loginPassword;
    
}
