/*
 * OpsirisDatabaseConnection.java
 *
 * Created on October 18, 2006, 2:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.patientdatabase;

import java.sql.Statement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 *
 * @author hans
 */
public class MRSpectroscopyDatabaseConnection
{
    
     private Connection m_connection;
    
    /** 
     * Creates a new instance of OpsirisDatabaseConnection 
     */
    public MRSpectroscopyDatabaseConnection( ) 
    {
        init( );
    }

    /**
     * Initializes the class
     */
    public void init( )
    {
        try
        {
        
            Class.forName( "com.mysql.jdbc.Driver" );
            DatabaseConnectionSettings dbSettings = DatabaseConnectionSettings.getInstance( );
            String dBaseCon = "jdbc:mysql://" + dbSettings.getDatabaseIP( ) + "/" + dbSettings.getDatabaseName( );
            
            m_connection=DriverManager.getConnection( dBaseCon,
                                                      dbSettings.getDatabaseLoginName( ), 
                                                      dbSettings.getDatabaseLoginPassword( ) );
        }
        catch ( Exception e )
        {
            System.out.println( "Failed to get connection" );
            e.printStackTrace( );
        }
    }
    
    
    /**
     * Returns the connection to the database
     */
    public Connection getMyConnection( )
    {
        return m_connection;
    }
    
    /**
     * Closes the connection
     */
    public void close( ResultSet rs ) 
    {
        
        if( rs != null )
        {
            try
            {
               rs.close( );
            }
            catch( Exception e )
            {
            }
        }
    }
    
    /**
     * Closes statement
     */
    public void close( java.sql.Statement stmt )
    {
        
        if ( stmt !=null )
        {
            try
            {
               stmt.close( );
            }
            catch( Exception e )
            {
            }
        }
    }
    
    /**
     * Destroys myConnection
     */
    public void destroy( )
    {
  
        if( m_connection != null )
        {
            try
            {
                m_connection.close( );
            }
            catch( Exception e )
            {
                // not caught yet
            }
        }
    }
    
    /**
     * Sets the PreparedStatement
     */
    public PreparedStatement prepareStatement( String sql )
    {
        PreparedStatement ps = null;
        try 
        {    
        
            ps =  m_connection.prepareStatement( sql );
        }
        catch ( SQLException e ) 
        {
            // not caught yet
        }
        
        return ps;
    }
    
    /**
     * Sets the PreparedStatement
     */
    public Statement createStatement( )
    {
        Statement ps = null;
        try 
        {    
        
            ps =  m_connection.createStatement( );
        }
        catch ( SQLException e ) 
        {
            // not caught yet
        }
        
        return ps;
    }
    
}
