/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.process;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.List;
import org.spectrim.registration.OutputListener;

/**
 * LGPL
 */
public class ProcessBuilderWrapper {

    private StringWriter infos;
    private StringWriter errors;
    private int status;

    public ProcessBuilderWrapper(File directory, List command, OutputListener listener) throws Exception {
        infos = new StringWriter();
        errors = new StringWriter();
        ProcessBuilder pb = new ProcessBuilder(command);
        if (directory != null) {
            pb.directory(directory);
        }
        pb.redirectErrorStream(true);
        Process process = pb.start();
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(new BufferedOutputStream(process.getOutputStream())), true);
        writer.flush();
        StreamBoozer seInfo = new StreamBoozer(process.getInputStream(), new PrintWriter(infos, true),listener);
        StreamBoozer seError = new StreamBoozer(process.getErrorStream(), new PrintWriter(errors, true),listener);
        seError.start();
        seInfo.start();
        status = process.waitFor();
        seInfo.join();
        seError.join();
    }


    public ProcessBuilderWrapper(List command) throws Exception {
        this(null, command, null);
    }

    public ProcessBuilderWrapper(List command, OutputListener listener) throws Exception {
        this(null, command, listener);
    }

    public String getErrors() {
        return errors.toString();
    }

    public String getInfos() {
        return infos.toString();
    }

    public int getStatus() {
        return status;
    }
}
