/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.randomforestregression;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import org.spectrim.tdfdfit.MRFitStrategy;
import org.spectrim.xyplot.XYPlotFrame;
import org.spectrim.tdfdfit.MRLineModelParameters;
import org.spectrim.tdfdfit.MRLineModelSpectralResponse;
import org.spectrim.tdfdfit.MRSignalProperties;
import org.spectrim.tdfdfit.OrderedBaseLinePointsDataModel;
import org.spectrim.tdfdfit.SingleVoxelMeasuredSpectralData;
import org.spectrim.tdfdfit.TDFDFitPrototypeModelSpectrumParameters;
import org.spectrim.tdfdfit.TDFDFittingDefaults;
import org.spectrim.xyplot.Curve;

/**
 *
 * @author Brigitte
 */
public class DataReaderVerification {
         
//    private String path = System.getProperty("user.home");
      
//    private String m_predictedParamFile = path + System.getProperty("file.separator") + "table_predictions_5paramenters_txt.txt"; 
//    private String m_initialFile = path + System.getProperty("file.separator") + "testOutput_forTD_txt.txt";
     
    private static Random rnd = new Random();
    private static MRSignalProperties m_MRSignalProperties;
    private static File m_TDFDfitPrototypeModelFileReference;
    private static MRFitStrategy m_fitStrategy;

    private static SingleVoxelMeasuredSpectralData m_singleVoxelMeasuredData;
    private static SingleVoxelMeasuredSpectralData m_singleVoxelMeasuredDataLoaded;
    
      private static final OrderedBaseLinePointsDataModel m_baseLineModel = OrderedBaseLinePointsDataModel.getInstance();
    
//    float[] listPredArea;
//    float[] listPredFrequency;
//    float[] listPredGaussWidth;
//    float[] listPredPhase;
//    float[] listPredLorentzWidth;
    
//    float[] listInitArea;
//    float[] listInitFrequency;
//    float[] listInitGaussWidth;
//    float[] listInitPhase;
//    float[] listInitLorentzWidth;
    
    private List<Float> listPredArea;
    private List<Float> listPredFrequency;
    private List<Float> listPredGaussWidth;
    private List<Float> listPredPhase;
    private List<Float> listPredLorentzWidth;
         
    private List<Float> listInitArea;
    private List<Float> listInitFrequency;
    private List<Float> listInitGaussWidth;
    private List<Float> listInitPhase;
    private List<Float> listInitLorentzWidth;
    private List<Float> listOrigSignal;
    
    public static void main(String[] args) throws IOException {
        DataReaderVerification dataReader = new DataReaderVerification();
   
    }

    public DataReaderVerification() throws IOException {
        
        this.listPredArea = new ArrayList<>();
        this.listPredFrequency = new ArrayList<>();
        this.listPredGaussWidth = new ArrayList<>();
        this.listPredPhase = new ArrayList<>();
        this.listPredLorentzWidth = new ArrayList<>();
        
        
        this.listInitArea = new ArrayList<>();
        this.listInitFrequency = new ArrayList<>();
        this.listInitGaussWidth = new ArrayList<>();
        this.listInitPhase = new ArrayList<>();
        this.listInitLorentzWidth = new ArrayList<>();
        this.listOrigSignal = new ArrayList<>();
        TDFDFittingDefaults defs = TDFDFittingDefaults.getInstance();
        defs.load( );
        defs.setProperty( TDFDFittingDefaults.DISPLAY_UNIT, TDFDFittingDefaults.FREQUENCY_DOMAIN_POINTS );
        defs.save( );
         
        modelReader( );
    }

    public void modelReader( ) throws IOException   
    {
        // read the initial and predicted parameters from the .txt files
        readPredictedAndInitialParametersFromFile("table_predictions_5paramenters_txt","testOutput_forTD_txt", "savedSignal_4");
        
        m_TDFDfitPrototypeModelFileReference = new File("C:\\Users\\Brigitte\\.SpectrImClinicalQMRS\\TDFDFit\\TDFDFit_FitModelsDir\\RFR3\\RFR3.tfm");

        boolean interactive = false;
        loadTDFDFitPrototypeModel(interactive);
        
//        // plot original signal 
//        XYPlotFrame plotOrig = new XYPlotFrame( "plot orig signal", null );
//        plotOrig.addCurve( new Curve( origRe,origIm, Color.BLUE ), false );
               
        
        // Predicted response       
        LinkedList<MRLineModelParameters> myLines = TDFDFitPrototypeModelSpectrumParameters.getInstance().getSimpleMRLines();
        MRLineModelParameters linePars = myLines.get(0);
        MRLineModelParameters lineParsVar = new MRLineModelParameters(linePars);
        
        // set the line param var using the predicted values
        for( int i= 0; i< 10; i++){
            lineParsVar.setArea(listPredArea.get(i));
            lineParsVar.setGaussianWidth(listPredGaussWidth.get(i));
            lineParsVar.setLorentzianWidth(listPredLorentzWidth.get(i));
            lineParsVar.setPhase(listPredPhase.get(i));
            lineParsVar.setOffset(listPredFrequency.get(i));
//        }
        
            MRLineModelSpectralResponse myPredResponse = new MRLineModelSpectralResponse(lineParsVar.getMRFittingParameters(),MRSignalProperties.getInstance());
          
           Curve myCurve = myPredResponse.getAbsorptionCurveFDPoints();
           myCurve.setColor(Color.blue);
           XYPlotFrame pFrame = new XYPlotFrame("One line predicted model", null);

          pFrame.addCurve(myCurve, false);
        }
        
//        Curve myCurve = myPredResponse.getAbsorptionCurveFDPPM();
//        myCurve.setColor(Color.blue);
//        XYPlotFrame pFrame = new XYPlotFrame("One line predicted model", null);
//
//        pFrame.addCurve(myCurve, false);
         
        
//      add noise to the model
//        float[] abs = myPredResponse.getAbsorptionChannelTD();
//        float[] disp = myPredResponse.getDispersionChannelTD();
//
//        for (int i = 0; i < abs.length; i++) {
//            abs[i] = abs[i] + (0.5f - rnd.nextFloat()) * 100000;
//            disp[i] = disp[i] + (0.5f - rnd.nextFloat()) * 100000;
//        }

//      add the noise on the top of the other frame using another curve
//        Curve myNoiseCurve;
//
//        myPredResponse.setSpectralDataPointsTD(abs,disp);  
//        myNoiseCurve = myPredResponse.getAbsorptionCurveFDPPM();
//        myNoiseCurve.setColor(Color.red);
//        
//        pFrame.addCurve(myNoiseCurve, false);  
        
    
        LinkedList<MRLineModelParameters> myInitLines = TDFDFitPrototypeModelSpectrumParameters.getInstance().getSimpleMRLines();
        MRLineModelParameters lineInitPars = myInitLines.get(0);
        MRLineModelParameters lineInitParsVar = new MRLineModelParameters(lineInitPars);

    
       // Initial response - the ground truth
       // set the line param var using the initial values
        for( int i= 0; i< listInitArea.size(); i++){
            lineInitParsVar.setArea(listInitArea.get(i));
            lineInitParsVar.setGaussianWidth(listInitGaussWidth.get(i));
            lineInitParsVar.setLorentzianWidth(listInitLorentzWidth.get(i));
            lineInitParsVar.setPhase(listInitPhase.get(i));
            lineInitParsVar.setOffset(listInitFrequency.get(i));
        }
        
        MRLineModelSpectralResponse myInitialResponse = new MRLineModelSpectralResponse(lineInitParsVar.getMRFittingParameters(),MRSignalProperties.getInstance());       
        Curve myInitialCurve = myInitialResponse.getAbsorptionCurveFDPPM();             
        myInitialCurve.setColor(Color.green);
        
        XYPlotFrame pInitialFrame = new XYPlotFrame("One line model - Plot data", null);
        
        pInitialFrame.addCurve(myInitialCurve, false);
        
        
        //    add noise to the model
        float[] abs_init = myInitialResponse.getAbsorptionChannelTD();
        float[] disp_init = myInitialResponse.getDispersionChannelTD();

        for (int i = 0; i < abs_init.length; i++) {
            abs_init[i] = abs_init[i] + (0.5f - rnd.nextFloat()) * 100000;
            disp_init[i] = disp_init[i] + (0.5f - rnd.nextFloat()) * 100000;
        }

//      add the noise on the top of the other frame using another curve
        Curve myNoiseInitialCurve;

        myInitialResponse.setSpectralDataPointsTD(abs_init,disp_init);  
        myNoiseInitialCurve = myInitialResponse.getAbsorptionCurveFDPPM();
        myNoiseInitialCurve.setColor(Color.red);
        
        pInitialFrame.addCurve(myNoiseInitialCurve, false);  
        
        // print the STD for initial and predicted param
        printSTDforInitialAndPredictedParam();
    }  
        
    public void readPredictedAndInitialParametersFromFile( String predictedFileName, String initialFileName, String origSignal) throws FileNotFoundException, IOException{
        
         BufferedReader predFile = new BufferedReader(new FileReader(System.getProperty("user.home") + System.getProperty("file.separator") + predictedFileName + ".txt"));
         BufferedReader initFile = new BufferedReader(new FileReader(System.getProperty("user.home") + System.getProperty("file.separator") + initialFileName + ".txt"));
         BufferedReader savedSignal = new BufferedReader(new FileReader(System.getProperty("user.home") + System.getProperty("file.separator") + origSignal + ".txt"));
         
         String linesPredFile = predFile.readLine();
         String linesInitFile = initFile.readLine();
         String linesOrigSignal = savedSignal.readLine();
         
         String[] columnsPredFile = linesPredFile.split(",");
         String[] columnsInitFile = linesInitFile.split(",");
         String[] columnsOrigSignal = linesOrigSignal.split(",");
          
         float[] origIm = new float[2048];
         float[] origRe = new float[2048];  //linesOrigSignal.length()
         
         float[] xaxis = new float[2048]; 
         int cntr = 0;
         
        try{      
                      
//       order in predicted values table: predicted_area,predicted_frequency,predicted_phase,predicted_lorentz_width,predicted_gauss_width
            while ((linesPredFile = predFile.readLine()) != null) {
                 
                 columnsPredFile = linesPredFile.split(",");
         
                 listPredArea.add(Float.parseFloat(columnsPredFile[0]));
                 listPredFrequency.add(Float.parseFloat(columnsPredFile[1]));
                 listPredPhase.add(Float.parseFloat(columnsPredFile[2]));
                 listPredLorentzWidth.add(Float.parseFloat(columnsPredFile[3]));
                 listPredGaussWidth.add(Float.parseFloat(columnsPredFile[4]));
                 }
                 
         
//       order in initial table:  area,frequency,gauss_width,zero_phase,lorentz_width,FQN
            while ((linesInitFile = initFile.readLine()) != null) {
               
                 columnsInitFile = linesInitFile.split(",");
                 
                 listInitArea.add(Float.parseFloat(columnsInitFile[0]));
                 listInitFrequency.add(Float.parseFloat(columnsInitFile[1]));
                 listInitGaussWidth.add(Float.parseFloat(columnsInitFile[2]));
                 listInitPhase.add(Float.parseFloat(columnsInitFile[3]));
                 listInitLorentzWidth.add(Float.parseFloat(columnsInitFile[4]));
                 }
             
            
            while ((linesOrigSignal = savedSignal.readLine()) != null) {
                      columnsOrigSignal = linesOrigSignal.split(",");
                      origRe[cntr] = Float.parseFloat( columnsOrigSignal[1] );
                      origIm[cntr] = Float.parseFloat( columnsOrigSignal[2] );
                      xaxis[cntr] = (float) cntr;
                      cntr++;
                 }
                 
        }
        catch(Exception ex) {
            Logger.getLogger(DataReaderVerification.class.getName()).log(Level.SEVERE, null, ex);
        }
         
        savedSignal.close();
        predFile.close();
        initFile.close();
        
        // plot original signal 
        XYPlotFrame plotOrig = new XYPlotFrame( "plot orig signal", null );
        plotOrig.addCurve( new Curve( xaxis , origRe,  Color.BLUE ), false );
    }
    
    
    // compute the variance  (standard deviation)
    public double calculateMeanVarianceAndStd( float[] param){
       
        double variance = 0;
        double total = 0;
        
       // compute the mean
         for( int i= 0; i< param.length; i++){
              total += param[i]; 
        }
        double mean = total / param.length; 
        
       // compute the variance
        for (int j = 0; j < param.length; j++) {
            variance += (param[j] - mean) * (param[j] - mean);
        }       
        variance = variance / param.length;

       // compute standard deviation
        double std = Math.sqrt(variance);
        
        return (double)std;   
    }
    
    
    public void printSTDforInitialAndPredictedParam(){
            
        // convert from arrayList to array - predicted parameters
        float[] predAreaObject = new float[listPredArea.size()]; 
        float[] predFreqObject = new float[listPredFrequency.size()]; 
        float[] predGaussObject = new float[listPredGaussWidth.size()]; 
        float[] predPhaseObject = new float[listPredPhase.size()]; 
        float[] predLorentzObject = new float[listPredLorentzWidth.size()]; 
        
        // convert from arrayList to array - inital parameters
        float[] initAreaObject = new float[listInitArea.size()]; 
        float[] initFreqObject = new float[listInitFrequency.size()]; 
        float[] initGaussObject = new float[listInitGaussWidth.size()]; 
        float[] initPhaseObject = new float[listInitPhase.size()]; 
        float[] initLorentzObject = new float[listInitLorentzWidth.size()]; 
       
      
        for (int i = 0; i < predAreaObject.length; i++){
              predAreaObject[i] = listPredArea.get(i);
              predFreqObject[i] = listPredFrequency.get(i);
              predGaussObject[i] = listPredGaussWidth.get(i); 
              predPhaseObject[i] = listPredPhase.get(i);
              predLorentzObject[i] = listPredLorentzWidth.get(i);
        }
        
        for (int k = 0; k < initAreaObject.length; k++){
              initAreaObject[k] = listInitArea.get(k);
              initFreqObject[k] = listInitFrequency.get(k);
              initGaussObject[k] = listInitGaussWidth.get(k); 
              initPhaseObject[k] = listInitPhase.get(k);
              initLorentzObject[k] = listInitLorentzWidth.get(k);
        }
      
        // print intial - predicted param STD
        float std_calc = (float) calculateMeanVarianceAndStd(initAreaObject);
        System.out.println("Initial Area STD:" +  std_calc );

        std_calc = (float) calculateMeanVarianceAndStd(predAreaObject);
        System.out.println("Predicted Area STD:" + std_calc );
        
       
        
        std_calc = (float) calculateMeanVarianceAndStd(initFreqObject);
        System.out.println("Initial Frequency STD:" + std_calc );       
        
        std_calc = (float) calculateMeanVarianceAndStd(predFreqObject);
        System.out.println("Predicted Frequency STD:" + std_calc );
        
        
        
        std_calc = (float) calculateMeanVarianceAndStd(initGaussObject);
        System.out.println("Initial Gaussian Width STD:" + std_calc );
        
        std_calc = (float) calculateMeanVarianceAndStd(predGaussObject);
        System.out.println("Predicted Gaussian Width STD:" + std_calc );
        
        
        
        std_calc = (float) calculateMeanVarianceAndStd(initPhaseObject);
        System.out.println("Initial Phase STD:" + std_calc);
        
        std_calc = (float) calculateMeanVarianceAndStd(predPhaseObject);
        System.out.println("Predicted Phase STD:" + std_calc);
        
        
        
        std_calc = (float) calculateMeanVarianceAndStd(initLorentzObject);
        System.out.println("Initial Lorentz Width STD:" + std_calc );

        std_calc = (float) calculateMeanVarianceAndStd(predLorentzObject);
        System.out.println("Predicted Lorentz Width STD:" + std_calc );
      
    }
    

    
    private static boolean loadTDFDFitPrototypeModel(boolean interactive) {
        // contains reference to model m_signalPrototypeModelSpectrumFileReference
        if (interactive == true) { // here is some error...
            m_TDFDfitPrototypeModelFileReference = getLoadTDFDFitPrototypeModelFileReference();
        } else {
            // m_TDFDfitModelFileReference is already defined in main.
            // m_TDFDfitPrototypeModelFileReference = getLoadTDFDFitPrototypeModelFileReference( );
        }

        loadTDFDFitPrototypeModelSpectrumFile();

        return true;
    }

    private static void loadTDFDFitPrototypeModelSpectrumFile() {

        if (m_TDFDfitPrototypeModelFileReference != null) {
            try {

                RandomAccessFile reader = new RandomAccessFile(m_TDFDfitPrototypeModelFileReference, "rw");

                m_MRSignalProperties = MRSignalProperties.getInstance();

                // Load all essential object attritubutes from the file.
                m_MRSignalProperties.read(reader);

                // Load the fitting strategy; if not defined you will get the 
                // default strategy.
                m_fitStrategy = MRFitStrategy.getInstance();
                m_fitStrategy.read(reader);  

                // Read the TDFDFitPrototypeModelSpectrum object from file.
                TDFDFitPrototypeModelSpectrumParameters.getInstance().read(reader);

                m_singleVoxelMeasuredData = new SingleVoxelMeasuredSpectralData();

                // Read the single voxel spectral data response
                m_singleVoxelMeasuredData.read(reader, false);

                if (m_singleVoxelMeasuredDataLoaded != null) {
                    m_singleVoxelMeasuredData.autoSetXaxis();
                    m_singleVoxelMeasuredDataLoaded = m_singleVoxelMeasuredData;
                    m_singleVoxelMeasuredDataLoaded.autoSetXaxis();
                    //xyplot m_MRSpectrumModellerPanel.setMeasuredSpectrum( m_singleVoxelMeasuredDataLoaded );
                } else {
                    m_singleVoxelMeasuredDataLoaded = m_singleVoxelMeasuredData;
                    m_singleVoxelMeasuredData.autoSetXaxis();
                    m_singleVoxelMeasuredDataLoaded.autoSetXaxis();
                    // xyplot m_MRSpectrumModellerPanel.setMeasuredSpectrum( m_singleVoxelMeasuredData );
                }

                // The model spectrum must know its m_MRSignalProperties object
                TDFDFitPrototypeModelSpectrumParameters.getInstance().setMRSignalProperties(m_MRSignalProperties);
                TDFDFitPrototypeModelSpectrumParameters.getInstance().setMeasuredSpectrum(m_singleVoxelMeasuredData);
//             
                // Reads the baseline points from file
                m_baseLineModel.read(reader);

                try {
                    // Load the patient database, and get a reference to it
                    // m_mrSpectrumDataBase = MRPatientSpectrumDataBase.getInstance( );
                    reader.close();
                } catch (IOException ex) {
                    Logger.getLogger(DataGeneratorMain.class.getName()).log(Level.SEVERE, null, ex);
                }
            } catch (FileNotFoundException e) {
                // Not handled yet.
            }

            TDFDFitPrototypeModelSpectrumParameters protoType = TDFDFitPrototypeModelSpectrumParameters.getInstance();
            Curve plotCurve = protoType.getMeasuredSpectrum().getAbsorptionCurveFDPPM();

            XYPlotFrame pFrame = new XYPlotFrame("Test - Plot data", null);
           
            Curve cur = new Curve(plotCurve.getXvalues(),
                    plotCurve.getYvalues(),
                    Color.BLACK);

            cur.setStyle(Curve.FAT_SOLID_LINE);

            pFrame.addCurve(cur, false);

        }
    }
    
    private static File getLoadTDFDFitPrototypeModelFileReference() {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance();
        fdef.load( );
        
        String modelRef = fdef.getProperty(TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME);
        String modelPath = fdef.getProperty(TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH);

        File file = new File(modelPath + System.getProperty("file.separator") + modelRef);

        if (file.exists() == false) {
            file = new File(fdef.getProperty(TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH));
        }

        if (file.exists() == false) {
            file = new File(System.getProperty("user.home"));
        }

        JFileChooser fileChooser = new JFileChooser(file.getAbsolutePath());

        int result = fileChooser.showOpenDialog(null);

        m_TDFDfitPrototypeModelFileReference = new File("");

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                m_TDFDfitPrototypeModelFileReference = fileChooser.getSelectedFile();
                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                def.load( );
                
                def.setProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME, m_TDFDfitPrototypeModelFileReference.getName( ) );
                def.setProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH, m_TDFDfitPrototypeModelFileReference.getParent( ) );
                def.save( );
                TDFDFitPrototypeModelSpectrumParameters.getInstance( ).setModelSpectrumName( m_TDFDfitPrototypeModelFileReference.getName( ) );

                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }

        return m_TDFDfitPrototypeModelFileReference;
    }
  
}
