/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.settings.processing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import org.spectrim.dicom.DicomDefaults;
import org.spectrim.tdfdfit.TDFDFittingDefaults;

/**
 * 
 * Enables the user to select a quantification type.
 * 
 * @author johan
 */
public class QuantificationTypeSelectionFrame extends javax.swing.JFrame 
{

    /**
     * Creates new form QuantificationTypeSelectionFrame.
     */
    public QuantificationTypeSelectionFrame( ) 
    {
        initComponents( );
       
        TDFDFittingDefaults defs = TDFDFittingDefaults.getInstance( );
        defs.load( );
        
        String defaultModelPath = defs.getProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH ) + System.getProperty( "file.separator" );
        String defaultModel = defs.getProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME );
        
        this.jselectedTDFDFitModeNamelTextField.setText( defaultModel );
        this.jselectedTDFDFitModelPathTextField.setText( defaultModelPath );
        
        setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
        pack( );
        setVisible( true );
    }

    /**
     * Adds an ActionListener to the list of listeners.
     * @param listener
     */
    public void addActionListener( ActionListener listener )
    {
        m_actionListeners.add( listener );
    }
    
    /**
     * Notifies actionEvent to all registered listeners.
     */
    private void notifyActionListeners( Object obj, 
                                        int eventType, 
                                        String actionCommand ) 
    {
        Iterator it = m_actionListeners.iterator( );
        while ( it.hasNext( ) ) 
        {
            ( (ActionListener) it.next( ) ).actionPerformed( new ActionEvent( obj, eventType, actionCommand ) );
        }
    }
    
    // Listeners to this object
    private final Vector<ActionListener> m_actionListeners = new Vector<>( );
    
    
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jQuantificationMethodSelectionPanel = new javax.swing.JPanel();
        jQUESTRadioButton = new javax.swing.JRadioButton();
        jTDFDFITRadioButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jselectedTDFDFitModeNamelTextField = new javax.swing.JTextField();
        jTDFDFitSelectionButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jselectedTDFDFitModelPathTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jCancelButton = new javax.swing.JButton();
        jApplyButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Quantification method");

        jQuantificationMethodSelectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Select quantification method (64 bits only)"));

        jQUESTRadioButton.setText("QUEST");
        jQUESTRadioButton.setEnabled(false);

        jTDFDFITRadioButton.setSelected(true);
        jTDFDFITRadioButton.setText("TDFDFIT");

        jLabel1.setText("TDFDFit model name:");

        jselectedTDFDFitModeNamelTextField.setText("jTextField1");

        jTDFDFitSelectionButton.setText("Select TDFDFITModel ..");
        jTDFDFitSelectionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTDFDFitSelectionButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("TDFDFit model path:");

        jselectedTDFDFitModelPathTextField.setText("jTextField1");

        javax.swing.GroupLayout jQuantificationMethodSelectionPanelLayout = new javax.swing.GroupLayout(jQuantificationMethodSelectionPanel);
        jQuantificationMethodSelectionPanel.setLayout(jQuantificationMethodSelectionPanelLayout);
        jQuantificationMethodSelectionPanelLayout.setHorizontalGroup(
            jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                .addGap(60, 60, 60)
                .addGroup(jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                        .addComponent(jQUESTRadioButton)
                        .addContainerGap())
                    .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                        .addComponent(jTDFDFITRadioButton)
                        .addGap(46, 46, 46)
                        .addGroup(jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(18, 18, 18)
                                .addComponent(jselectedTDFDFitModelPathTextField))
                            .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addGap(18, 18, 18)
                                .addComponent(jselectedTDFDFitModeNamelTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE)))
                        .addGap(18, 18, 18)
                        .addComponent(jTDFDFitSelectionButton))))
        );
        jQuantificationMethodSelectionPanelLayout.setVerticalGroup(
            jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jQuantificationMethodSelectionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jQUESTRadioButton)
                .addGap(18, 18, 18)
                .addGroup(jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTDFDFITRadioButton)
                    .addComponent(jLabel1)
                    .addComponent(jselectedTDFDFitModeNamelTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTDFDFitSelectionButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jQuantificationMethodSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jselectedTDFDFitModelPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(33, Short.MAX_VALUE))
        );

        jCancelButton.setText("Cancel");
        jCancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCancelButtonActionPerformed(evt);
            }
        });

        jApplyButton.setText("Apply");
        jApplyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jApplyButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jApplyButton, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jApplyButton)
                    .addComponent(jCancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jQuantificationMethodSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jQuantificationMethodSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jApplyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jApplyButtonActionPerformed
       this.notifyActionListeners( this, 
                                   APPLY_BUTTON_PRESSED_ID, 
                                   APPLY_BUTTON_PRESSED_CMD );
        dispose( );
    }//GEN-LAST:event_jApplyButtonActionPerformed

    private void jTDFDFitSelectionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTDFDFitSelectionButtonActionPerformed
        File file = getTDFDFitDirectoryAndFileName( );
        
        this.jselectedTDFDFitModelPathTextField.setText( file.getParent( ) );
        this.jselectedTDFDFitModeNamelTextField.setText( file.getName( ) );
    }//GEN-LAST:event_jTDFDFitSelectionButtonActionPerformed

    private void jCancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCancelButtonActionPerformed
        setVisible( false );
    }//GEN-LAST:event_jCancelButtonActionPerformed

    
     /**
     * Returns the selected TDFDFit path and model as selected by the user.
     */
    private File getTDFDFitDirectoryAndFileName( ) 
    {
 
        TDFDFittingDefaults defs = TDFDFittingDefaults.getInstance( );
        defs.load( );
        
        String pathAsString = "" + defs.get( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH ); 
        

        
        JFileChooser fileChooser = new JFileChooser( pathAsString + System.getProperty( "file.separator" ) );
        
        fileChooser.setName( "Select model TDFDFit name" );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_file = new File( "" );
        
        switch ( result ) 
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                
                selected_file = fileChooser.getSelectedFile( );
                defs.setProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH, selected_file.getParent( ) );
                defs.setProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME, selected_file.getName( ) );
                
                defs.save( );
                                                
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_file;
    }
    
    
    
    
    /**
     * 
     * Returns which quantification method is preferred.
     * 
     * @return 
     */
    public int getSelectedQuantificationType( )
    {
        if ( jTDFDFITRadioButton.isSelected( ) )
        {
            return TDFDFIT_SELECTED;
        }
        else
        {
            return QUEST_SELECTED;
        }
    }
    
    public String getSelectedQuantificationModel( )
    {
        return jselectedTDFDFitModeNamelTextField.getText( );
    }
    
    public String getSelectedQuantificationModelPath( )
    {
        return jselectedTDFDFitModelPathTextField.getText( );
    }
    
    
    /**
     * @param args the command line arguments.
     */
    public static void main( String args[] ) 
    {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(QuantificationTypeSelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(QuantificationTypeSelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(QuantificationTypeSelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(QuantificationTypeSelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* 
           Create and display the form 
        */
        java.awt.EventQueue.invokeLater( new Runnable( ) 
        {
            @Override
            public void run( ) 
            {
                new QuantificationTypeSelectionFrame( ).setVisible( true );
            }
        } );
    }

    public final static int     APPLY_BUTTON_PRESSED_ID     = 0;
    public final static String  APPLY_BUTTON_PRESSED_CMD    = "APPLY_SELECTED_MODEL";
    
    public  final static int    TDFDFIT_SELECTED            = 1;
    public  final static int    QUEST_SELECTED              = 2;
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jApplyButton;
    private javax.swing.JButton jCancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jQUESTRadioButton;
    private javax.swing.JPanel jQuantificationMethodSelectionPanel;
    private javax.swing.JRadioButton jTDFDFITRadioButton;
    private javax.swing.JButton jTDFDFitSelectionButton;
    private javax.swing.JTextField jselectedTDFDFitModeNamelTextField;
    private javax.swing.JTextField jselectedTDFDFitModelPathTextField;
    // End of variables declaration//GEN-END:variables
}
