/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.settings.processing;

import org.spectrim.settings.ProcessingSettings;

/**
 *
 * @author nunopbarros
 */
public class ReferencePeak {

    private double minppm;
    private double maxppm;
    private double targetppm;
    private int multiplicity;
    private String name;

    public ReferencePeak(String name, double targetppm, double minppm, double maxppm, int multiplicity) {
        this.minppm = minppm;
        this.maxppm = maxppm;
        this.targetppm = targetppm;
        this.multiplicity = multiplicity;
        this.name = name;
    }
    
    public ReferencePeak(String info) {
        String[] parts = info.split(ProcessingSettings.separator1);
        this.name = parts[0];
        this.targetppm = Double.parseDouble(parts[1]);
        this.minppm = Double.parseDouble(parts[2]);
        this.maxppm = Double.parseDouble(parts[3]);
        this.multiplicity = Integer.parseInt(parts[4]);
    }
    
    public String toString(){
        return name+ProcessingSettings.separator1+targetppm+ProcessingSettings.separator1+minppm+ProcessingSettings.separator1+maxppm+ProcessingSettings.separator1+multiplicity;
    }

    public double getMinppm() {
        return minppm;
    }

    public void setMinppm(double minppm) {
        this.minppm = minppm;
    }

    public double getMaxppm() {
        return maxppm;
    }

    public void setMaxppm(double maxppm) {
        this.maxppm = maxppm;
    }

    public double getTargetppm() {
        return targetppm;
    }

    public void setTargetppm(double targetppm) {
        this.targetppm = targetppm;
    }

    public int getMultiplicity() {
        return multiplicity;
    }

    public void setMultiplicity(int multiplicity) {
        this.multiplicity = multiplicity;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
