/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import static org.spectrim.tdfdfit.BaseLineSplineSupportPointsDefinitionFrame.CANCEL_EVENT;

/**
 * Graphical user interface enabling user to define simulated baseline and
 * residual water components to be simulated.
 *
 * @author johan
 */
public class BaselineAndWaterResidualModelParameterDefinitionJFrame extends javax.swing.JFrame {

    /**
     * Creates new form BaselineAndWaterResidualModelParameterDefinitionJFrame.
     */
    public BaselineAndWaterResidualModelParameterDefinitionJFrame( ) 
    {
        initComponents( );

        TDFDFitPrototypeModelSpectrumParameters protModel = TDFDFitPrototypeModelSpectrumParameters.getInstance( );
        Vector<String> componentNames = protModel.getComponentNameVector( );

        // m_componentNamesjComboBox.removeAllItems( );

        Iterator it = componentNames.iterator( );
        while ( it.hasNext( ) ) 
        {
            m_componentNamesjComboBox.addItem( (String) it.next( ) );
        }

        ImperfectSpectrumModelParameters imperfectModelParameters = ImperfectSpectrumModelParameters.getInstance( );

        String selectedReferenceComponent = imperfectModelParameters.getSelectedReferenceComponent( );
        m_numberOfWaterResidualComponentsjTextField.setText("" + imperfectModelParameters.getNumberOfWaterCompoments( ) );
        m_componentNamesjComboBox.setSelectedItem( selectedReferenceComponent );
        
        float[] ampFactors  = imperfectModelParameters.getResidualWaterAmplFactors( );
        float[] maxOffsets  = imperfectModelParameters.getResidualWaterOffsetValues( );
        float[] maxPhases   = imperfectModelParameters.getResidualWaterPhaseValues( );
        float[] maxLWidths  = imperfectModelParameters.getResidualWaterLWidthValues( );
        
        DefaultTableModel model = (DefaultTableModel)m_residualWaterComponentsPropertiesTable.getModel( );
        int currentNumberOfRows = model.getRowCount( );
        // make the table empty ..
        for ( int i = currentNumberOfRows-1; i > -1; i-- )
        {
            model.removeRow( i );    
        }
        // set the table model to the proper amount of rows ...
        for ( int i = 0; i < ampFactors.length; i++ )
        {
            model.addRow( new Object[]{null, null, null, null, null} );
        }
               
        // Now the parameters are read we can set the GUI!!
        for ( int i = 0; i < imperfectModelParameters.getNumberOfWaterCompoments( ); i++ ) 
        {
            m_residualWaterComponentsPropertiesTable.setValueAt( i + 1, i, 0 );
            m_residualWaterComponentsPropertiesTable.setValueAt( "" + ampFactors[i], i, 1 );
            m_residualWaterComponentsPropertiesTable.setValueAt( "" + maxOffsets[i], i, 2 );
            m_residualWaterComponentsPropertiesTable.setValueAt( "" + maxPhases[i], i, 3 );
            m_residualWaterComponentsPropertiesTable.setValueAt( "" + maxLWidths[i], i, 4 );
        }

        m_includeSmileyArtefactjCheckBox.setSelected( imperfectModelParameters.getIncludeSmileyArtefacts( ) );
        m_includeResidualWaterSignalsjCheckBox.setSelected( imperfectModelParameters.getIncludeHasResidualWaterSignals( ) );
        m_includeGeneralBaselineArtefactjCheckBox.setSelected( imperfectModelParameters.getIncludeHasGeneralBaselineRoleArtefacts( ) );

        m_smileyAmplitudeFactorjTextField.setText( "" + imperfectModelParameters.getMaxSmileyAmplitudeFactor( ) );
        m_smileyDecayConstantjTextField.setText( "" + imperfectModelParameters.getMaxSmileyDecayConstant( ) );
        m_smileyPhaseDifferencejTextField.setText( "" + imperfectModelParameters.getMaxSmileyPhaseDifference( ) );
        
        m_generalBaselineAmplitudejTextField.setText( "" + imperfectModelParameters.getGeneralBaseLineAmplitudeFactor( ) );
        m_generalBaselineDampingConstantVarjTextField.setText( "" + imperfectModelParameters.getGeneralBaseLineDamping( ) );
        m_generalBaselineMaxPhasejTextField.setText( "" + imperfectModelParameters.getGeneralBaseLineMaxPhase( ) );
        m_generalBaselineOffsetVarjTextField.setText( "" + imperfectModelParameters.getGeneralBaseLineOffsetVar(  ) );
        
        setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );

        setVisible( true );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        m_residualWaterComponentsPropertiesTable = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        m_componentNamesjComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        m_numberOfWaterResidualComponentsjTextField = new javax.swing.JTextField();
        m_addRowToTablejButton = new javax.swing.JButton();
        m_deleteRowjButton = new javax.swing.JButton();
        m_includeResidualWaterSignalsjCheckBox = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        m_includeSmileyArtefactjCheckBox = new javax.swing.JCheckBox();
        m_smileyDecayConstantjTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        m_smileyPhaseDifferencejTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        m_smileyAmplitudeFactorjTextField = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        m_quitjButton = new javax.swing.JButton();
        m_applyAndQuitjButton = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        m_includeGeneralBaselineArtefactjCheckBox = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        m_generalBaselineAmplitudejTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        m_generalBaselineMaxPhasejTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        m_generalBaselineOffsetVarjTextField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        m_generalBaselineDampingConstantVarjTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Water residual parameters"));

        m_residualWaterComponentsPropertiesTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Component number", "Max. amplitude factor", "Max. offset shift", "Max. phase shift", "Max. Lorentzian width factor"
            }
        ));
        jScrollPane1.setViewportView(m_residualWaterComponentsPropertiesTable);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(0, 17, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        m_componentNamesjComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "not defined yet!" }));
        m_componentNamesjComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_componentNamesjComboBoxActionPerformed(evt);
            }
        });

        jLabel1.setText("Reference component");

        jLabel2.setText("Number of water components");

        m_numberOfWaterResidualComponentsjTextField.setEditable(false);
        m_numberOfWaterResidualComponentsjTextField.setText("5");

        m_addRowToTablejButton.setText("Add row");
        m_addRowToTablejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_addRowToTablejButtonActionPerformed(evt);
            }
        });

        m_deleteRowjButton.setText("Delete row");
        m_deleteRowjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteRowjButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_componentNamesjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(24, 24, 24)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_numberOfWaterResidualComponentsjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addComponent(m_addRowToTablejButton, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_deleteRowjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addContainerGap(17, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_componentNamesjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(m_numberOfWaterResidualComponentsjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_addRowToTablejButton)
                    .addComponent(m_deleteRowjButton))
                .addContainerGap())
        );

        m_includeResidualWaterSignalsjCheckBox.setSelected(true);
        m_includeResidualWaterSignalsjCheckBox.setText("Include residual water resonances");
        m_includeResidualWaterSignalsjCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_includeResidualWaterSignalsjCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(m_includeResidualWaterSignalsjCheckBox)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, 0))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_includeResidualWaterSignalsjCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Smily artefact model properties"));

        m_includeSmileyArtefactjCheckBox.setSelected(true);
        m_includeSmileyArtefactjCheckBox.setText("Include smiley artefact");
        m_includeSmileyArtefactjCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_includeSmileyArtefactjCheckBoxActionPerformed(evt);
            }
        });

        m_smileyDecayConstantjTextField.setText("16.0");

        jLabel3.setText("Max. smiley decay constant ");

        jLabel4.setText("Max. smiley phase variation ");

        m_smileyPhaseDifferencejTextField.setText("45.0");
        m_smileyPhaseDifferencejTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_smileyPhaseDifferencejTextFieldActionPerformed(evt);
            }
        });

        jLabel5.setText("Max. smiley amplitude factor ");

        m_smileyAmplitudeFactorjTextField.setText("0.1");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_includeSmileyArtefactjCheckBox)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(jPanel3Layout.createSequentialGroup()
                            .addComponent(jLabel4)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_smileyPhaseDifferencejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel3)
                                .addComponent(jLabel5))
                            .addGap(60, 60, 60)
                            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(m_smileyAmplitudeFactorjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(m_smileyDecayConstantjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(m_includeSmileyArtefactjCheckBox)
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(m_smileyAmplitudeFactorjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_smileyDecayConstantjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_smileyPhaseDifferencejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_quitjButton.setText("Quit");
        m_quitjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_quitjButtonActionPerformed(evt);
            }
        });

        m_applyAndQuitjButton.setText("Apply and Quit");
        m_applyAndQuitjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyAndQuitjButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_quitjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_applyAndQuitjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_quitjButton)
                    .addComponent(m_applyAndQuitjButton))
                .addContainerGap())
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Gerenal baseline artefacts"));

        m_includeGeneralBaselineArtefactjCheckBox.setSelected(true);
        m_includeGeneralBaselineArtefactjCheckBox.setText("Include general baseline artefact");
        m_includeGeneralBaselineArtefactjCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_includeGeneralBaselineArtefactjCheckBoxActionPerformed(evt);
            }
        });

        jLabel6.setText("General baseline amplitude factor");

        m_generalBaselineAmplitudejTextField.setText("100.0");
        m_generalBaselineAmplitudejTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_generalBaselineAmplitudejTextFieldActionPerformed(evt);
            }
        });

        jLabel7.setText("General baseline max. phase diff.");

        m_generalBaselineMaxPhasejTextField.setText("3.141592");

        jLabel8.setText("General baseline max. offset [pnt]");

        m_generalBaselineOffsetVarjTextField.setText("4096");

        jLabel9.setText("General baseline damping constant");

        m_generalBaselineDampingConstantVarjTextField.setText("1024");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_includeGeneralBaselineArtefactjCheckBox)
                    .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                            .addComponent(jLabel8)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_generalBaselineOffsetVarjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel6)
                                .addComponent(jLabel7))
                            .addGap(41, 41, 41)
                            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(m_generalBaselineMaxPhasejTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(m_generalBaselineAmplitudejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGroup(jPanel6Layout.createSequentialGroup()
                            .addComponent(jLabel9)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_generalBaselineDampingConstantVarjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(m_generalBaselineAmplitudejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel6))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(m_includeGeneralBaselineArtefactjCheckBox)
                        .addGap(32, 32, 32)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_generalBaselineMaxPhasejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(m_generalBaselineOffsetVarjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(m_generalBaselineDampingConstantVarjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_smileyPhaseDifferencejTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_smileyPhaseDifferencejTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_smileyPhaseDifferencejTextFieldActionPerformed

    private void m_addRowToTablejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_addRowToTablejButtonActionPerformed
        DefaultTableModel model = (DefaultTableModel) m_residualWaterComponentsPropertiesTable.getModel( );

        int newCompNumber = model.getRowCount( );

        Object[] row = {(newCompNumber + 1), "0.0", "0.0", "0.0", "0.0"};

        model.addRow( row );

        m_residualWaterComponentsPropertiesTable.setRowSelectionInterval( newCompNumber, newCompNumber );
        m_numberOfWaterResidualComponentsjTextField.setText( "" + model.getRowCount( ) );
        
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        imperfPar.setNumberOfWaterResidualComponents( model.getRowCount( ) );
        
        float[] amplitudes  = new float[model.getRowCount( )];
        float[] offsets     = new float[model.getRowCount( )];
        float[] phases      = new float[model.getRowCount( )];
        float[] lwidths      = new float[model.getRowCount( )];
        
        for( int i = 0 ; i < model.getRowCount( );i++ )
        {
            amplitudes[i]   = new Float( "" + model.getValueAt( i, 1 ) );
            offsets[i]      = new Float( "" + model.getValueAt( i, 2 ) );
            phases[i]       = new Float( "" + model.getValueAt( i, 3 ) );
            lwidths[i]      = new Float( "" + model.getValueAt( i, 4 ) ); 
        }
        
        imperfPar.setResidualWaterAmplFactors( amplitudes );
        imperfPar.setResidualWaterOffsetValues( offsets );
        imperfPar.setResidualWaterPhaseValues( phases );
        imperfPar.setResidualWaterLWidthValues( lwidths );
        
    }//GEN-LAST:event_m_addRowToTablejButtonActionPerformed

    private void m_quitjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_quitjButtonActionPerformed
        dispose( );
    }//GEN-LAST:event_m_quitjButtonActionPerformed

    private void m_deleteRowjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteRowjButtonActionPerformed

        DefaultTableModel model = (DefaultTableModel)m_residualWaterComponentsPropertiesTable.getModel( );

        if ( model.getRowCount( ) > 1 ) 
        {
            int selectedRowNumber = m_residualWaterComponentsPropertiesTable.getSelectedRow();

            model.removeRow(m_residualWaterComponentsPropertiesTable.getSelectedRow());
            m_residualWaterComponentsPropertiesTable.setRowSelectionInterval(selectedRowNumber - 1, selectedRowNumber - 1);
        } else {
            JOptionPane.showMessageDialog(this, "Residual water model should contain at least one resonance line");
        }
         m_numberOfWaterResidualComponentsjTextField.setText( "" + model.getRowCount( ) );
        
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        imperfPar.setNumberOfWaterResidualComponents( model.getRowCount( ) );
        
        float[] amplitudes  = new float[model.getRowCount( )];
        float[] offsets     = new float[model.getRowCount( )];
        float[] phases      = new float[model.getRowCount( )];
        float[] lwidths      = new float[model.getRowCount( )];
        
        for( int i = 0 ; i < model.getRowCount( );i++ )
        {
            amplitudes[i]   = new Float( "" + model.getValueAt( i, 1 ) );
            offsets[i]      = new Float( "" + model.getValueAt( i, 2 ) );
            phases[i]       = new Float( "" + model.getValueAt( i, 3 ) );
            lwidths[i]      = new Float( "" + model.getValueAt( i, 4 ) );
            
        }
        
        imperfPar.setResidualWaterAmplFactors( amplitudes );
        imperfPar.setResidualWaterOffsetValues( offsets );
        imperfPar.setResidualWaterPhaseValues( phases );
        imperfPar.setResidualWaterLWidthValues( lwidths );
        
    }//GEN-LAST:event_m_deleteRowjButtonActionPerformed

    private void m_applyAndQuitjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyAndQuitjButtonActionPerformed
        
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        
        imperfPar.setIncludeHasResidualWaterSignals( this.m_includeResidualWaterSignalsjCheckBox.isSelected( ) );
        imperfPar.setIncludeSmileyArtefacts( m_includeSmileyArtefactjCheckBox.isSelected( ) );
        imperfPar.setIncludeHasGeneralBaselineRoleArtefacts( this.m_includeGeneralBaselineArtefactjCheckBox.isSelected( ) );
        
        imperfPar.setMaxSmileyAmplitudeFactor( new Float( m_smileyAmplitudeFactorjTextField.getText( ) ) );
        imperfPar.setMaxSmileyDecayConstant( new Float( m_smileyDecayConstantjTextField.getText( ) ) );
        imperfPar.setMaxSmileyPhaseDifference( new Float( m_smileyPhaseDifferencejTextField.getText( ) ) );
        
        
        imperfPar.setGeneralBaseLineAmplitudeFactor( new Float( m_generalBaselineAmplitudejTextField.getText( ) ) );
        imperfPar.setGeneralBaseLineDamping( new Float( m_generalBaselineDampingConstantVarjTextField.getText( ) ) );
        imperfPar.setGeneralBaseLineMaxPhase( new Float( m_generalBaselineMaxPhasejTextField.getText( ) ) );
        imperfPar.setGeneralBaseLineOffsetVar( new Float( m_generalBaselineAmplitudejTextField.getText( ) ) );
        
        DefaultTableModel model = (DefaultTableModel)m_residualWaterComponentsPropertiesTable.getModel( );
        
        float[] amplitudes  = new float[model.getRowCount( )];
        float[] offsets     = new float[model.getRowCount( )];
        float[] phases      = new float[model.getRowCount( )];
        float[] lwidths      = new float[model.getRowCount( )];
        
        for( int i = 0 ; i < model.getRowCount( );i++ )
        {
            amplitudes[i]   = new Float( "" + model.getValueAt( i, 1 ) );
            offsets[i]      = new Float( "" + model.getValueAt( i, 2 ) );
            phases[i]       = new Float( "" + model.getValueAt( i, 3 ) );
            lwidths[i]      = new Float( "" + model.getValueAt( i, 4 ) );
            
        }
        
        imperfPar.setResidualWaterAmplFactors( amplitudes );
        imperfPar.setResidualWaterOffsetValues( offsets );
        imperfPar.setResidualWaterPhaseValues( phases );
        imperfPar.setResidualWaterLWidthValues( lwidths );
        
        String selComponent = (String)m_componentNamesjComboBox.getSelectedItem( );
        imperfPar.setReferenceComponentName( selComponent );
        imperfPar.setNumberOfWaterResidualComponents( model.getRowCount( ) );
        imperfPar.makeInstancePersistent( );
        notifyActionListeners( QUIT_AND_SAVE_CMD, QUIT_AND_SAVE);
        dispose( );
    }//GEN-LAST:event_m_applyAndQuitjButtonActionPerformed

    private void m_componentNamesjComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_componentNamesjComboBoxActionPerformed
       
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        String selComponent = (String)m_componentNamesjComboBox.getSelectedItem( );
        imperfPar.setReferenceComponentName( selComponent );
        
    }//GEN-LAST:event_m_componentNamesjComboBoxActionPerformed

    private void m_includeResidualWaterSignalsjCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_includeResidualWaterSignalsjCheckBoxActionPerformed
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        imperfPar.setIncludeHasResidualWaterSignals( m_includeResidualWaterSignalsjCheckBox.isSelected( ) );
        imperfPar.makeInstancePersistent( );
    }//GEN-LAST:event_m_includeResidualWaterSignalsjCheckBoxActionPerformed

    private void m_includeSmileyArtefactjCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_includeSmileyArtefactjCheckBoxActionPerformed
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        imperfPar.setIncludeSmileyArtefacts( m_includeSmileyArtefactjCheckBox.isSelected( ) );
        imperfPar.makeInstancePersistent( );
    }//GEN-LAST:event_m_includeSmileyArtefactjCheckBoxActionPerformed

    private void m_includeGeneralBaselineArtefactjCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_includeGeneralBaselineArtefactjCheckBoxActionPerformed
        ImperfectSpectrumModelParameters imperfPar = ImperfectSpectrumModelParameters.getInstance( );
        imperfPar.setIncludeHasGeneralBaselineRoleArtefacts( m_includeGeneralBaselineArtefactjCheckBox.isSelected( ) );
        imperfPar.makeInstancePersistent( );
    }//GEN-LAST:event_m_includeGeneralBaselineArtefactjCheckBoxActionPerformed

    private void m_generalBaselineAmplitudejTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_generalBaselineAmplitudejTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_generalBaselineAmplitudejTextFieldActionPerformed

    /**
     * @param args the command line arguments.
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(BaselineAndWaterResidualModelParameterDefinitionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(BaselineAndWaterResidualModelParameterDefinitionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(BaselineAndWaterResidualModelParameterDefinitionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BaselineAndWaterResidualModelParameterDefinitionJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BaselineAndWaterResidualModelParameterDefinitionJFrame().setVisible(true);
            }
        });
    }
    
    /**
     * Adds an ActionListener to the list of action listeners who are notified
     * when something happens within this object.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    }
    
    // sent the cancel event to all listeners!
     private final void notifyActionListeners( String cmd, int cmd_id )
     {
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, cmd_id, cmd ) );
        }
     }
    
     
    private final LinkedList<ActionListener> m_listeners = new LinkedList<>( );
    public final static int QUIT_AND_SAVE = 1;
    public final static String QUIT_AND_SAVE_CMD = "Quit and save";
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton m_addRowToTablejButton;
    private javax.swing.JButton m_applyAndQuitjButton;
    private javax.swing.JComboBox<String> m_componentNamesjComboBox;
    private javax.swing.JButton m_deleteRowjButton;
    private javax.swing.JTextField m_generalBaselineAmplitudejTextField;
    private javax.swing.JTextField m_generalBaselineDampingConstantVarjTextField;
    private javax.swing.JTextField m_generalBaselineMaxPhasejTextField;
    private javax.swing.JTextField m_generalBaselineOffsetVarjTextField;
    private javax.swing.JCheckBox m_includeGeneralBaselineArtefactjCheckBox;
    private javax.swing.JCheckBox m_includeResidualWaterSignalsjCheckBox;
    private javax.swing.JCheckBox m_includeSmileyArtefactjCheckBox;
    private javax.swing.JTextField m_numberOfWaterResidualComponentsjTextField;
    private javax.swing.JButton m_quitjButton;
    private javax.swing.JTable m_residualWaterComponentsPropertiesTable;
    private javax.swing.JTextField m_smileyAmplitudeFactorjTextField;
    private javax.swing.JTextField m_smileyDecayConstantjTextField;
    private javax.swing.JTextField m_smileyPhaseDifferencejTextField;
    // End of variables declaration//GEN-END:variables
}
