/*
 * FitResultParameterViewerPanel.java
 *
 * Created on October 8, 2003, 10:54 AM
 */

package org.spectrim.tdfdfit;


import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;

import java.io.FileReader;
import java.io.IOException;

/**
 * 
 * Simply loads the .fitres file and puts it in a JTextArea object.
 * 
 * @author  hans
 */
public class FitResultParameterViewerPanel extends JPanel
{
    
    /** 
     * Creates a new instance of FitResultParameterViewerPanel. 
     * @param fileReference
     */
    public FitResultParameterViewerPanel( String fileReference )
    {
        setLayout( new BoxLayout( this, BoxLayout.X_AXIS ) );
        
        m_displayPanel = new JPanel( );
        m_displayPanel.setLayout( new BoxLayout( m_displayPanel , BoxLayout.X_AXIS ) );
        
        m_infoTextArea = new JTextArea( );
        
        m_mainScrollPane = new JScrollPane( m_infoTextArea,
                                            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                                            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS );
        
        m_displayPanel.add( m_mainScrollPane );
        m_displayPanel.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );
        add( m_displayPanel );
        
        displayFileText( fileReference );
    }
    
    /**
     * Display the text from the .exl text formatted file.
     */
    private void displayFileText( String fileReference )
    {
        FileReader reader;
        int c;
        String displayString = "";
        String fileToLoad = fileReference.replaceAll( ".bin", ".fitres" );
        char[] chr = new char[1];
        
        try
        {
            reader = new FileReader( fileToLoad );
            while ( ( c = reader.read( ) ) != -1 )
            {
                chr[0] = (char)c;
                String str = new String( chr );
                displayString +=  str;  
            }
            // set the text
            m_infoTextArea.setText( displayString );
            reader.close();
        }
        catch ( IOException e )
        {
            // not handled yet
        }
    }
    
    // Attributes
    private final JPanel        m_displayPanel;
    private final JTextArea     m_infoTextArea;
    private final JScrollPane   m_mainScrollPane;
    
    // For proper serialization
    private static final long   serialVersionUID = 1482266191289213L;
    
}
