/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit;

import java.io.File;
import javax.swing.JFileChooser;
import org.spectrim.tdfdfit.quantitativeresults.MetaboliteRelaxationTimesDatabase;

/**
 * 
 * Allows the user to set important file system paths in connection to 
 * TDFDFit.
 * 
 * @author Johannes Slotboom <johannes.slotboom at insel.ch>
 */
public class TDFDFitFileSystemSettingsPanel extends javax.swing.JPanel {
    
    private boolean m_patientDBDirectorySet = false;
    private boolean m_tdfdftExcutableInstallationPathSet = false;
    private boolean m_tdfdfitModelsBasePathDefined = false;
    private boolean m_tdfdftExcutableNameSet = false;
    private boolean m_tdfdfitRelaxationTimeDataBaseFileReferenceSet = false;
    private boolean m_tdfdfitNormalConcentrationValueDatabaseSet = false;
      
    /**
     * Creates new form TDFDFitFileSystemSettingsPanel.
     */
    public TDFDFitFileSystemSettingsPanel( ) 
    {
        initComponents( );
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        // Read the possibly avaiable preset values, and show them
        m_patientDatabasePathValue.setText( fdef.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitInstallationPathValue.setText( fdef.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitModelsBasePathValue.setText( fdef.getProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitExecutableNameValue.setText( fdef.getProperty( TDFDFittingDefaults.TDFDFIT_EXECUTABLE_NAME, System.getProperty( "user.dir" ) ) );
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText( fdef.getProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE, System.getProperty( "user.dir" ) ) );
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText( fdef.getProperty(TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH, System.getProperty( "user.dir" ) ) );
        m_baselineNodesBaseDirectoryValue.setText( fdef.getProperty(TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH, System.getProperty( "user.dir" ) ) );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_tdfdfitLInstallationPathLabel = new javax.swing.JLabel();
        m_tdfdfitInstallationPathValue = new javax.swing.JLabel();
        m_changeTDFDFitInstallationPathButton1 = new javax.swing.JButton();
        m_patientDatabsePathLabel = new javax.swing.JLabel();
        m_patientDatabasePathValue = new javax.swing.JLabel();
        m_changePatientDatabasePathButton = new javax.swing.JButton();
        m_changeTDFDFitModelsBasePathButton = new javax.swing.JButton();
        m_tdfdfitModelsBasePathValue = new javax.swing.JLabel();
        m_tfdfitProjectPathLabel = new javax.swing.JLabel();
        m_tdfdfitExecutableNameLabel = new javax.swing.JLabel();
        m_tdfdfitExecutableNameValue = new javax.swing.JLabel();
        m_changeTDFDFitExecutableNameButton = new javax.swing.JButton();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel = new javax.swing.JLabel();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue = new javax.swing.JLabel();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton = new javax.swing.JButton();
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel = new javax.swing.JLabel();
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue = new javax.swing.JLabel();
        m_baselineSplineNodesModelPath = new javax.swing.JButton();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2 = new javax.swing.JButton();
        m_baselineNodesBaseDirectoryValue = new javax.swing.JLabel();
        m_baselineNodesBaseDirectoryLabel = new javax.swing.JLabel();

        m_tdfdfitLInstallationPathLabel.setText("TDFDFit installation path    :");

        m_tdfdfitInstallationPathValue.setText("tdfdfit installation path goes here!");

        m_changeTDFDFitInstallationPathButton1.setText("Change");
        m_changeTDFDFitInstallationPathButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitInstallationPathButton1ActionPerformed(evt);
            }
        });

        m_patientDatabsePathLabel.setText("Patient database root path  :");

        m_patientDatabasePathValue.setText("patient database path goes here!");

        m_changePatientDatabasePathButton.setText("Change");
        m_changePatientDatabasePathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changePatientDatabasePathButtonActionPerformed(evt);
            }
        });

        m_changeTDFDFitModelsBasePathButton.setText("Change");
        m_changeTDFDFitModelsBasePathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitModelsBasePathButtonActionPerformed(evt);
            }
        });

        m_tdfdfitModelsBasePathValue.setText("tdfdfit model path goes here!");

        m_tfdfitProjectPathLabel.setText("TDFDFit models root path   :");

        m_tdfdfitExecutableNameLabel.setText("TDFDFit executable name   :");

        m_tdfdfitExecutableNameValue.setText("tdfdfit executable name goes here!");

        m_changeTDFDFitExecutableNameButton.setText("Change");
        m_changeTDFDFitExecutableNameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitExecutableNameButtonActionPerformed(evt);
            }
        });

        m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel.setText("TDFDFit T1, T2 dBase path  :");

        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText("tdfdfit model path goes here!");

        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton.setText("Change");
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed(evt);
            }
        });

        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel.setText("TDFDFit normal metabolite concentration path  :");

        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText("tdfdfit normal metabolite values goes here");

        m_baselineSplineNodesModelPath.setText("Change");
        m_baselineSplineNodesModelPath.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_baselineSplineNodesModelPathActionPerformed(evt);
            }
        });

        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2.setText("Change");
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2ActionPerformed(evt);
            }
        });

        m_baselineNodesBaseDirectoryValue.setText("baseline spline node panel goes here!");

        m_baselineNodesBaseDirectoryLabel.setText("Baseline spline model root path :");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(m_tdfdfitLInstallationPathLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitInstallationPathValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(30, 30, 30)
                        .addComponent(m_changeTDFDFitInstallationPathButton1))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(m_patientDatabsePathLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_patientDatabasePathValue, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
                        .addGap(29, 29, 29)
                        .addComponent(m_changePatientDatabasePathButton))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(m_tfdfitProjectPathLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitModelsBasePathValue, javax.swing.GroupLayout.DEFAULT_SIZE, 428, Short.MAX_VALUE)
                        .addGap(29, 29, 29)
                        .addComponent(m_changeTDFDFitModelsBasePathButton))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(m_tdfdfitExecutableNameLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitExecutableNameValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(30, 30, 30)
                        .addComponent(m_changeTDFDFitExecutableNameButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValue, javax.swing.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
                        .addGap(29, 29, 29)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue, javax.swing.GroupLayout.DEFAULT_SIZE, 315, Short.MAX_VALUE)
                        .addGap(29, 29, 29)
                        .addComponent(m_baselineSplineNodesModelPath))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(m_baselineNodesBaseDirectoryLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_baselineNodesBaseDirectoryValue, javax.swing.GroupLayout.DEFAULT_SIZE, 437, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(31, 31, 31)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitLInstallationPathLabel)
                    .addComponent(m_tdfdfitInstallationPathValue)
                    .addComponent(m_changeTDFDFitInstallationPathButton1))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitExecutableNameLabel)
                    .addComponent(m_tdfdfitExecutableNameValue)
                    .addComponent(m_changeTDFDFitExecutableNameButton))
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_patientDatabsePathLabel)
                    .addComponent(m_patientDatabasePathValue)
                    .addComponent(m_changePatientDatabasePathButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tfdfitProjectPathLabel)
                    .addComponent(m_tdfdfitModelsBasePathValue)
                    .addComponent(m_changeTDFDFitModelsBasePathButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValue)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel)
                    .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue)
                    .addComponent(m_baselineSplineNodesModelPath))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_baselineNodesBaseDirectoryLabel)
                    .addComponent(m_baselineNodesBaseDirectoryValue)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2))
                .addContainerGap(53, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void m_changeTDFDFitInstallationPathButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitInstallationPathButton1ActionPerformed
        defineTDFDFitInstallationPath( );
    }//GEN-LAST:event_m_changeTDFDFitInstallationPathButton1ActionPerformed

    private void m_changePatientDatabasePathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changePatientDatabasePathButtonActionPerformed
       definePatientDatabaseRootPath( );
    }//GEN-LAST:event_m_changePatientDatabasePathButtonActionPerformed

    private void m_changeTDFDFitModelsBasePathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitModelsBasePathButtonActionPerformed
        defineTDFDModelsBasePath( );
    }//GEN-LAST:event_m_changeTDFDFitModelsBasePathButtonActionPerformed

    private void m_changeTDFDFitExecutableNameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitExecutableNameButtonActionPerformed
        defineTDFDFitExecutableName( );
    }//GEN-LAST:event_m_changeTDFDFitExecutableNameButtonActionPerformed

    private void m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed
        defineTDFDFitRelaxationTimesDatabaseFileReference( );
    }//GEN-LAST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed

    private void m_baselineSplineNodesModelPathActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_baselineSplineNodesModelPathActionPerformed
        defineBaselineSplineNodesModelPath( );
    }//GEN-LAST:event_m_baselineSplineNodesModelPathActionPerformed

    private void m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2ActionPerformed
    
    /**
     * Defines the path to the location in the file system where the metabolite
     * normal values are located.
     * @return 
     */
    private File defineTDFDFitNormalMetaboliteValueDatabasePath( )
    {

        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultNormalValueConcentrationsTimesDBaseString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH );
        
        File defaultNormalValueConcentrationDBaseFileRef = new File( defaultNormalValueConcentrationsTimesDBaseString );
        
        if ( defaultNormalValueConcentrationDBaseFileRef != null )
        {   
            defaultNormalValueConcentrationDBaseFileRef = new File( defaultNormalValueConcentrationsTimesDBaseString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultNormalValueConcentrationDBaseFileRef.exists( ) )
            {
                defaultNormalValueConcentrationsTimesDBaseString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultNormalValueConcentrationsTimesDBaseString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultNormalValueConcentrationsTimesDBaseString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitNormalConcentrationValueDatabaseSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the base path where the relaxation times are stored. 
     */
    private File defineBaselineSplineNodesModelPath( )
    {
        
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String baselineSplineModelPath = fdef.getProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH );
        
        File baselineSplineModelPathRef = new File( baselineSplineModelPath );
        
        if ( baselineSplineModelPathRef != null )
        {   
            baselineSplineModelPathRef = new File( baselineSplineModelPath );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !baselineSplineModelPathRef.exists( ) )
            {
                baselineSplineModelPath = System.getProperty( "user.home" );
            }
        }
        else
        {
            baselineSplineModelPath = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( baselineSplineModelPath );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitRelaxationTimeDataBaseFileReferenceSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the base path where the relaxation times are stored. 
     */
    private File defineTDFDFitRelaxationTimesDatabaseFileReference( )
    {
        
        MetaboliteRelaxationTimesDatabase relaxationTimesDbase = MetaboliteRelaxationTimesDatabase.getInstance( );
        
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultRelaxationTimesDBaseString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE );
        
        File defaultRelaxationTimesDBaseFileRef = new File( defaultRelaxationTimesDBaseString );
        
        if ( defaultRelaxationTimesDBaseFileRef != null )
        {   
            defaultRelaxationTimesDBaseFileRef = new File( defaultRelaxationTimesDBaseString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultRelaxationTimesDBaseFileRef.exists( ) )
            {
                
                defaultRelaxationTimesDBaseString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultRelaxationTimesDBaseString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultRelaxationTimesDBaseString );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE, selected_dir.getPath( ) );
                                                m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitRelaxationTimeDataBaseFileReferenceSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the base path where the TDFDFit models are stored. 
     */
    private File defineTDFDModelsBasePath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH );
        
        File defaultTDFDFitModelsPath;
        
        if ( defaultPathString != null )
        {   
            defaultTDFDFitModelsPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultTDFDFitModelsPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitModelsBasePathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitModelsBasePathDefined = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    
    /**
     * Defines the path where the TDFDFit executable is installed. 
     */
    private File defineTDFDFitInstallationPath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH );
        
        File defaultPatientDBRootPath;
        
        if ( defaultPathString != null )
        {   
            defaultPatientDBRootPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitInstallationPathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdftExcutableInstallationPathSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the name of the TDFDFit executable. 
     */
    private File defineTDFDFitExecutableName( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH );
        
        File defaultPatientDBRootPath;
        
        if ( defaultPathString != null )
        {   
            defaultPatientDBRootPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_file = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_file = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_EXECUTABLE_NAME, selected_file.getName( ) );
                                                m_tdfdfitExecutableNameValue.setText( selected_file.getPath( ) );
                                                def.save( );
                                                if ( selected_file != null )
                                                {
                                                    m_tdfdftExcutableNameSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_file;
    }
    
    
    
    /**
     * Defines the path in which the patient database is stored.
     */
    private File definePatientDatabaseRootPath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH );
        
        File defaultPatientDBRootPath;
        if ( defaultPathString != null )
        {
            defaultPatientDBRootPath= new File( defaultPathString );
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( "Patient database root path", selected_dir.getPath( ) );
                                                m_patientDatabasePathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_patientDBDirectorySet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel m_baselineNodesBaseDirectoryLabel;
    private javax.swing.JLabel m_baselineNodesBaseDirectoryValue;
    private javax.swing.JButton m_baselineSplineNodesModelPath;
    private javax.swing.JButton m_changePatientDatabasePathButton;
    private javax.swing.JButton m_changeTDFDFitExecutableNameButton;
    private javax.swing.JButton m_changeTDFDFitInstallationPathButton1;
    private javax.swing.JButton m_changeTDFDFitModelsBasePathButton;
    private javax.swing.JLabel m_patientDatabasePathValue;
    private javax.swing.JLabel m_patientDatabsePathLabel;
    private javax.swing.JLabel m_tdfdfitExecutableNameLabel;
    private javax.swing.JLabel m_tdfdfitExecutableNameValue;
    private javax.swing.JLabel m_tdfdfitInstallationPathValue;
    private javax.swing.JLabel m_tdfdfitLInstallationPathLabel;
    private javax.swing.JLabel m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue;
    private javax.swing.JLabel m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel;
    private javax.swing.JLabel m_tdfdfitModelsBasePathValue;
    private javax.swing.JButton m_tdfdfitRelaxationTimeDataBaseFileReferenceButton;
    private javax.swing.JButton m_tdfdfitRelaxationTimeDataBaseFileReferenceButton2;
    private javax.swing.JLabel m_tdfdfitRelaxationTimeDataBaseFileReferenceValue;
    private javax.swing.JLabel m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel;
    private javax.swing.JLabel m_tfdfitProjectPathLabel;
    // End of variables declaration//GEN-END:variables
}
