/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * AutoTwoCompartmentFittingInfomationPanel.java
 *
 * Created on 12-Jan-2011, 08:09:32
 */

package org.spectrim.tdfdfit.waterreferencemodelling;

import java.awt.Point;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;

/**
 * This class gives information on the applied two compartment model fitting
 * approach.
 * @author slotboom
 */
public class TwoCompartmentWaterReferenceModelFittingInfomationPanel extends javax.swing.JFrame {

    /** 
     * Creates new form AutoTwoCompartmentFittingInfomationPanel 
     * @param parent
     */
    public TwoCompartmentWaterReferenceModelFittingInfomationPanel( JFrame parent )
    {
        
        initComponents( );

        addWindowListener(
            new WindowAdapter( )
            {
            @Override
                public void windowClosing( WindowEvent event )
                {
                   dispose( );
                }
            }
        );
        
        // Put the Dialog nicely in the middle of its parent
        Point parentLoc = parent.getLocation( );
        Point centerParent = new Point( parent.getX( ) + ( parent.getWidth( ) / 2 ) - this.getWidth( ) / 2,
                                        parent.getY( ) + ( parent.getHeight( ) / 2 ) - this.getHeight( ) / 2 );

        setTitle( "About Two Compartment Fitting" );

        setLocation( centerParent );

        pack( );

        setVisible( true );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_InfoPanelScrollPane = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        m_OKButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        m_InfoPanelScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        m_InfoPanelScrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

        jTextArea1.setEditable(false);
        jTextArea1.setColumns(20);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setText("This control allows the fitting of a bi-exponential decay  \n\nModel(t) =  M * (  A1 * exp ( - TC1  *  t  ) + A2 * exp ( -TC2 *  t )  )  \n\nBy means of a Levenberg Marquardt fit or random fit algorithm. \nThe user has to select first the input water responses from the\nDICOM examination list. The user has to set the  initial starting values \nof A1, A2, TC1, and TC2. Note that A1 and A2 are amplitide factors, \nsince M is the maximum value of the measered signal.  \n\nIf A1 = 4.0 this means that the area factor is A1 * M ( with M is th first \n(maximum) value of the measured input array), so 4 times larger than \nthe beginning point of the measured data. Normally the value for t=0 \nis not know (mostly they are the minimum possible eco time, which is \n20ms for STEAM, and 30ms for PRESS on a Siemens scanner), \nso the values A1 and A2 factor can be larger than 1.0.\n \nAdditionally  the minimum and maximum values of A1, A2, TC1, and TC2 \nshould be given. These parameter ranges are used  in the random \nfitting algorithm only. The algorithm searches for the best fit on these \ngiven parameter ranges. Always verify after the fit whether the observed \nvalues are on the border of the allowed parameter range. If this is the case, \nthan fit again with enlarged parameter range.  \n\nThe displayed resulting values are true amplitudes for A1 and A2 and in \nmsec units for TC1 TC2.");
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setPreferredSize(new java.awt.Dimension(6134, 228));
        m_InfoPanelScrollPane.setViewportView(jTextArea1);

        m_OKButton.setText("OK");
        m_OKButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_OKButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(255, 255, 255)
                .addComponent(m_OKButton, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(284, Short.MAX_VALUE))
            .addComponent(m_InfoPanelScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 627, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(m_InfoPanelScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 576, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_OKButton)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_OKButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_OKButtonActionPerformed
       dispose( );
}//GEN-LAST:event_m_OKButtonActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new TwoCompartmentWaterReferenceModelFittingInfomationPanel( null ).setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JScrollPane m_InfoPanelScrollPane;
    private javax.swing.JButton m_OKButton;
    // End of variables declaration//GEN-END:variables

}
