/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.utilities;

import com.jmatio.io.MatFileReader;
import com.jmatio.io.MatFileWriter;
import com.jmatio.types.MLArray;
import com.jmatio.types.MLChar;
import com.jmatio.types.MLDouble;
import com.jmatio.types.MLNumericArray;
import com.jmatio.types.MLStructure;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author user
 */
public class MatlabIO {

    private ArrayList<MLArray> list = new ArrayList<>();

    public void addArrayToList(String name, float[] array) {
        double[] aux = new double[array.length];

        for (int i = 0; i < aux.length; i++) {
            aux[i] = array[i];
        }

        MLDouble mlDouble = new MLDouble(name, aux, array.length);

        //write array to file
        list.add(mlDouble);
    }

    public void addArrayToList(String name, double[][] array) {
        MLDouble mlDouble = new MLDouble(name, array);
        //write array to file
        list.add(mlDouble);
    }

    public void addArrayToList(String name, String[] array) {
        MLChar mlChar = new MLChar(name, array);
        //write array to file
        list.add(mlChar);
    }

    public void addArrayToList(String name, float[][] array) {
        double[][] aux = new double[array.length][array[0].length];
        for (int i = 0; i < array.length; i++) {
            for (int j = 0; j < array[0].length; j++) {
                aux[i][j] = array[i][j];
            }
        }
        MLDouble mlDouble = new MLDouble(name, aux);
        //write array to file
        list.add(mlDouble);
    }

    public void addArrayToList(String name, double[] array) {
        MLDouble mlDouble = new MLDouble(name, array, array.length);

        //write array to file
        list.add(mlDouble);
    }

    public void save(String folder) {
        try {
            //write arrays to file
            new MatFileWriter(folder, list);
            list.clear();
        } catch (IOException ex) {
            Logger.getLogger(MatlabIO.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static HashMap<String, MLArray> readMAT(String file) {
        MatFileReader reader = new MatFileReader();
        HashMap<String, MLArray> map;
        try {
            map = (HashMap<String, MLArray>) reader.read(new File(file));
            return map;
        } catch (IOException ex) {
            Logger.getLogger(MatlabIO.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }
    }
}
